﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
//
//  Class to express the avatar
//
//  Image of the player character
//  This is created on each station
//

#ifndef _AVATAR_H_
#define _AVATAR_H_

#include <NetZ/NetZ.h>
#include "AvatarDDL.h"

#define AVATAR_SIZE 10

class Avatar : public NAMESPACE_NEX DOCLASS(Avatar)
{
public:
    Avatar();
    Avatar(qReal x, qReal y);
    ~Avatar();

    void InitDO();

    void SetPosition(qReal x, qReal y);
    void MovePosition(qReal x, qReal y);

    void DoPhysic();
    void Render();

private:
    void UpdateMoveDir();
    void UpdateCollisionWithWorld();
    void UpdateCollisionWithWorldSub(qReal& x, qReal& y);

private:
    // Constant definitions
    enum
    {
        MOVE_TIME = 3000,                   // Move time (direction changes as time elapses)
        MOVE_POWER = 2,                     // Distance to move
        EXTRAPOLATION_DELAY_TIME = 500,     // Extrapolation delay time
        LOOPBACK_DELAY_TIME = 500,          // Loopback delay time setting
        SUBSTREAM_ID = 1                        // SubStream ID
    };

private:
    // Time
    nn::nex::Time mTime;
    // Distance to move
    qReal mMove[2];
};

#endif      // _AVATAR_H_
