/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
//
//  Class to express the position from the extrapolation filter and loopback
//

#ifndef _EXTRAPOLATEDLOOPBACKPOSITION_H_
#define _EXTRAPOLATEDLOOPBACKPOSITION_H_

#include <NetZ/NetZ.h>
#include "ExtrapolatedLoopbackPositionDDL.h"

// Position class attached to the extrapolation filter & loopback
class ExtrapolatedLoopbackPosition: public NAMESPACE_NEX DATASET(ExtrapolatedLoopbackPosition)
{
public:
    ExtrapolatedLoopbackPosition()
    {
        x = 0;
        y = 0;
    }

    // Move relatively
    void Move(qReal dx, qReal dy)
    {
        x += dx;
        y += dy;
    }

    // Move absolutely
    void Set(qReal dx, qReal dy)
    {
        x = dx;
        y = dy;
    }
};

#endif
