﻿/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _Avatar_H_
#define _Avatar_H_

#include <nex_P2p.h>
#include "AvatarDDL.h"

#include "SampleCommon.h"
#include "../common/Vector2D.h"

#define AVATAR_PLAYER_MAX 12
#define AVATAR_SIZE 10

class Avatar: public nn::nex:: DOCLASS(Avatar)
{
public:
    Avatar();
    virtual ~Avatar();

    void HandleError();
    virtual void InitDO();

    void DoPhysic();
    void Render();

    qBool MovePosition(qReal x, qReal y);
    qBool SetPosition(qReal x, qReal y);
    qBool GetExtrapolationPosition(qReal* x, qReal* y);

private:
    Vector2D m_vSpeed;
};

#endif
