﻿//The DeadReckoning.ddl file defines the title, the datasets and the
// doclasses of the application. 
#include <NetZ/NetZ.ddl>

title "DeadReckoning";

//The Position dataset defines a data type that holds 3 doubles which is associated
//to the Avatar doclass.  

dataset Position {
	float x;
	float y;
	float z;
};

dataset ExtrapolatedPosition {
	float x;
	float y;
	float z;
} extrapolation_filter, unreliable, update_perf_counter;

dataset ExtrapolatedLoopbackPosition {
	float x;
	float y;
	float z;
} extrapolation_filter, unreliable, loopback, update_perf_counter;

dataset AvatarInfo {
	byte playerId;
};

doclass Avatar {
	AvatarInfo m_dsInfo;
	Position m_dsPosition;
	ExtrapolatedPosition m_dsExtrapolatedPosition;
	ExtrapolatedLoopbackPosition m_dsExtrapolatedLoopbackPosition;
};

dataset Boundaries {
	float	minX;
	float	maxX;
	float	minY;
	float	maxY;
} constant;

dataset WorldInfo {
	byte extrapolationType;
};

doclass World {
	WorldInfo m_dsInfo;
	Boundaries m_dsBoundaries;
};

wellknown World g_hWorld;
