/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/



#ifndef SCENE_EXIT_NETZ_SESSION_H_
#define SCENE_EXIT_NETZ_SESSION_H_

#include "SceneBase.h"

#include <OnlineCore/src/Core/CallContext.h>

class SceneExitNetZSession : public SceneBase
{
public:
    static SceneBase* GetInstance(void);

    virtual ~SceneExitNetZSession(void);

    virtual void Initialize(void);
    virtual void Finalize(void);
    virtual SceneBase* Update(void);
    virtual void Render(void) const;

private:
    SceneExitNetZSession(void);   // Force use of GetInstance function.
    SceneExitNetZSession           (const SceneExitNetZSession&);
    SceneExitNetZSession& operator=(const SceneExitNetZSession&);

    // Is the NetZ Terminate function process executing?
    bool isTerminating(void) const;

    nn::nex::CallContext m_context;
};

#endif
