/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/



#ifndef SCENE_SELECT_NETZ_SESSION_H_
#define SCENE_SELECT_NETZ_SESSION_H_

#include "SceneBase.h"

#include <OnlineCore/src/Core/CallContext.h>

class SceneSelectNetZSession : public SceneBase
{
public:
    static SceneBase* GetInstance(void);

    virtual ~SceneSelectNetZSession(void);

    virtual void Initialize(void);
    virtual void Finalize(void);
    virtual SceneBase* Update(void);
    virtual void Render(void) const;

private:
    SceneSelectNetZSession(void);   // Force use of GetInstance function.
    SceneSelectNetZSession           (const SceneSelectNetZSession&);
    SceneSelectNetZSession& operator=(const SceneSelectNetZSession&);

    void updateQuery(void);

    nn::nex::qList<nn::nex::SessionDescription> m_sessionList;
    nn::nex::qList<nn::nex::SessionDescription> m_workingSessionList; // This is the one where Query overwrites directly.
    nn::nex::CallContext m_context;
};

#endif
