/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/


#ifndef GLOBALSTATUS_H_
#define GLOBALSTATUS_H_

#include <nn/types.h>


//
class GlobalStatus
{
public:
    GlobalStatus(void);
    ~GlobalStatus(void);

    bool m_bIsMasterMode;
    bool m_bSocketModeSelected;
    bool m_bMeasuring;

    s64  m_iJoinSuccessTime;
    u32  m_uiJoinCount;
    u8   m_uiNbLocalStations;
    u8   m_uiSessionRole;

    u32  m_uiUpdateCount;
    u32  m_uiProcessNexCount;
    s32  m_iTransportProcessCount;

    u32  m_uiMaxSilenceTime;
    u32  m_uiKeepAliveTimeout;

    bool m_bEnableMessageBundle;
    u16  m_uiMessageBundleFlushDelay;
    u16  m_uiMessageBundleFlushCheckPeriod;

    bool m_bEnablePacketBundle;
    u16  m_uiPacketBundleFlushDelay;

    u32  m_uiLocalComunicationId;

private:
    //
    GlobalStatus           (const GlobalStatus&);
    GlobalStatus& operator=(const GlobalStatus&);
};


extern GlobalStatus g_gsStatus;


#endif  // end of GLOBALSTATUS_H_
