﻿/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#include "../common/DemoFramework.h"

#include "../common/NetZManager.h"
#include "SceneSessionParticipant.h"

SceneBase* SceneSessionParticipant::GetInstance(void)
{
    static SceneSessionParticipant s_instance;
    return &s_instance;
}

SceneSessionParticipant::SceneSessionParticipant(void)
{
    SceneSessionGame::SetInstance((SceneSessionGame*)GetInstance());
    mSceneId = SCENE_ID_SESSION_PARTICIPANT;
}


SceneSessionParticipant::~SceneSessionParticipant(void)
{
}

void SceneSessionParticipant::Initialize(void)
{
    SceneSessionGame::Initialize();
    SceneSessionGame::SetInstance((SceneSessionGame*)GetInstance());
}

SceneSessionGame* SceneSessionParticipant::GetSceneSessionGameInstance()
{
    return static_cast<SceneSessionGame*>(SceneSessionParticipant::GetInstance());
}

SceneBase* SceneSessionParticipant::Update(void)
{
    return SceneSessionGame::Update();
}


void SceneSessionParticipant::Render(void) const
{
    RenderInfo("<SceneSessionParticipant>");
    SceneSessionGame::Render();

    u16 y = DRAW_POSITION_OPERATION_Y;
    DemoFramework::GetInstance()->DrawText(DRAW_POSITION_OPERATION_X, y, "B: exit session");
    y += DRAW_FONT_HEIGHT;
}
