﻿/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/


#ifndef CONFIG_H_
#define CONFIG_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <NetZ/src/Core/DOCore/NetworkTopology.h>

#include <nn/types.h>


//
//
//

struct SampleConfig
{
    SampleConfig(void);
    ~SampleConfig(void);

    // Thread mode.
    int threadMode;

    bool useUserDO;

    // Stream related?
    nn::nex::qUnsignedInt32 maxSilenceTime;
    nn::nex::qUnsignedInt32 keepAliveTimeout;
    nn::nex::qUnsignedInt32 maxWindowMapSize;

    // Network topology related.
    enum nn::nex::NetworkTopology::_NetworkTopology networkTopology;
    bool testRouting;

    // Message bundle related
    bool enableMessageBundle;
    u16  messageBundleFlushDelay;
    u16  messageBundleFlushCheckPeriod;

    // Packet bundle related
    bool enablePacketBundle;
    u16  packetBundleFlushDelay;

    // JobTerminationFailed-related. Timeout length for terminate processing. Units in milliseconds.
    nn::nex::qUnsignedInt32 terminationDOCoreTimeout;
};


#endif  // end of CONFIG_H_
