/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef DEMO_FRAMEWORK_H_
#define DEMO_FRAMEWORK_H_

#include <OnlineCore/src/Platform/Core/Recognition.h>

// Gets the smaller value.
template <class T>
T min(T a, T b)
{
    return a < b ? a : b;
}


// Gets the greater value.
template <class T>
T max(T a, T b)
{
    return a > b ? a : b;
}

#if defined(CTR_TARGET)
#include "CTR/DemoFramework.h"
using CTR::DemoFramework;
using CTR::DEMO_BUTTON_A;
using CTR::DEMO_BUTTON_B;
using CTR::DEMO_BUTTON_X;
using CTR::DEMO_BUTTON_Y;
using CTR::DEMO_BUTTON_L;
using CTR::DEMO_BUTTON_R;
using CTR::DEMO_BUTTON_UP;
using CTR::DEMO_BUTTON_DOWN;
using CTR::DEMO_BUTTON_LEFT;
using CTR::DEMO_BUTTON_RIGHT;
#elif defined(CAFE_TARGET)
#include "Cafe/DemoFramework.h"
using Cafe::DemoFramework;
using Cafe::DEMO_BUTTON_A;
using Cafe::DEMO_BUTTON_B;
using Cafe::DEMO_BUTTON_X;
using Cafe::DEMO_BUTTON_Y;
using Cafe::DEMO_BUTTON_L;
using Cafe::DEMO_BUTTON_R;
using Cafe::DEMO_BUTTON_UP;
using Cafe::DEMO_BUTTON_DOWN;
using Cafe::DEMO_BUTTON_LEFT;
using Cafe::DEMO_BUTTON_RIGHT;
#else /* !CTR_TARGET && !CAFE_TARGET */
#error "This platform is not supported."
#endif /* !CTR_TARGET && !CAFE_TARGET */

#endif  // end of DEMO_FRAMEWORK_H_

