﻿/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _MathUtil_H_
#define _MathUtil_H_

#include <math.h>

#include <OnlineCore/src/Platform/Core/GlobalVariables.h>
#include <nex_P2p.h>

#include <OnlineCore/src/Platform/Core/Type.h>
typedef float qReal;
#define QREAL(_num) (_num##f)

// Computes the direction of the vector <x,y>
qReal Direction(qReal x,qReal y);

// Computes the length of the vector <x,y>
qReal Length(qReal x,qReal y);

qReal Abs(qReal x);
qReal Max(qReal i, qReal j);
qReal Max(qReal i, qReal j, qReal k);

#define PI QREAL(3.14159265358979323846)

#endif
