/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NEXDEMO_GRAPHICS_H_
#define NEXDEMO_GRAPHICS_H_

#include <demo.h>

// Use similarly to RenderSystem::SetColor(NEXDEMO_RGB(r, g, b))
#define NEXDEMO_RGB(r, g, b) (f32)(r) / 255.0f, (f32)(g) / 255.0f, (f32)(b) / 255.0f

namespace nexdemo
{
namespace Graphics
{
// Performs initialization.
void Initialize(size_t heapSize = 0x800000);
// Performs shutdown.
void Finalize();

// Get the renderer.
demo::RenderSystemDrawing* GetRenderSystem();
}
}

#endif // NEXDEMO_GRAPHICS_H_
