﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
#ifndef _NEXUTILNETZ_H_
#define _NEXUTILNETZ_H_

#include <nex.h>
#include "NexUtil.h"

#if defined(CTR_TARGET)
#include <nn.h>
#include <nn/friends.h>
#elif defined(CAFE_TARGET)
#include <cafe.h>
#include <nn/act.h>
#include <nn/fp.h>
#endif

NEXUTIL_BEGIN
//-----------------------------------------------------------------------------------------
// Name        : SetupLocalPlayerName
//
// Description:
//      Sets the name that apears in P2P station.
//
// Arguments   :
//      None
//
// Returns     :
//      None
//
//-----------------------------------------------------------------------------------------
void SetupLocalPlayerName()
{
#if defined(CAFE_TARGET)
    //Use the account ID.
    char accountId[ACT_ACCOUNT_ID_SIZE];
    nn::Result result = nn::act::GetAccountId(accountId);

    if(result.IsSuccess())
    {
        // Set the language used by the application.
        nn::nex::Station::SetLocalPlayerName(accountId, nn::fp::LANGUAGE_JAPANESE);
    }
    else
    {
        nn::nex::Station::SetLocalPlayerName(_T("DummyName"), nn::fp::LANGUAGE_JAPANESE);
    }
#elif defined(CTR_TARGET)
    //Use the name of the Mii character.
    char16 screenName[nn::friends::SCREEN_NAME_SIZE];
    nn::Result result = nn::friends::GetMyScreenName(screenName);
    if(result.IsSuccess() && screenName[0] != 0) // Also exclude cases where a Mii character is not set.
    {
        nn::nex::Station::SetLocalPlayerName(screenName, 0);
    }
    else
    {
        nn::nex::Station::SetLocalPlayerName(_T("DummyName"), 0);
    }
#else
    nn::nex::Station::SetLocalPlayerName(_T("DummyName"), 0);
#endif
}

NEXUTIL_END   // end of namespace nex_util

#endif  // end of _NEXUTILNETZ_H_
