﻿{
  shownetz = false;

  //Generate a table of contents in the callbacks to support JSONP.
  var callbackShowNetzFlag = function(){

  var objTOC = new TocObject();
  // Document title.
  objTOC.setTitle("CTR-NEX");
  // Link to document title.
  objTOC.setTitleFile("title.html");
  // Specify true to expand the table of contents on launch. If not specified, the value is false.
  objTOC.setOpenWithExpand(true);
  // To auto-number the chapters.
  objTOC.enableDisplayNumber();
  // To not display icons for lists that do not expand and collapse.
  objTOC.disableViewFileIcon();

  // Manual table of contents.
  // Use the second level as the base.
  objTOC.setBaselevel(1);
  objTOC.addSectionHeader(         "GENERAL"         , 0, "General Features", "", "");
  objTOC.addSection(  "GENERAL_FIRST_OF_ALL", 1, "Introduction" , "nex/commonmanual/first_of_all.html", "");
  objTOC.addSection(        "GENERAL_INIT_FIN", 1, "NEX Initialization and Shutdown"         , "nex/commonmanual/init_final.html", "");
  objTOC.addSection(        "GENERAL_MEMORY", 1, "Memory Management"         , "nex/commonmanual/memory.html", "");
  objTOC.addSection(        "GENERAL_INITIALIZE", 1, "Initialization Settings (Thread Models, Exclusive Control, and Local Communication)"         , "nex/commonmanual/initialize_detail.html", "");
  objTOC.addSection(        "GENERAL_OVERALL", 1, "NEX Library (General) (Basic Types, Dispatching, Asynchronous Processing, Data Integrity)" , "nex/commonmanual/overall.html", "");
  objTOC.addSection(        "GENERAL_POLLING_ITEM", 1, "Items to Check Every Frame" , "nex/commonmanual/polling_item.html", "");
  
  if (shownetz) {
  objTOC.addSectionHeader(         "P2P"         , 0, "P2P and Communication Features", "", "");
  objTOC.addSection(  "P2P_FIRST_OF_ALL", 1, "Introduction" , "nex/p2p/first_of_all.html", "");
  objTOC.addSection(        "P2P_OVERVIEW", 1, "NetZ Overview" , "nex/p2p/overview.html", "");
  objTOC.addSection(        "P2P_NETZ_TERMINATE", 1, "NetZ Initialization and Finalization", "nex/p2p/netz_terminate.html", "");
  objTOC.addSection(        "P2P_ERROR", 1, "Error Handling", "nex/p2p/error.html", "");
  objTOC.addSection(        "P2P_SESSION", 1, "Sessions and Stations", "nex/p2p/session.html", "");
  objTOC.addSection(        "P2P_CLOCK", 1, "Time Management", "nex/p2p/clock_management.html", "");
  objTOC.addSection(        "P2P_DIRECT_STREAM", 1, "Direct Streaming", "nex/p2p/direct_stream.html", "");
  objTOC.addSection(        "P2P_STATIONINCONSITENCY", 1, "Detection of Station Inconsistency", "nex/p2p/station_inconsistency.html", "");
  objTOC.addSection(        "P2P_SEQURITY", 1, "Security", "nex/p2p/security.html", "");
  objTOC.addSection(        "P2P_DO_BRIEF", 1, "Duplicated Object Features Overview", "nex/p2p/do_brief.html", "");
  objTOC.addSection(        "P2P_DO_BASIC", 1, "Basic Duplicated Object Features", "nex/p2p/do_basic.html", "");
  objTOC.addSection(        "P2P_DEAD_RECKONING", 1, "Dead Reckoning", "nex/p2p/dead_reckoning.html", "");
  objTOC.addSection(        "P2P_DO_EXT", 1, "Extended Duplicated Object Features", "nex/p2p/do_ext.html", "");
  objTOC.addSection(        "P2P_DO_DDL", 1, "The Data Definition Language (DDL) for Duplicated Objects", "nex/p2p/do_ddl.html", "");
  objTOC.addSection(        "P2P_DDL_GRAMMER", 1, "DDL Grammar", "nex/p2p/ddl_grammer.html", "");
  objTOC.addSection(        "P2P_DO_KNOW_HOW", 1, "Effectively Using Duplicated Objects", "nex/p2p/do_know_how.html", "");
  objTOC.addSection(        "P2P_CONSTRUCTION", 1, "Useful Features and Reference Information", "nex/p2p/construction.html", "");
  objTOC.addSection(        "P2P_WORDS", 1, "Glossary", "nex/p2p/words.html", "");
  objTOC.addSection(        "P2P_VSOCKET", 1, "Addendum: VSocket", "nex/p2p/vsocket.html", "");
  }
  objTOC.addSectionHeader(         "SERVER"         , 0, "Server Services", "", "");
  objTOC.addSection(  "SERVER_FIRST_OF_ALL", 1, "Introduction"     , "nex/serverservice/first_of_all.html", "");
  objTOC.addSection(        "SERVER_USER", 1, "User Management"     , "nex/serverservice/user_account_management.html", "");
  objTOC.addSection(        "SERVER_LOGIN", 1, "Connection Management"     , "nex/serverservice/login_logout.html", "");
  objTOC.addSection(        "SERVER_MATCHMAKE", 1, "Matchmaking"     , "nex/serverservice/matchmake.html", "");
  objTOC.addSection(        "SERVER_RANKING", 1, "Ranking"     , "nex/serverservice/ranking.html", "");
  objTOC.addSection(        "SERVER_DATASTORE", 1, "Data Stores"     , "nex/serverservice/datastore.html", "");
  objTOC.addSection(        "SERVER_SUBSCRIBER", 1, "Subscriber"     , "nex/serverservice/subscriber.html", "");
  objTOC.addSection(        "SERVER_P2P", 1, "P2P Communication"     , "nex/serverservice/p2p.html", "");
  objTOC.addSection(        "SERVER_INDEPENDENT", 1, "Independent Server"     , "nex/serverservice/independent_server.html", "");
  objTOC.addSection(        "SERVER_DEBUG", 1, "Debug Assistance"     , "nex/serverservice/debug.html", "");
  objTOC.addSection(        "SERVER_OVERALL", 1, "The NEX Unique ID"     , "nex/serverservice/overall.html", "");
  objTOC.addSection(        "SERVER_WEBAPI" , 1, "WebAPI"  , "nex/serverservice/webapi.html", "");
  objTOC.addSection(        "SERVER_WEBAPI_COMMON" , 2, "Use web API."  , "nex/serverservice/webapi_common.html", "");
  objTOC.addSection(        "SERVER_WEBAPI_MATCHMAKE" , 2, "Matchmaking"  , "nex/serverservice/webapi_matchmake.html", "");
  objTOC.addSection(        "SERVER_WEBAPI_DATASTORE" , 2, "Data Stores"  , "nex/serverservice/webapi_datastore.html", "");
  objTOC.addSection(        "SERVER_WORDS", 1, "Terminology"     , "nex/serverservice/words.html", "");

  objTOC.addSectionHeader(  "NEX_API" , 0, "API Reference"  , "nex/api/index.html", "");

  objTOC.addSectionHeader(  "SAMPLE_DEMOS", 0, "Sample Demos", "nex/sampledemos/demolist.html", "");
/*
objTOC.addSection(  "SAMPLE_AUTO_MATCH",            1, "AutoMatch",           "nex/sampledemos/AutoMatch.html", "");
objTOC.addSection(  "SAMPLE_BLACK_LIST",            1, "BlackList",           "nex/sampledemos/BlackList.html", ""); // [/target:CTR]
objTOC.addSection(  "SAMPLE_CALL_CONTEXT",          1, "CallContext",         "nex/sampledemos/CallContext.html", "");
objTOC.addSection(  "SAMPLE_CREATE_AND_BROWSE",     1, "CreateAndBrowse",     "nex/sampledemos/CreateAndBrowse.html", "");
objTOC.addSection(  "SAMPLE_DATA_STORE",            1, "DataStore",           "nex/sampledemos/DataStore.html", "");
objTOC.addSection(  "SAMPLE_DATA_STORE_API_CHAIN",  1, "DataStoreApiChain",   "nex/sampledemos/DataStoreApiChain.html", "");
objTOC.addSection(  "SAMPLE_DATA_STORE_SIMPLE",     1, "DataStoreSimple",     "nex/sampledemos/DataStoreSimple.html", "");
objTOC.addSection(  "SAMPLE_DDL_BASIC",             1, "DDLBasic",            "nex/sampledemos/DDLBasic.html", "");
objTOC.addSection(  "SAMPLE_DEBUG",                 1, "Debug",               "nex/sampledemos/Debug.html", "");
objTOC.addSection(  "SAMPLE_INDEPENDENT_SERVER",    1, "IndependentServer",   "nex/sampledemos/IndependentServer.html", ""); // [/target:CTR]
objTOC.addSection(  "SAMPLE_DEAD_RECKONING",        1, "DeadReckoning",       "nex/sampledemos/DeadReckoning.html", ""); // [/target:CTR]
objTOC.addSection(  "SAMPLE_DIRECT_STREAM",         1, "DirectStream",        "nex/sampledemos/DirectStream.html", ""); // [/target:CTR]
objTOC.addSection(  "SAMPLE_JOIN_FROM_FRIEND_LIST", 1, "JoinFromFriendList",  "nex/sampledemos/JoinFromFriendList.html", ""); // [/target:CTR]
objTOC.addSection(  "SAMPLE_MATCH_MAKING_REFEREE",  1, "MatchmakeReferee",    "nex/sampledemos/MatchmakeReferee.html", "");
objTOC.addSection(  "SAMPLE_MESSAGING",             1, "Messaging",           "nex/sampledemos/Messaging.html", "");
objTOC.addSection(  "SAMPLE_MULTI_UNIT_HEAP",       1, "MultiUnitHeap",       "nex/sampledemos/MultiUnitHeap.html", ""); // [/target:CTR]
objTOC.addSection(  "SAMPLE_NOTIFICATION",          1, "Notification",        "nex/sampledemos/Notification.html", "");
objTOC.addSection(  "SAMPLE_PERSISTENT_GATHERING",  1, "PersistentGathering", "nex/sampledemos/PersistentGathering.html", "");
objTOC.addSection(  "SAMPLE_RANKING",               1, "Ranking",             "nex/sampledemos/Ranking.html", "");
objTOC.addSection(  "SAMPLE_SHUTDOWN",              1, "Shutdown",            "nex/sampledemos/Shutdown.html", "");
*/
  // Reset the numbering base.
  objTOC.setBaselevel(0);
  // Revision History
  objTOC.addSeparator();
  objTOC.addItem("History", 0, "Revision History", "history.html", "");

  // Process tree data.
  objTOC.processTreeData();
  Reassemble.objectTocData = objTOC;

  }; //end of callbackShowNetzFlag
  
  //Get the path for tocData.js.
  var scripts = document.getElementsByTagName("script");
  var src = scripts[scripts.length - 1].src;
  var root = src.slice(0, src.lastIndexOf("/") + 1);
  
  //Work around the problem of being unable to load local files with Chrome.
  if(jQuery.browser.webkit){
    var script = $("<script>").prop({
      src : root + "shownetzflag.js"
    })
    script.error(function(ev) {
      callbackShowNetzFlag();
    });
    //An error occurs in IE with the following method if shownetzflag.js is not present.
    document.getElementsByTagName("head")[0].appendChild(script[0]);
  } else {
    $.ajax({
      type: 'GET',
      url: root + 'shownetzflag.js',
      dataType: 'jsonp',
      async: false,
      success: function(json){
      },
      error:function(){
        callbackShowNetzFlag();
      }
    });
  }

}

