﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _ProcessAuthentication_H_
#define _ProcessAuthentication_H_

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <OnlineCore/src/Platform/Core/String.h>
BEGIN_NAMESPACE_NEX
class Message;

// TODO.  It isn't clear what will happen with this class, and what is
// its relation with the new authentication service.

class ProcessAuthentication: public RootObject
{
    // Group=
public:

    ProcessAuthentication();
    virtual ~ProcessAuthentication();

    void AddSourceTo(Message *pMessage);
    void ExtractFrom(Message *pMessage, qBool bReturnString, String *pStrTrace);

    qBool Authenticate(const ProcessAuthentication& oAuthentication);

    void Trace(qUnsignedInt64 uiTraceFlags);

    static void SetTitle(const qChar* strTitle);
    static const qChar* GetTitle();

    static void SetUsingDupSpaces(qBool bFlag);
    static qBool IsUsingDupSpaces();

    void ComputeTitleChecksum();
    static qUnsignedInt32 ComputeTitleChecksum(const qChar* szTitle);

    void SkipLibraryAuthentication();

    void SetVersionInfo(qUnsignedInt32 uiVersion, qUnsignedInt32 uiBuild);
    void SetProtocolFlags(qUnsignedInt32 uiFlags)
    {
        m_uiProtocolFlags=uiFlags;
    }

    qUnsignedInt32 GetProtocolFlags() const
    {
        return m_uiProtocolFlags;
    }

    qBool TransmitParseTree() const;

    qUnsignedInt32 GetTitleChecksum() const
    {
        return m_uiTitleChecksum;
    }

#ifdef TEST_ENABLED
    static qBool Test();
#endif

protected:
    qByte m_byProtocolVersion;
    qByte m_byVersionInfo;
    qUnsignedInt32 m_uiVersion;
    qUnsignedInt32 m_uiBuild;

private:
    // NetZ info...
    qByte m_byStructureVersion;
    qUnsignedInt32 m_uiProtocolFlags;

    // NetZ managed game info
    qUnsignedInt32 m_uiTitleChecksum;

    qUnsignedInt32 m_uiAuthenticationContext;

    static const qChar* s_strTitle;
    static qBool s_bIsUsingDupSpaces;

    qBool m_bDoLibraryAuthentication;
};


END_NAMESPACE_NEX

#endif
