#ifndef _Quazal_ConnectionInfoDDL_H_
#define _Quazal_ConnectionInfoDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include <NetZ/src/Core/DOCore/CodeGenerationExports.h>
#include <OnlineCore/src/DDLTypes/OnlineCoreDDF.h>
#include <NetZ/src/Core/DOCore/DOClassesTable.h>
#include <NetZ/src/Core/DOCore/CodeGenerationExports.h>
#include <OnlineCore/src/DDLTypes/OnlineCoreDDF.h>
#include <NetZ/src/Core/DOCore/DOClassesTable.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
BEGIN_NAMESPACE_NEX
class OSDK_API DATASET(ConnectionInfo): public DataSet {
public:
	DDLTYPE(byte)::CPPType _mRevision;

/* ************** Begin the dataset definitions ************** */
	/* --- You can access these values directly. --- */

	//define string m_strStationURL1
	DDLTYPE(string)::CPPType m_strStationURL1;

	//define string m_strStationURL2
	DDLTYPE(string)::CPPType m_strStationURL2;

	//define string m_strStationURL3
	DDLTYPE(string)::CPPType m_strStationURL3;

	//define string m_strStationURL4
	DDLTYPE(string)::CPPType m_strStationURL4;

	//define string m_strStationURL5
	DDLTYPE(string)::CPPType m_strStationURL5;

	//define uint32 m_uiInputBandwidth
	DDLTYPE(uint32)::CPPType m_uiInputBandwidth;

	//define uint32 m_uiOutputBandwidth
	DDLTYPE(uint32)::CPPType m_uiOutputBandwidth;

	//define uint32 m_uiInputLatency
	DDLTYPE(uint32)::CPPType m_uiInputLatency;

	//define uint32 m_uiOutputLatency
	DDLTYPE(uint32)::CPPType m_uiOutputLatency;

	//define bool m_bURLInitialized
	DDLTYPE(bool)::CPPType m_bURLInitialized;

/* ************** End the dataset definitions ************** */

	qUnsignedInt32 GetRevision() { return _mRevision; }

	void InitVariables() {
		_mRevision=0;
	}

	_DS_GENERAL_DECLARATIONS(ConnectionInfo)
	DATASET(ConnectionInfo)( const DATASET(ConnectionInfo) &oOther ):DataSet() ,
		_mRevision(oOther._mRevision), 
		m_strStationURL1(oOther.m_strStationURL1), 
		m_strStationURL2(oOther.m_strStationURL2), 
		m_strStationURL3(oOther.m_strStationURL3), 
		m_strStationURL4(oOther.m_strStationURL4), 
		m_strStationURL5(oOther.m_strStationURL5), 
		m_uiInputBandwidth(oOther.m_uiInputBandwidth), 
		m_uiOutputBandwidth(oOther.m_uiOutputBandwidth), 
		m_uiInputLatency(oOther.m_uiInputLatency), 
		m_uiOutputLatency(oOther.m_uiOutputLatency), 
		m_bURLInitialized(oOther.m_bURLInitialized)
	{
	}

	_DS_ASSIGN_OPERATOR(ConnectionInfo){
		_DS_COPYDATASET_VAR(_mRevision);
		_DS_COPYDATASET_VAR(m_strStationURL1);
		_DS_COPYDATASET_VAR(m_strStationURL2);
		_DS_COPYDATASET_VAR(m_strStationURL3);
		_DS_COPYDATASET_VAR(m_strStationURL4);
		_DS_COPYDATASET_VAR(m_strStationURL5);
		_DS_COPYDATASET_VAR(m_uiInputBandwidth);
		_DS_COPYDATASET_VAR(m_uiOutputBandwidth);
		_DS_COPYDATASET_VAR(m_uiInputLatency);
		_DS_COPYDATASET_VAR(m_uiOutputLatency);
		_DS_COPYDATASET_VAR(m_bURLInitialized);
	}

	_DS_EQUAL_OPERATOR(ConnectionInfo){
		_DS_EQUAL_VAR(_mRevision);
		_DS_EQUAL_VAR(m_strStationURL1);
		_DS_EQUAL_VAR(m_strStationURL2);
		_DS_EQUAL_VAR(m_strStationURL3);
		_DS_EQUAL_VAR(m_strStationURL4);
		_DS_EQUAL_VAR(m_strStationURL5);
		_DS_EQUAL_VAR(m_uiInputBandwidth);
		_DS_EQUAL_VAR(m_uiOutputBandwidth);
		_DS_EQUAL_VAR(m_uiInputLatency);
		_DS_EQUAL_VAR(m_uiOutputLatency);
		_DS_EQUAL_VAR(m_bURLInitialized);
		return true;
	}

	_DS_TMPL_EQUAL_OPERATOR(ConnectionInfo)
	void ExtractFrom(Message* pMsg) {
		_MSG_EXTRACT_VARIABLE(T_mRevision, _mRevision);
		_MSG_EXTRACT_VARIABLE(Tm_strStationURL1,m_strStationURL1);
		_MSG_EXTRACT_VARIABLE(Tm_strStationURL2,m_strStationURL2);
		_MSG_EXTRACT_VARIABLE(Tm_strStationURL3,m_strStationURL3);
		_MSG_EXTRACT_VARIABLE(Tm_strStationURL4,m_strStationURL4);
		_MSG_EXTRACT_VARIABLE(Tm_strStationURL5,m_strStationURL5);
		_MSG_EXTRACT_VARIABLE(Tm_uiInputBandwidth,m_uiInputBandwidth);
		_MSG_EXTRACT_VARIABLE(Tm_uiOutputBandwidth,m_uiOutputBandwidth);
		_MSG_EXTRACT_VARIABLE(Tm_uiInputLatency,m_uiInputLatency);
		_MSG_EXTRACT_VARIABLE(Tm_uiOutputLatency,m_uiOutputLatency);
		_MSG_EXTRACT_VARIABLE(Tm_bURLInitialized,m_bURLInitialized);
	}



	DATASET_VALID_REVISION_DEF(m_strStationURL1, 0);
	qBool DATASET_ISVALID(m_strStationURL1){ return true; /* The revision is 0. Always true */}
	DATASET_VALID_REVISION_DEF(m_strStationURL2, 0);
	qBool DATASET_ISVALID(m_strStationURL2){ return true; /* The revision is 0. Always true */}
	DATASET_VALID_REVISION_DEF(m_strStationURL3, 0);
	qBool DATASET_ISVALID(m_strStationURL3){ return true; /* The revision is 0. Always true */}
	DATASET_VALID_REVISION_DEF(m_strStationURL4, 0);
	qBool DATASET_ISVALID(m_strStationURL4){ return true; /* The revision is 0. Always true */}
	DATASET_VALID_REVISION_DEF(m_strStationURL5, 0);
	qBool DATASET_ISVALID(m_strStationURL5){ return true; /* The revision is 0. Always true */}
	DATASET_VALID_REVISION_DEF(m_uiInputBandwidth, 0);
	qBool DATASET_ISVALID(m_uiInputBandwidth){ return true; /* The revision is 0. Always true */}
	DATASET_VALID_REVISION_DEF(m_uiOutputBandwidth, 0);
	qBool DATASET_ISVALID(m_uiOutputBandwidth){ return true; /* The revision is 0. Always true */}
	DATASET_VALID_REVISION_DEF(m_uiInputLatency, 0);
	qBool DATASET_ISVALID(m_uiInputLatency){ return true; /* The revision is 0. Always true */}
	DATASET_VALID_REVISION_DEF(m_uiOutputLatency, 0);
	qBool DATASET_ISVALID(m_uiOutputLatency){ return true; /* The revision is 0. Always true */}
	DATASET_VALID_REVISION_DEF(m_bURLInitialized, 0);
	qBool DATASET_ISVALID(m_bURLInitialized){ return true; /* The revision is 0. Always true */}

protected:
private:
	typedef DDLTYPE(byte) T_mRevision;
	typedef DDLTYPE(string) Tm_strStationURL1;
	typedef DDLTYPE(string) Tm_strStationURL2;
	typedef DDLTYPE(string) Tm_strStationURL3;
	typedef DDLTYPE(string) Tm_strStationURL4;
	typedef DDLTYPE(string) Tm_strStationURL5;
	typedef DDLTYPE(uint32) Tm_uiInputBandwidth;
	typedef DDLTYPE(uint32) Tm_uiOutputBandwidth;
	typedef DDLTYPE(uint32) Tm_uiInputLatency;
	typedef DDLTYPE(uint32) Tm_uiOutputLatency;
	typedef DDLTYPE(bool) Tm_bURLInitialized;
};

#define _DSDECL_ConnectionInfo ConnectionInfo

END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_ConnectionInfoDDL.h_H_
