/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DORoles_H_
#define _DORoles_H_

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>

BEGIN_NAMESPACE_NEX

//Group=Miscellaneous Types and Macros

// Description: This enumerates the Role that a duplicated object may have.
/* Please see man pages for details 
 
 */
enum Role
{
    /*
    A Duplication master is the controlling instance of a duplicated object.
    The Duplication master can update the values of
    its datasets, an operation that a Duplica cannot perform.
    See Also: Duplication master, ChangeMasterStationOperation
    */
    /* Please see man pages for details 
     
     
     */
    DUPLICATION_MASTER = 0,

    /*
    A Duplica is a copy of a duplicated object. Its datasets are updated remotely, automatically,
    and transparently by $PRODUCTNAME$ whenever its Duplication master performs an update.
    See Also: Duplica, ChangeMasterStationOperation
    */
    /* Please see man pages for details 
     
     
     
     */
    DUPLICA = 1,

    // This value is returned when the role of a duplicated object is not yet defined.
    /* Please see man pages for details 
     
     */
    ROLE_NOT_DEFINED = 2
};

END_NAMESPACE_NEX

#endif
