﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _Migration_H_
#define _Migration_H_

BEGIN_NAMESPACE_NEX

#define FORCED_MIGRATION                    1<<16

// Group = Miscellaneous Types and Macros

/*
Summary: Emigration of a duplicated object is requested since a process
is leaving the session.
Remarks: When a process leaves, the DuplicatedObject::ApproveEmigration system
callback is called with this reason to determine if the duplicated object for
which the process is Duplication master should emigrate to another station.
See also: DuplicatedObject::ApproveEmigration
*/
#define MIGRATION_REASON_LEAVING_SESSION        0

//{secret}
#define MIGRATION_REASON_LEAVING_GAME       MIGRATION_REASON_LEAVING_SESSION

//{secret}
#define MIGRATION_REASON_LEAVING_CLUSTER    0

/*
$ifdef NETZ$
{secret}
$endif$

$ifdef ETERNA$
Summary: Emigration of a duplicated object is requested to perform load balancing.
Remarks: When Load balancing is called the DuplicatedObject::ApproveEmigration system
callback is called with this reason to determine if the duplicated object should emigrate
to another station.
See also: DuplicatedObject::ApproveEmigration, Object Migration Overview
$endif$
*/
#define MIGRATION_REASON_LOAD_BALANCING     1
#define MIGRATION_REASON_TWO_MASTERS        (2 | FORCED_MIGRATION)
#define MIGRATION_REASON_USER_REQUEST       3

#define MIGRATE_TO_ANY_LOCATION             INVALID_DOHANDLE

END_NAMESPACE_NEX

#endif

