﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _NetworkTopology_H_
#define _NetworkTopology_H_

//n1769:memo
// The documentation generation tool did not work properly because this FOR_DOC_PURPOSE macro was defined.
// We thus forcibly turn it off in this header alone (if it had been defined, it is re-defined at the end of this file).
#ifdef FOR_DOC_PURPOSE
#define FOR_DOC_PURPOSE_WAS_DEFINED    FOR_DOC_PURPOSE
#undef FOR_DOC_PURPOSE
#endif

BEGIN_NAMESPACE_NEX

#ifndef FOR_DOC_PURPOSE

// group=Miscellaneous Types and Macros

/*
    Description: Enumerates all possible networking topologies that a session may establish.
    Remarks: Enumerates the networking topologies that a session may establish (Peer2Peer or
    ClientServer).
*/
/* Please see man pages for details 
  
  */
namespace NetworkTopology
{
#endif

/* Please see man pages for details 
  
  */
enum _NetworkTopology
{

    //  Description: The Default Net-Z topology where direct connections are
    //  established between every pair of stations. With this topology,
    //  messages are always sent directly from one station to another.
    /* Please see man pages for details 
      
      
      
      
      */
    Peer2Peer,

    //  Description: A network topology where connections are established
    //  from each station in the session to a central one (the session master).
    //  Communications between the session master and any other station
    //  are direct while communications between any two non
    //  session master stations are routed through the session master.
    /* Please see man pages for details 
      
      
      
      
      */
    ClientServer,

    //n1589: memo: This mode is for using the router, only if connecting directly failed
    /* Please see man pages for details 
      
      
      
      
      
      */
    Hybrid,

    // {secret}
    // Description: A network topology that uses an external process (that is, not part
    // of the current Net-Z session) to route packets between Net-Z stations.
    /* Please see man pages for details 
      
      
      
      
      */
    ExternalRouter
};

// Description: Used with NetZ::SetNetworkTopology to define the NetworkTopology that
// a Net-Z instance may establish.
/* Please see man pages for details 
  
  
  */
typedef enum _NetworkTopology Mode;

#ifndef FOR_DOC_PURPOSE
}
#endif

END_NAMESPACE_NEX

#ifdef FOR_DOC_PURPOSE_WAS_DEFINED
#define FOR_DOC_PURPOSE FOR_DOC_PURPOSE_WAS_DEFINED   // Restored!
#endif


#endif
