﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

// This file must have the name of the Dataset that it implements, StationIdentification.h

#ifndef _StationIdentification_H_
#define _StationIdentification_H_

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <NetZ/src/Core/DOCore/StationIdentificationDDL.h>

BEGIN_NAMESPACE_NEX

class StationIdentification: public DATASET(StationIdentification)
{

public:
    enum PlatFormID
    {
        PLATFORM_UNKNOWN = 0,
        PLATFORM_CTR,
        PLATFORM_WUP
    };

    StationIdentification()
    {
        m_uiProcessType = 0;
        m_uiProductVersion = 0;
        m_uiPrincipalId = 0;
        m_uiLanguageCode = 0;
        m_strPlayerName = _T("");
        m_uiNetZVersion = 0;
        m_uiApplicationVersion = 0;
        m_uiNATProperties = 0;
        m_uiPlatformID = PLATFORM_UNKNOWN;
    }
    virtual ~StationIdentification() {}
};

END_NAMESPACE_NEX

#endif
