﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _SessionSpace_H_
#define _SessionSpace_H_

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>

#include <NetZ/src/Core/DupSpace/SessionSpaceDDL.h>
#include <NetZ/src/Core/DOCore/DOHandle.h>

BEGIN_NAMESPACE_NEX


class IteratorOverDOs;
class DuplicatedObject;

class SessionSpace: public DUPSPACE(SessionSpace)
{
public:

    SessionSpace();
    virtual ~SessionSpace();

    virtual qBool PSMatch(DuplicatedObject* pPublisher, DuplicatedObject* pSubscriber, qBool bOnRelevanceCheck);

    virtual qBool IsDuplicaRelevant(DuplicatedObject *pDO);

    // In this space, although no user cells are defined, we don't
    // use default cells.
    virtual qBool CellMatch(DuplicatedObject* /*pPorS*/, DuplicatedObject* /*pCell*/, qBool /*bForDiscovery*/)
    {
        SYSTEMCHECK(false);
        return false;
    }
    virtual void CreateCells() {};
    virtual qBool UsesDefaultCells()
    {
        return false;
    }

    static void InitializeSpecialRelations();
};

END_NAMESPACE_NEX

#endif
