﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _GlobalDiscovery_H_
#define _GlobalDiscovery_H_

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <OnlineCore/src/Core/PseudoSingleton.h>
#include <OnlineCore/src/Core/OperationManager.h>

BEGIN_NAMESPACE_NEX

class DuplicatedObject;
class DOOperation;
class Station;

class GlobalDiscovery: public OperationCallback
{
public:
    GlobalDiscovery();

    virtual void CallMethod(Operation* pOperation);

private:
    void ProcessNewSubscriber(DOOperation *pOperation);
    void ProcessNewPublisher(DOOperation *pOperation);
    void BootstrapDiscovery(DOOperation *pOperation);
    void ProcessPSPair(DuplicatedObject* pPublisher, Station* pStation);
};

END_NAMESPACE_NEX

#endif
