﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _CacheManager_H_
#define _CacheManager_H_

#include <OnlineCore/src/Platform/Core/String.h>
#include <OnlineCore/src/Core/CoreDecl.h>
#include <OnlineCore/src/Core/BasicCache.h>
#include <OnlineCore/src/Platform/Core/qMap.h>

BEGIN_NAMESPACE_NEX

/*
    CacheManager (singleton)
*/
class CacheManager: public RootObject
{
    friend class BasicCache;

public:

    ~CacheManager();

    BasicCache* GetCache(const String& strCacheName);

    static CacheManager* GetInstance();

#ifdef TEST_ENABLED
    static qBool Test();
#endif

private:

    CacheManager();

    //  Accessible by BasicCache
    void  RegisterCache(BasicCache* pCache);
    qBool UnregisterCache(const String& strCacheName);

    typedef qMap<String, BasicCache*>   BasicCacheMap;

    BasicCacheMap   m_oBasicCacheMap;

    friend class GlobalVariables;
};

END_NAMESPACE_NEX

#endif
