﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
//n1769


#ifndef _MD5checksumWithKey_H_
#define _MD5checksumWithKey_H_

#include <OnlineCore/src/Core/Checksum/Interface/ChecksumDecl.h>
#include <OnlineCore/src/Core/Checksum/Interface/KeyedChecksumAlgorithm.h>
#include <OnlineCore/src/Core/Checksum/MD5/MD5Checksum.h>


BEGIN_NAMESPACE_NEX


class Buffer;

//
//
//
class MD5ChecksumWithKey : public KeyedChecksumAlgorithm
{
public:
    MD5ChecksumWithKey(void);

    virtual ~MD5ChecksumWithKey(void);

    virtual qBool ComputeChecksum(const qByte** pBuffer, const qUnsignedInt32 nSize[], qInt length, SignatureBytes &signature);

    virtual qBool ComputeChecksum(const Buffer &oBuffer, Buffer *pChecksum);

    virtual qByte GetChecksumLength(void)
    {
        return 16;    // This is MD5, so the digest length is 128 bits (that is, 16 bytes)
    }

    // {secret}
    virtual qUnsignedInt32 ComputeChecksumForTransportArray( const qByte** pBuffer, const qUnsignedInt32 nSize[], qInt length );

    static qBool Test(void);

protected:
    //n1769: For this class, a signature should be calculated even if a key is not set, so it now always returns true.
    //       
    virtual qBool IsReady(void) const
    {
        return true;
    }


private:
    //
    MD5ChecksumWithKey           (const MD5ChecksumWithKey&);
    MD5ChecksumWithKey& operator=(const MD5ChecksumWithKey&);
    void ChecksumComputeHelper( const qByte** pBuffer, const qUnsignedInt32 nSize[], qInt length, MD5 &oOuter);

};


END_NAMESPACE_NEX


#endif  // end of _MD5checksumWithKey_H_
