/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/


#ifndef _RefBuffer_H_
#define _RefBuffer_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

class Buffer;

/* Please see man pages for details 
 

 
 
 
 
 */
class RefBuffer: public RootObject
{
public:
    /* Please see man pages for details 
    

    

    
    */
    RefBuffer();
    /* Please see man pages for details 
    

    

    
    
    
    */
    RefBuffer(const RefBuffer& refBuffer);

    /* Please see man pages for details 
    

    
    */
    ~RefBuffer();

    /* Please see man pages for details 
    

    
    
    */
    qByte* Get()
    {
        return m_pBufferPayload;
    }
    /* Please see man pages for details 
    

    
    
    */
    const qByte* Get() const
    {
        return m_pBufferPayload;
    }

    /* Please see man pages for details 
    
    
    */
    qUnsignedInt32 GetSize() const
    {
        return m_bufferPayloadSize;
    }

public: // operator overload
    /* Please see man pages for details 
    

    

    
    
    */
    RefBuffer& operator=(const RefBuffer& refBuffer);
    /*
    
    
    
    
    */
    RefBuffer& operator=(Buffer& buffer);

    /* Please see man pages for details 
    

    
    
    
    */
    qByte& operator[](qUnsignedInt pos)
    {
        return *(m_pBufferPayload+pos);
    }
    /* Please see man pages for details 
    

    
    
    
    */
    const qByte& operator[](qUnsignedInt pos) const
    {
        return *(m_pBufferPayload+pos);
    }

private:
    /*
    
    */
    void Initialize();
    /*
    
    */
    void ReleaseBuffer();
private:
    // m_pBuffer -> GetContentPtr function cache
    qByte* m_pBufferPayload;
    // m_pBuffer -> GetContentSize function cache
    qUnsignedInt32 m_bufferPayloadSize;
    // Pointer to a buffer object
    Buffer* m_pBuffer;
};

END_NAMESPACE_NEX

#endif // _RefBuffer_H_
