﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _StringUtil_H_
#define _StringUtil_H_

#include <OnlineCore/src/Core/UtilityDecl.h>
#include <OnlineCore/src/Platform/Core/qVector.h>
#include <OnlineCore/src/Platform/Core/String.h>

BEGIN_NAMESPACE_NEX

//  Convert a string to uppercase
//  Returns szStr
qChar* StrUpper(qChar* szStr);

//  Convert a string to lowercase
//  Returns szStr
qChar* StrLower(qChar* szStr);

//  Duplicate a string
//  qSpecialDeleteArray MUST be called afterwards on returned value
qChar* StrDup(const qChar* szStr);

//  Find a substring, regardless of case
//  Returns substring position as offset (-1 if not found)
qInt FindSubstringNoCase(const qChar* szStr, const qChar* szSubstring);

qVector<String> StringSplit(const String& str, qChar delimiter);

#ifdef TEST_ENABLED

qBool StringUtilTests();

#endif


END_NAMESPACE_NEX

#endif

