﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _ClassDeclaration_H_
#define _ClassDeclaration_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/ParseTree/TypeDeclaration.h>
#include <OnlineCore/src/ParseTree/NameSpaceRef.h>
#include <OnlineCore/src/ParseTree/NameSpace.h>

BEGIN_NAMESPACE_NEX

class UpdateSpec;

class ClassDeclaration: public TypeDeclaration
{
public:
    ClassDeclaration(const String& strName, ClassDeclaration* pParent=NULL);
    virtual ~ClassDeclaration();

    DECLARE_NAMESPACE_ITEM(ClassDeclaration, TypeDeclaration);

    virtual void SetNameSpace(NameSpace *pNS);

#ifdef TRACE_ENABLED
    virtual void Trace(qUnsignedInt64 uiTraceFlag) const;
#endif

    qResult StreamIn(BinaryRepresentation *pStream) const;
    qResult StreamOut(BinaryRepresentation *pStream);

    virtual qBool IsEqual(const ParseTreeItem* pOther) const;

    ClassDeclaration* GetParent() const;

    virtual qBool MayHaveProperties() const
    {
        return true;
    }
    virtual Declaration* GetParentDeclaration() const
    {
        return GetParent();
    }

    virtual qBool ResolveReferences();

    NameSpace& NS()
    {
        return m_nsStruct;
    }
    const NameSpace& NS() const
    {
        return m_nsStruct;
    }

private:
    NameSpaceRef m_refParent;
    NameSpace m_nsStruct;
};

END_NAMESPACE_NEX

#endif
