/*---------------------------------------------------------------------------*
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _Condition_H_
#define _Condition_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/LockMasks.h>
#include <OnlineCore/src/Platform/Core/CriticalSection.h>
#include <OnlineCore/src/Platform/Core/ForcedCriticalSection.h>
#include <OnlineCore/src/Platform/Core/Event.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
 
 
 
 
 
 */
class Condition: public RootObject
{

    class Attribute;

public:
    /* Please see man pages for details 
     
     
     
     
     
     
     */
    Condition(qUnsignedInt32 uiLockGroup, qBool isAll = false);

    /* Please see man pages for details 
     
     
     
     
     
     
     
     
     
     */
    void Notify();


    /* Please see man pages for details 
     
     
     
     
     
     
     */
    void CancelAll();

    virtual ~Condition();

    /* Please see man pages for details 
     
     
     
     
     
     
     
     
     */
    qBool WaitForEvent(ForcedCriticalSection *cs, qUnsignedInt32 uiTimeout = WAIT_INFINITE_TIMEOUT);

    qInt GetRefCount()
    {
        return m_refCount;
    }

#ifdef TEST_ENABLED
    static qBool Test();
#endif

private:

#if defined(WIN_FAMILY) || defined(UNIX_FAMILY) || defined(CTR_TARGET) || defined(CAFE_TARGET)
    qBool WaitForOSEvent(ForcedCriticalSection *cs, qUnsignedInt32 uiTimeout);
#else
    qBool WaitForBoolEvent(ForcedCriticalSection *cs, qUnsignedInt32 uiTimeout);
#endif

    void ResetEvent();

    qInt IncRefCount()
    {
        qInt ret;
        m_refCountLock.Enter();
        ret = ++m_refCount;
        m_refCountLock.Leave();
        return ret;
    }

    qInt DecRefCount()
    {
        qInt ret;
        m_refCountLock.Enter();
        ret = --m_refCount;
        m_refCountLock.Leave();
        return ret;
    }

    Attribute       *m_pAttribute;
    ForcedCriticalSection m_refCountLock;
    qInt m_refCount;
    qBool m_isAll;
};

END_NAMESPACE_NEX


#endif
