﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _ConsoleIO_H_
#define _ConsoleIO_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/String.h>

BEGIN_NAMESPACE_NEX

//==============================================================================
// Provides platform-independent basic services for user I/O in console mode.
//==============================================================================
class ConsoleIO : public RootObject
{
public:
    ConsoleIO() {}
    virtual ~ConsoleIO() {}

    static qBool InputIsSupported();
    static qBool OutputIsSupported();

    static qChar GetChar( qBool bBlocking = true );
    static void GetCStr( qChar *pCStr, qUnsignedInt uiBufSize );
    static void Print(const qChar * const szFormat, ...);
    static void PutString(const qChar* szString);
    static void Banner(const qChar *strDescription);
    static void Error();

#ifdef NON_SUPPORT_A_TARGET
    class GuDebugConsole: public RootObject
    {
    public:
        GuDebugConsole();
        void Print(const qChar * const szString);
    private:
        String          m_strConsoleLines[25];
        qUnsignedInt    m_uiCurrentLine;
    };
#endif

};

END_NAMESPACE_NEX

#endif
