﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _LogDeviceConsole_H_
#define _LogDeviceConsole_H_

#include <OnlineCore/src/Platform/Core/LogDevice.h>

BEGIN_NAMESPACE_NEX

//group=Log Devices

/*
Description: This class is the LogDevice implementation of standard output console logging.
See Also: LogDeviceFile, LogDeviceDebugOutput
*/
class LogDeviceConsole : public LogDevice
{
public:
    LogDeviceConsole(void *ConsoleHandle = NULL);
    //group=Methods

    // {secret}
    // Outputs the LogEntry to the standard output console.
    virtual void Output(const qChar *pLog);

#ifdef TEST_ENABLED
    // {Secret}
    static qBool Test();
#endif
private:
    void *m_cpHandle;
};

END_NAMESPACE_NEX

#endif

