﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _NETZPROFILE_H_
#define _NETZPROFILE_H_

#include <OnlineCore/src/Platform/Core/NetzProfileTag.h>

//////////////////////////////////////////////////////////////////////////
// Profiling

#if defined(PROFILING_ENABLED)

#define NETZ_INTERNAL_PROFILE(str) \
    OSDK_Platform::profile::ProfilerTags profilerData(str);

#define NETZ_PROFILEPOINT(str)  NETZ_INTERNAL_PROFILE( "" #str "")

#else

#define NETZ_PROFILEPOINT(...)

#endif //defined(PROFILING_ENABLED)

typedef void (* ProfileEnterFunction)(const char * profileId);
typedef void (* ProfileExitFunction)(const char * profileId);
typedef void (* ProfileRegisterThread)();

namespace OSDK_Platform
{
namespace profile
{
//////////////////////////////////////////////////////////////////////////
// Module - OSDK_Platform::profile
//////////////////////////////////////////////////////////////////////////
qBool HookProfileTags(ProfileEnterFunction fcnEnter, ProfileExitFunction fcnExit, ProfileRegisterThread fcnRegisterThread);

// Call this to register a thread for profiling
qBool RegisterThreadForProfiling();

} // namespace profile
} // namespace OSDK_Platform

#endif //_NETZPROFILE_H_
