﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _Recognition_H_
#define _Recognition_H_

// Windows family recognition.

#if defined(WIN32) && !defined(UNDER_CE) && !defined(_NON_SUPPORT_D) && !defined(_XENON)
#define WIN_FAMILY
#define WIN32_TARGET
#define TARGET_RECOGNIZED
#define MSC_COMPILER
#endif // WIN32

// LIVE_VERSION is the server build definition. The server build definitions are defined in BuildFlags_server.cmake and BuildFlags_linuxserver.cmake.
#ifndef LIVE_VERSION
#define NEX_CLIENT_OPTIMIZATION
#endif

#if defined(_NON_SUPPORT_D)

// (note that due to a bug in makedepend, the spaces before the ifndef
// that follows is required!)

#ifndef _M_PPC
#define WIN_FAMILY
#define NON_SUPPORT_D_TARGET
#define NON_SUPPORT_D_FAMILY
#define TARGET_RECOGNIZED
#define MSC_COMPILER
#else
#define NON_SUPPORT_E_TARGET
#endif // _M_PPC
#endif // NON_SUPPORT_D

#if defined(XENON) || defined(_XENON) || defined(_NON_SUPPORT_E) || defined(NON_SUPPORT_E)
// Maybe some people are using those
#ifndef NON_SUPPORT_E_TARGET
#define NON_SUPPORT_E_TARGET
#endif
#endif

#ifdef NON_SUPPORT_E_TARGET
#define WIN_FAMILY
#define NON_SUPPORT_D_FAMILY
#define TARGET_RECOGNIZED
#define MSC_COMPILER
#endif

#if defined(WIN32_TARGET)

#if defined(_MSC_VER) && _MSC_VER >= 1300
#define DOT_NET_COMPILER
#endif

#if defined(_MSC_VER) && _MSC_VER >= 1310 && _MSC_VER < 1400
#define DOT_NET_2003_COMPILER
#elif defined(_MSC_VER) && _MSC_VER >= 1400 && _MSC_VER < 1500
#define VS2005_COMPILER
#elif defined(_MSC_VER) && _MSC_VER >= 1500 && _MSC_VER < 1600
#define VS2008_COMPILER
#elif defined(_MSC_VER) && _MSC_VER >= 1600
#define VS2010_COMPILER
#endif

#endif // WIN32_TARGET


// Unix family recognition.

#ifndef GCC_TARGET_NON_SUPPORT_B
#if defined(__GNUC__) && __GNUC__ >= 3
#if defined(MIPSEL) && defined(R5900)
#define GCC_TARGET_NON_SUPPORT_B
#endif
#endif
#endif

#ifdef LINUX_TARGET
#define UNIX_FAMILY
#define TARGET_RECOGNIZED
#define GCC_COMPILER_FAMILY
#endif // linux

#ifdef MACOSX_TARGET
#define UNIX_FAMILY
#define TARGET_RECOGNIZED
#define GCC_COMPILER_FAMILY
#endif // linux

// NON_SUPPORT_B target recognition.

#ifdef SN_TARGET_NON_SUPPORT_B
#define NON_SUPPORT_B_TARGET
#define SN_COMPILER
#define GCC_COMPILER_FAMILY
#define TARGET_RECOGNIZED
#endif

#ifdef GCC_TARGET_NON_SUPPORT_B
#define NON_SUPPORT_B_TARGET
#define GCC_COMPILER
#define GCC_COMPILER_FAMILY
#define TARGET_RECOGNIZED
#endif

#if defined(MW_TARGET_NON_SUPPORT_B)
#define NON_SUPPORT_B_TARGET
#define MW_COMPILER
#define TARGET_RECOGNIZED
#endif

#ifdef GCC_TARGET_NON_SUPPORT_A
#define NON_SUPPORT_A_TARGET
#define GCC_COMPILER
#define GCC_COMPILER_FAMILY
#define TARGET_RECOGNIZED
#endif


#ifdef SN_TARGET_NON_SUPPORT_A
#define NON_SUPPORT_A_TARGET
#define SN_COMPILER
#define GCC_COMPILER_FAMILY
#define TARGET_RECOGNIZED
#endif

#ifdef MW_TARGET_NON_SUPPORT_A
#define NON_SUPPORT_A_TARGET
#define MW_COMPILER
#define TARGET_RECOGNIZED
#endif

#if defined(NON_SUPPORT_B_TARGET) || defined(NON_SUPPORT_A_TARGET)
#define MIPS_R9000
#endif

#ifndef GCC_TARGET_NON_SUPPORT_C
#if !defined(__SNC__)
#if defined(__GNUC__) && __GNUC__ >= 3
#if defined(__CELLOS_LV2__)
#define GCC_TARGET_NON_SUPPORT_C
#endif
#endif
#endif
#endif

#ifdef GCC_TARGET_NON_SUPPORT_C
#define NON_SUPPORT_C_TARGET
#define GCC_COMPILER
#define GCC_COMPILER_FAMILY
#define TARGET_RECOGNIZED
#endif

#ifndef SNC_TARGET_NON_SUPPORT_C
#if defined(__SNC__)
#if defined(__CELLOS_LV2__)
#define SNC_TARGET_NON_SUPPORT_C
#endif
#endif
#endif

#ifdef SNC_TARGET_NON_SUPPORT_C
#define NON_SUPPORT_C_TARGET
#define SN_COMPILER
#define SN_COMPILER_FAMILY
#define TARGET_RECOGNIZED
#endif

#ifndef MW_TARGET_WII
#if defined(RVL) || defined(RVL_SDK) || defined(RVL_OS)
#define MW_TARGET_WII
#endif
#endif

#ifdef MW_TARGET_WII

#if !defined(WII_STACK) && !defined(WII_DWC)
#error You must define WII_STACK or WII_DWC to use Quazal API on Wii. Check the documentation or contact customer support for more details.
#endif

#if defined(WII_STACK) && defined(WII_DWC)
#error You must define only one of WII_STACK or WII_DWC to use Quazal API on Wii. Check the documentation or contact customer support for more details.
#endif

#define WII_TARGET
#define NINTENDO_FAMILY

// TODO_WII_PORT : We use MW_COMPILER, but we do not want to use this define
// in samples because the function mwInit(); is not defined!
// We have ~35 calls to MW_COMPILER. We should rename them to something like
// MW_COMPILER_INIT since it is mainly used (with a few exceptions) to
// define mwInit.
//#define MW_COMPILER
#define NINTENDO_FAMILY
#define TARGET_RECOGNIZED
#endif

#ifdef MULTI_TARGET_CAFE
#define CAFE_TARGET
#define TARGET_RECOGNIZED
#define NINTENDO_FAMILY
#define NEX_CLIENT_OPTIMIZATION
#endif

#if defined(CAFE) && defined(IOP_BUILD)
#define CAFEIOP_TARGET
#define TARGET_RECOGNIZED
#define NINTENDO_FAMILY
#define NEX_CLIENT_OPTIMIZATION
#endif

/* Nintendo DS */

#if defined(__MWERKS__) && defined(__arm)
#define DS_TARGET
#define NINTENDO_FAMILY
#define TARGET_RECOGNIZED
#endif


#ifndef ARM_TARGET_CTR
#if defined(_ARMABI)
#define ARM_TARGET_CTR
#endif
#endif


#if defined(ARM_TARGET_CTR) || defined(NN_PLATFORM_CTR)
#define NEX_CLIENT_OPTIMIZATION
#define NINTENDO_FAMILY
#define CTR_TARGET
#define TARGET_RECOGNIZED
#endif


// Check errors.

#ifndef TARGET_RECOGNIZED
#error NO TARGET SPECIFIED !
#endif

/* Build Target */
#ifdef CTR_TARGET
// n2605: Enable DEBUG_VERSION even when building a library
#if defined(NN_BUILD_DEBUG) || defined(NN_BUILD_NOOPT)
#define DEBUG_VERSION
// n2208: Enable DEVELOPMENT_VERSION even when building a library
#elif defined(NN_BUILD_DEVELOPMENT) || defined(NN_BUILD_VERBOSE)
#define DEVELOPMENT_VERSION
#undef DEBUG_VERSION
#else
#define RELEASE_VERSION
#endif
#else /* LINUX, WIN */
#if defined(_DEBUG) || defined(DEBUG)
#define DEBUG_VERSION
#else
#define RELEASE_VERSION
#endif
#endif

/* stop if defined many targets */
#if defined(DEBUG_VERSION) && defined(DEVELOPMENT_VERSION)
#error
#elif defined(DEBUG_VERSION) && defined(RELEASE_VERSION)
#error
#elif defined(DEVELOPMENT_VERSION) && defined(RELEASE_VERSION)
#error
#endif

// Error if not even one build type is specified.
#if !defined(DEBUG_VERSION) && !defined(DEVELOPMENT_VERSION) && !defined(RELEASE_VERSION)
#error DEBUG_VERSION or DEVELOPMENT_VERSION or RELEASE_VERSION are not defined.
#endif

/* Unicode or ANSI */
#if defined(CTR_TARGET) || defined(CAFE_TARGET) || defined(CAFEIOP_TARGET)
#if !defined(UNICODE_VERSION) && !defined(ANSI_VERSION)
#define UNICODE_VERSION
#endif
#endif

#if defined(_ANSI) || defined(ANSI)
#define ANSI_VERSION
#ifdef UNICODE_VERSION
#undef UNICODE_VERSION
#endif
#else
#if !(defined(CTR_TARGET) || defined(CAFE_TARGET) || defined(CAFEIOP_TARGET))
#define UNICODE_VERSION
#endif
#endif

#if defined(WIN32_TARGET) && defined(_MBCS)
#define ANSI_VERSION
#ifdef UNICODE_VERSION
#undef UNICODE_VERSION
#endif
#endif

// Define the opposite flags.

#ifndef INTERNAL_VERSION
#define SHIPPING_VERSION
#endif


/* The purpose of those definitions is to shorten macro expressions. */

#if defined(CTR_TARGET) && defined(ANSI_VERSION)
#define CTR_ANSI
#endif

#if defined(CTR_TARGET) && defined(UNICODE_VERSION)
#define CTR_UNICODE
#endif

#if defined(CAFE_TARGET) && defined(ANSI_VERSION)
#define CAFE_ANSI
#endif

#if defined(CAFE_TARGET) && defined(UNICODE_VERSION)
#define CAFE_UNICODE
#endif

// In consideration of making it common, will make it the same define as CAFE.
#if defined(CAFEIOP_TARGET) && defined(ANSI_VERSION)
#define CAFE_ANSI
#endif

#if defined(CAFEIOP_TARGET) && defined(UNICODE_VERSION)
#define CAFE_UNICODE
#endif

/* CTR config as it should run on a retail system */

#if defined(CTR_TARGET) && (defined(DEVELOPMENT_VERSION) || defined(RELEASE_VERSION)) && defined(SHIPPING_VERSION)
#define CTR_SHIPPING_VERSION
#endif

//n1589: Make the default MTU value larger than the original 1000
//n1589: The MTU can be made larger because CompressionAlgorithm::Decompress was revised
//n2361: MTU1000 is maintained to preserve compatibility with NFS
#if defined(NFS_COMPATIBLE) || defined(FPD_BUILD)
#define NEX_ENABLE_MTU_MAX 0
#else
#define NEX_ENABLE_MTU_MAX 1
#endif

//n2361: A 16-byte key length is maintained during RV communication to preserve compatibility with NFS
#if defined(NFS_COMPATIBLE) || defined(FPD_BUILD)
#define NEX_ENABLE_KERBEROS_KEY_LENGTH_MAX 0
#else
#define NEX_ENABLE_KERBEROS_KEY_LENGTH_MAX 1
#endif

//n1589: todo1
#if defined(NEX_CLIENT_OPTIMIZATION)
#define NEX_ENALBE_ASSERTMSG 1
#else
#define NEX_ENALBE_ASSERTMSG 0
#endif

//n1589
#define NEX_ENABLE_LOCK_ENDPOINT_MAP_MISSING_FIX 1

//n1589
#define NEX_ENABLE_LOCK_ENDPOINT_MISSING_FIX 1

//n1589: Lock m_oRoutingTable. This was missing from the original code.
#define NEX_ENABLE_LOCK_ROUTING_TABLE_MISSING_FIX 1

//n1589
#define NEX_ENABLE_LOCK_OBJECT_INCONSISTENCY_FIX 1

//n1589: Optimize locks. This mainly enables and disables individual locks dynamically for each CriticalSection.
#define NEX_ENABLE_LOCK_OPTIMIZATION 1

//n1589
#if NEX_ENABLE_LOCK_OPTIMIZATION
//n1589: Make transport thread mode usable
#define NEX_ENABLE_TRANSPORT_THREAD_MODE 1
#if defined(NEX_CLIENT_OPTIMIZATION)

// Do not lock when network stack operations occur.
#define STACK_IS_THREADSAFE

//n1589: Localize the PeerAddressLock in BerkeleySocketDriver and StationManager
#define NEX_ENABLE_PEER_ADDRESS_LOCK_LOCALIZATION 1
//n1589: Use the TransportLock only for necessary Job's destructors and PerformExecution
#define NEX_ENABLE_SCHEDULER_JOB_LOCK_LOCALIZATION 1
#endif
#endif //NEX_ENABLE_LOCK_OPTIMIZATION

#ifdef NEX_CLIENT_OPTIMIZATION
#ifndef CAFEIOP_TARGET
#define NEX_CLIENT_PBPOOL // Only the client using the packet buffer pool.
#endif
#endif

//n1589
#define NEX_ENABLE_PRUDP_USER_PROTOCOL_USE_REF 1

//n1589: Feature for sending and receiving data directly\ n2361: Handle 0x5c in Shift-JIS
#define NEX_ENABLE_PRUDP_USER_TRANSPORT 1

#if NEX_ENABLE_PRUDP_USER_TRANSPORT
//n2788: Enable a class just for sending and receiving data directly
#define NEX_ENABLE_USING_CLASS_DIRECTTRANSPORT 1
#endif

//n1589: Reduce locks when data is sent
#define NEX_ENABLE_STATION_SEND_OPTIMIZATION 1

//n1589: Optimize the unreliable transmissions
#define NEX_ENABLE_UNRELIABLE_BC 1

//n1589: Allow router features to be used even when UnreliableSendMulti is used
#define NEX_ENABLE_SEND_MULTI_ROUTING 1

//n1589
#ifdef NEX_CLIENT_OPTIMIZATION
#define NEX_ENABLE_SOCKET_TRANSPORT_PROFILING 1
#endif

//n1589
#ifdef NEX_CLIENT_OPTIMIZATION
#define NEX_ENABLE_BERKLEY_SOCKET_PROFILING 1
#endif

//n1589: Output necessary fault information to the log when a bug is reported. This is required because there are many rare bugs when a fault occurs.
#if defined(NEX_CLIENT_OPTIMIZATION)
#define NEX_ENABLE_LOG_FAULT 1
#endif

//n1589: Suppress code that implicitly specifies queues
#define NEX_ENABLE_EXPLICIT_ARGUMENT_TRANSPORT_SEND_QUEUE 1

//n1589: Suppress feature(s) that send data through sockets from the dispatch thread
#define NEX_ENABLE_TRANSPORT_SEND_QUEUE_FORCIBLY 1

#ifdef NEX_CLIENT_OPTIMIZATION
//n1589: Limitations on the latency limit queue feature and the delay within the send buffer
#define NEX_ENABLE_LATENCY_LIMIT_PACKET_QUEUE_SEND 1

//n1589: Limitations on the latency limit buffer feature and the delay within the send buffer for the transport buffer
#define NEX_ENABLE_LATENCY_LIMIT_TRANSPORT_BUFFER_SEND 1
#endif

//n2370
#if defined( NEX_CLIENT_OPTIMIZATION ) || defined( WIN32_TARGET )
#   define NEX_ENABLE_RELIABLE_MAP_SIZE_LIMITATION 1
#else
#   define NEX_ENABLE_RELIABLE_MAP_SIZE_LIMITATION 0
#endif

#if defined(CTR_TARGET) || defined(CAFE_TARGET) || defined(CAFEIOP_TARGET)
//n1589: for exporting socket handle
#define NEX_ENABLE_SOCKET_HANDLE_EXPORT 1
//n1589: for exporting socket receiving
#define NEX_ENABLE_SOCKET_RECEIVE_EXPORT 1
//n1589: for switching socket transport function
#define NEX_ENABLE_SOCKET_TRANSPORT_SWITCH 1
#endif

#if defined( NEX_CLIENT_OPTIMIZATION )
// n2361: Disable unittest because a memory leak is detected.
//n1769: Edit this macro's value if you want to change whether profiling is used in a CTR environment.
#define NEX_DISABLE_USING_CTR_PROFILING_UNIT 1
#else
//n1769: Profiling is always suppressed on non-CTR environments. Leave this value alone.
#define NEX_DISABLE_USING_CTR_PROFILING_UNIT 1
#endif

//n2370: Reject new stations that are trying to join a session when the scheduler is busy
#ifdef NEX_CLIENT_OPTIMIZATION
#   define NEX_ENABLE_SCHEDULE_BUSY_CHECK 1
#endif

//n2370: Reject non-master PRUDP connections while joining a session
#ifdef NEX_CLIENT_OPTIMIZATION
#   define NEX_ENABLE_REJECT_PRUDP_CONNECTING_WHILE_JOINING 1
#else
#   define NEX_ENABLE_REJECT_PRUDP_CONNECTING_WHILE_JOINING 0
#endif

//n2370: Ignore some communication upon failure to join a session
#define NEX_IGNORE_DOPROTOCOL_IF_FAILED_TO_JOIN 1

//n2370: Check when a station finishes connecting
#define NEX_CHECK_FAULTY_ON_ORPHAN_RESULT 1

//n2370: Disconnect when a request fails
#define NEX_DISCONNECT_ON_REQUESTFAILED 1

//n2370: When failing to join a session, change the method to delete the station's main reference
#define NEX_JOINREQUESTFAILED_CHECK_DUPLICATION_MASTER 0

//n2370: Perform EndPoint confirmation when connecting to a station
#define NEX_ENABLE_ENDPOINTCHECK_UNDELETE 1

//n1589: for bug_p2p1720: Workaround for a bug that results in an infinite wait for failures in ChangeMasterStation
#define NEX_ENABLE_FAULT_RECOVERY_FOREVER_FIX 1

//n1589: for bug_p2p1720: Original fix to eliminate (reduce) the chances of ChangeMasterStation failing
#define NEX_ENABLE_FAULT_RECOVERY_ELECT_MASTER_IMPROVE 1

//n1589: for bug_p2p1174: Allow fatal error processing when duplicated objects do not finish terminating
#define NEX_ENABLE_IMPROVE_DO_CORRUPT 1
#if NEX_ENABLE_IMPROVE_DO_CORRUPT

//n1589: Allow LeaveSession to be run as appropriate
#define NEX_ENABLE_IMPROVE_LEAVE_SESSION 1

#else //NEX_ENABLE_IMPROVE_DO_CORRUPT

#define NEX_ENABLE_IMPROVE_LEAVE_SESSION 0

#endif //NEX_ENABLE_IMPROVE_DO_CORRUPT

//n2370: Patch provided by Quazal to cancel connection to EndPoint in regards to the problem of a prolonged finalization process
#define NEX_ENABLE_QUAZAL_TERMINATE_CANCELJOB 1

//n2370: Patch provided by Quazal to improve SynchronizeTermination in regards to the problem of a prolonged finalization process
#define NEX_ENABLE_QUAZAL_TERMINATE_SYNCTERMINATION 1

//n2370: Perform a call context check with JobTerminateDOCore::SyncTermination
#define NEX_ENABLE_CALLCONTEXT_CHECK_IN_SYNCTERMINATION 1

//n2781: Revised weaknesses in PRUDPS.
#define NEX_ENABLE_FIX_PRUDPS 1

//n2781: Details for the revision (these cannot be switched on and off individually)
#if NEX_ENABLE_FIX_PRUDPS
//n2781: Compress and encrypt at the EndPoint level
#define NEX_ENABLE_ENCDEC_AT_ENDPOINT 1

//n2781: Use the key received from an authentication node for communication with a service node
#define NEX_ENABLE_USE_SECURE_KEY 1

//n2781: Attach an expiration date to tickets
#define NEX_ENABLE_USE_TICKET_PERIOD 1

#else // NEX_ENABLE_FIX_PRUDPS
#define NEX_ENABLE_ENCDEC_AT_ENDPOINT 0
#define NEX_ENABLE_USE_SECURE_KEY 0
#define NEX_ENABLE_USE_TICKET_PERIOD 0
#endif // end of NEX_ENABLE_FIX_PRUDPS

//n2690: Macro definition(s) to preserve FPD compatibility
#if defined(NFS_COMPATIBLE)
// Use RegisterEx and always authenticate tokens in RegisterURLs
#define NEX_ENABLE_FORCE_REGISTEREX 1
// Allow an RVSecure stream request
#define NEX_ENABLE_OLD_RVSECURE 1
#else
#define NEX_ENABLE_FORCE_REGISTEREX 0
#define NEX_ENABLE_OLD_RVSECURE 0
#endif

//n2781: Return ACK responses together
#define NEX_ENABLE_COLLATED_ACK 0

//n2781: Intercept communication with an address specified for testing
#define NEX_ENABLE_VIRTUAL_FILTER_DEVICE 1

//n2781: Fixes a bug that causes a fatal error when the transport thread has a higher priority than the main thread
#define NEX_ENABLE_TRANSPORT_THREAD_PRIORITY_FIX 1

//n2342: Move communication processing to a separate thread to reduce locks by the transport thread
#define NEX_ENABLE_TRANSPORT_BUFFER_THREAD 1

//n2781: Use a safe, temporary key for data packets' HMAC
#if defined(FPD_BUILD) || defined(NFS_COMPATIBLE)
#define NEX_ENABLE_HMAC_USE_SECURE_KEY 0
#else
#define NEX_ENABLE_HMAC_USE_SECURE_KEY 1
#endif

//n2781: Hybrid connections' validation
#define NEX_ENABLE_HYBRID 1

//n2781: Limitations for hybrid connections
#define NEX_ENABLE_HYBRID_DETECT_LIMITATION 1

//n2781: TTL is correctly set for TransportBufferThread
#define NEX_ENABLE_FIX_TTL_FOR_TRANSPORT_BUFFER_THREAD 1

//n2781: Activated JobConnectStation cancellation
#define NEX_ENABLE_CANCEL_CONNECT_STATION 0

//n2788: Directly use nn::os::Thread in UdsNode's EventThread
#define NEX_ENABLE_CHANGE_UDS_EVENT_THREAD 1

// Whether to check the product key.
#define NEX_ENABLE_USE_PRODUCT_KEY 0

#endif //_Recognition_H_
