﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _RootObject_H_
#define _RootObject_H_

#include <OnlineCore/src/Platform/Core/PlatformDeclInternal.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
 

 
 
 
 

 
 
 
 */
class RootObject
{
public:
    enum TargetPool
    {
        // The target pool when allocating memory. (The enum difinition in consideration of an increase in the future.)
        POOL_PB_MANAGEMENT // Pool for the management object based on PacketBufferManager.
    };
public:
    RootObject() {}
#ifdef TEST_ENABLED
    virtual ~RootObject() {}
#else
    ~RootObject() {}
#endif
    void *operator new(size_t size, void* pPtr) throw()
    {
        DUMMY_PARAM(size);
        return pPtr;
    }
    //n2775 Exclude because it cannot be used and results in a warning during CTR builds
#ifndef CTR_TARGET
    void operator delete(void* pPtr1, void* pPtr2)
    {
        DUMMY_PARAM(pPtr1);
        DUMMY_PARAM(pPtr2);
    }
#endif

    void *operator new(size_t size, const qChar* file, qUnsignedInt32 line) throw();
    void *operator new(size_t size) throw();

    void *operator new[](size_t size, const qChar* file, qUnsignedInt32 line) throw();
    void *operator new[](size_t size) throw();

    void operator delete(void *uptr);
    void operator delete[](void *uptr);

    /* 
     
            
     */
    void *operator new(size_t size, TargetPool pool) throw();
    void *operator new(size_t size, TargetPool pool, const qChar *file, qUnsignedInt32 line) throw();
private:// Array allocation is not supported.
    void *operator new[](size_t size, TargetPool pool) throw();
public:

    //n2775 Exclude because it cannot be used and results in a warning during CTR builds
#ifndef CTR_TARGET
    // The two following methods must be called explicitely to be used.
    // NOTE: Those method are currently not called or exercised through any test.
    void operator delete(void *uptr, const qChar *file, qUnsignedInt32 line);
    void operator delete[](void *uptr, const qChar *file, qUnsignedInt32 line);
#endif

#ifdef TEST_ENABLED
    // {Secret}
    static qBool Test();
    // This method is there only for RTTI to properly work.
    virtual void vvfunc() {}
#endif
};

END_NAMESPACE_NEX

#endif
