/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _qVector_H_
#define _qVector_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/MemAllocator.h>

// STL compiles with level 4 warnings...
#ifdef WIN_FAMILY
#pragma warning( push, 1 )
#endif
#ifdef TURN_MATHWARN_OFF
#pragma mathwarn off
#endif

#include <vector>

#ifdef WIN_FAMILY
#pragma warning( pop ) // Restore previous warning
#endif
#ifdef TURN_MATHWARN_OFF
#pragma mathwarn on
#endif

BEGIN_NAMESPACE_NEX

//==============================================================================
// Inherits all operations from the std::vector using the appropriate allocator.
//==============================================================================
/* Please see man pages for details 
    

            

    
*/
template <typename T> class qVector
#ifdef ALLOCATOR_SUPPORT
    : public std::vector<T, MemAllocator<T> >, public RootObject
#else
    : public std::vector<T>, public RootObject
#endif
{
public:
    qVector()
#ifdef ALLOCATOR_SUPPORT
        : std::vector<T, MemAllocator<T> >()
#else
        : std::vector<T>()
#endif
    {
    }
    explicit qVector(qInt iSize)
#ifdef ALLOCATOR_SUPPORT
        : std::vector<T, MemAllocator<T> >(iSize)
#else
        : std::vector<T>(iSize)
#endif
    {
    }
};

END_NAMESPACE_NEX

#endif //_qVector_H_
