/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _InetDecl_H_
#define _InetDecl_H_

#ifndef _PlatformDecl_H_
#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#endif

#ifdef WIN_FAMILY
#define WINSOCK_FAMILY_STACK
#if defined(WIN32_TARGET) || defined(LIVE_FAMILY)
#define WINSOCK2_STACK_SUPPORT
#endif
#define BERKELEY_STACK_SUPPORT
#endif

#ifdef UNIX_FAMILY
#define BERKELEY_STACK_SUPPORT
#endif

#ifdef NON_SUPPORT_F_STACK
#define BERKELEY_STACK_SUPPORT
#endif

#ifdef EENET_STACK
#endif

//  Return value for Socket::GetIOResult()

#ifdef NON_SUPPORT_A_TARGET
#define NON_SUPPORT_A_INFRASTRUCTURE
#endif

#if defined(NON_SUPPORT_A_INFRASTRUCTURE)
#define BERKELEY_STACK_SUPPORT
#endif

#if defined(NON_SUPPORT_C_TARGET)
#define BERKELEY_STACK_SUPPORT
#endif

#ifndef WINSOCK2_STACK_SUPPORT
#define USE_BERKELEY_DRIVER
#endif

#ifdef WII_TARGET
#define BERKELEY_STACK_SUPPORT
#endif

#ifdef CAFE_TARGET
#define BERKELEY_STACK_SUPPORT
#endif

#ifdef NEX_CLIENT_OPTIMIZATION
#define BERKELEY_STACK_SUPPORT
#endif

#ifdef CTR_TARGET
#include <nn/socket/socket_Types.h> //n2343:for sizeof(nn::socket::SockAddrIn)
BEGIN_NAMESPACE_NEX
typedef nn::socket::SockAddrStorage SockAddrStorage;
typedef nn::socket::SockAddrIn SockAddrIn;
END_NAMESPACE_NEX
#endif

#ifdef UNIX_FAMILY
#include <netinet/in.h>

BEGIN_NAMESPACE_NEX
typedef struct ::sockaddr_storage SockAddrStorage;
typedef struct ::sockaddr_in SockAddrIn;
END_NAMESPACE_NEX

#endif

#if defined(CAFE_TARGET) || defined(CAFEIOP_TARGET)

#if defined(CAFE_TARGET)
#include <sdk_ver.h>
#if CAFE_OS_SDK_VERSION <= 20908
#include <cafe/net/so.h>
#else
#include <cafe/net/so_init.h>
#endif
#endif //defined(CAFE_TARGET)

#if defined(CAFEIOP_TARGET)
#include <cafe/net/so.h>
#include <cafe/net/netdb.h> // for gethostbyname
#endif //defined(CAFEIOP_TARGET)

BEGIN_NAMESPACE_NEX
typedef struct sockaddr SockAddrStorage;
typedef struct sockaddr_in SockAddrIn;
END_NAMESPACE_NEX

#endif

#ifdef WIN32_TARGET
//n2967: With Windows, if Winsock is included, there are conflicts with max, etc., so it is not optimized
#endif


#endif

