﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _InterfaceTable_H_
#define _InterfaceTable_H_

#include <OnlineCore/src/Platform/Stack/Core/InetDecl.h>
#include <OnlineCore/src/Platform/Stack/Core/InterfaceInfo.h>

BEGIN_NAMESPACE_NEX

class InterfaceTable: public RootObject
{

public:
    InterfaceTable();
    ~InterfaceTable();

    qBool   Query();

    qUnsignedInt32  GetNbInterface();
    qUnsignedInt32  GetNbLoopbackInterface();
    InterfaceInfo   &operator[](qUnsignedInt32 uiIndex);

    void    Trace(qUnsignedInt64 uiTraceFlags = TRACE_ALWAYS);

#ifdef TEST_ENABLED
    static qBool Test();
#endif

private:
    void cleanup();
    qUnsignedInt32  m_uiNbInterface;
    InterfaceInfo   *m_aInterfaceTable;

#ifdef NEX_CLIENT_OPTIMIZATION
    static qChar    m_szDefaultNetworkInterfaceAddress[20];
#endif
};


END_NAMESPACE_NEX

#endif
