﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.
  Copyright (C)2011-2014 Nintendo  All rights reserved.
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------

*/

#ifndef _NATTraversalResult_H_
#define _NATTraversalResult_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

enum NATTraversalResult
{
    NATTraversalResult_Initial = 0, /* Undefined/database default. */
    NATTraversalResult_Success = 100, /* Success. */
    NATTraversalResult_SuccessWithRelay = 110, /* Success using relay server. */
    NATTraversalResult_NotProbeRequestReceived = 200, /* Could not receive response for ProbeRequest. */
    NATTraversalResult_NotProbeResponseReceived = 201, /* Could not receive ProbeResponse. */
    NATTraversalResult_NotProbeResponseReceivedWithRelay = 210, /* Could not receive ProbeResponse even when using relay server. */
    NATTraversalResult_Unknwon = 999 /* Unknown. The probe does not exist or is in processing. */
};


END_NAMESPACE_NEX

#endif
