/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _StreamBundling_H_
#define _StreamBundling_H_

#include <OnlineCore/src/Transport/Interface/TransportDecl.h>
#include <OnlineCore/src/Platform/Core/CriticalSection.h>

BEGIN_NAMESPACE_NEX
/* Please see man pages for details 
    

    
    
    
    

    

  

    
 */
class StreamBundling: public RootObject
{
public:
    StreamBundling();
    virtual     ~StreamBundling();

    /* Please see man pages for details 
     
     
     
     
     
     */
    qBool IsEnabled() const
    {
        return m_bEnabled;
    }

    /* Please see man pages for details 
    
     */
    void Disable()
    {
        m_bEnabled = false;
    }

    /* Please see man pages for details 
     
     
     
     
     
     
     
     */
    void Enable(TimeInterval tiAutoFlushPeriod = Time(0));
    void Flush();
    Time GetLastFlushTime();

    //n1589
    /* Please see man pages for details 
     
     
     
     
     
     
     
     */
    void SetMaxFlushDelay(TimeInterval ti);

    /* Please see man pages for details 
     
     
     
     */
    qUnsignedInt16 GetMaxUnreliableBundlingPackets()
    {
        return m_maxUnreliableBundlingPackets;
    }

    /* Please see man pages for details 
     
     
     
     
     
     */
    void SetMaxUnreliableBundlingPackets(qUnsignedInt16 packets)
    {
        m_maxUnreliableBundlingPackets = packets;
    }

    /* Please see man pages for details 
     
     
     
     */
    qUnsignedInt16 GetMaxReliableBundlingPackets()
    {
        return m_maxReliableBundlingPackets;
    }

    /* Please see man pages for details 
     
     
     
     
     
     
     
     */
    void SetMaxReliableBundlingPackets(qUnsignedInt16 packets)
    {
        m_maxReliableBundlingPackets = packets;
    }

    //n2619
    TimeInterval GetMaxFlushDelay()
    {
        return m_tiMaxFlushDelay;
    }

private:
    void UpdateFlushTime();

private:
    qBool                   m_bEnabled;
    TimeInterval            m_tiMaxFlushDelay;
    Time                    m_tLastFlushTime;
    qUnsignedInt16          m_maxUnreliableBundlingPackets;
    qUnsignedInt16          m_maxReliableBundlingPackets;

    //n1589
    mutable CriticalSection m_csFlushTime;
};

END_NAMESPACE_NEX

#endif
