﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _TransportStreamManager_H_
#define _TransportStreamManager_H_

#include <OnlineCore/src/Transport/Interface/TransportDecl.h>
#include <OnlineCore/src/Platform/Core/qVector.h>
#include <OnlineCore/src/Platform/Core/qSortedVector.h>
#include <OnlineCore/src/Transport/Interface/Stream.h>
#include <OnlineCore/src/Transport/Interface/VirtualPort.h>

BEGIN_NAMESPACE_NEX

class RootTransport;
class Packet;

class TransportStreamManager : public RootObject
{
    friend class RootTransport;

public:
    TransportStreamManager();
    virtual ~TransportStreamManager();

    //{secret}
    qBool           RegisterStream(Stream *pStream, Stream::ID idDesiredStream, Stream::ID *pAcquiredStreamID = NULL);
    //{secret}
    qBool           UnregisterStream(Stream::Type oType, Stream::ID idStream);
    //{secret}
    qBool           IsStreamTypeRegistered(Stream::Type oType);

    qUnsignedInt    GetNBStreamByStreamType(Stream::Type oType);
    //{secret}
    qUnsignedInt    GetNbStream();
    //{secret}
    Stream*         GetStream(VirtualPort oVPort);
    //{secret}
    void            DemuxIncomingPacket(Packet *pPacket);
    //{secret}
    void            DoWork();
    //(secret)
    qBool           IsDuplicateReorderingPacket(Packet *pPacket);

private:
    typedef qSortedVector<VirtualPort,Stream*> VPortMap;

    //{secret}
    Stream*         GetStreamImpl(VirtualPort oVPort);

    VPortMap m_mapVPort;
    RootTransport *m_pTransport;
};

END_NAMESPACE_NEX

#endif
