﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _VirtualPort_H_
#define _VirtualPort_H_

#include <OnlineCore/src/Transport/Interface/TransportDecl.h>
#include <OnlineCore/src/Transport/Interface/Stream.h>

BEGIN_NAMESPACE_NEX

class VirtualPort: public RootObject
{
public:

    VirtualPort()
    {
        m_byVPort = 0;
    }

    VirtualPort(Stream::Type oType, Stream::ID idStream)
    {
        m_byVPort = qByte((oType<<4) | idStream);
    }

    VirtualPort(qByte byVPort)
    {
        m_byVPort = byVPort;
    }

    Stream::Type GetStreamType()
    {
        return Stream::Type(m_byVPort >> 4);
    }

    Stream::ID GetStreamID()
    {
        return Stream::ID((m_byVPort & 0xF));
    }

    operator qByte() const
    {
        return m_byVPort;
    }
    qBool operator ==(const VirtualPort &oVPort) const
    {
        return m_byVPort == oVPort.m_byVPort;
    }
    qBool operator <(const VirtualPort &oVPort) const
    {
        return m_byVPort < oVPort.m_byVPort;
    }

public:
    qByte m_byVPort;

};

END_NAMESPACE_NEX

#endif
