﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _RTT_H_
#define _RTT_H_


#include <OnlineCore/src/Transport/PRUDP/PRUDPDecl.h>

#if defined(NON_SUPPORT_B_TARGET) && defined(TEST_ENABLED)
#define INITIALRTT_DEFAULT      25000
#else
#define INITIALRTT_DEFAULT      750
#endif

BEGIN_NAMESPACE_NEX

class RTT: public RootObject
{

public:

    RTT(qUnsignedInt32 uiInitialRTT = INITIALRTT_DEFAULT);
    virtual ~RTT();

    void Adjust(qUnsignedInt32 uiRTT);

    qUnsignedInt32 GetRTO() const
    {
        return GetRTTSmoothedAvg()+(GetRTTSmoothedDev()<<DEVIATION_MULT);
    }
    qUnsignedInt32 GetLastRTT() const
    {
        return m_uiLastRTT;
    }
    qUnsignedInt32 GetRTTSmoothedAvg() const
    {
        return m_uiRTTSmoothedAvg >> AVG_GAIN_DIV;
    }
    qUnsignedInt32 GetRTTSmoothedDev() const
    {
        return m_uiRTTSmoothedDev >> DEVIATION_GAIN_DIV;
    }

    void Trace(qUnsignedInt64 uiTraceFlags);

#ifdef TEST_ENABLED
    static qBool Test();
#endif

protected:
    qUnsignedInt32          m_uiRTTSmoothedAvg;
    qUnsignedInt32          m_uiRTTSmoothedDev;
    qUnsignedInt32          m_uiLastRTT;
private:
    static const qUnsignedInt32 AVG_GAIN_DIV       = 3; // (1/8)
    static const qUnsignedInt32 DEVIATION_GAIN_DIV = 2; // (1/4)
    static const qUnsignedInt32 DEVIATION_MULT     = 2; // 4
};

END_NAMESPACE_NEX

#endif
