﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef __GuestCustomCreateAccountCommand_h__
#define __GuestCustomCreateAccountCommand_h__

#include <RendezVous/Core/src/Client/AccountManagement/GuestCreateAccountCommand.h>
#include <RendezVous/Core/src/Common/DataHolder.h>
#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

class ProtocolCallContext;

//==============================================================================
// Creates an account by using guest account with the static
// CustomCreateAccount method from AccountManagementClient.
//==============================================================================
class OSDK_API GuestCustomCreateAccountCommand: public GuestCreateAccountCommand
{

public:
    GuestCustomCreateAccountCommand(
        const DebugString& strDescription,
        const SandboxConnectionInfo& sci,
        const String& strUsername, const String& strPassword,
        const String& strEmail, qUnsignedInt32 uiGroups,
        DataHolder* pCustomAuthData, PrincipalID* pPid);

    ~GuestCustomCreateAccountCommand();

protected:
    qBool InvokeImpl(ProtocolCallContext* pCC);

private:
    DataHolder* m_pCustomAuthData;
    PrincipalID* m_pPid;
};

END_NAMESPACE_NEX

#endif
