﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _BuiltInPrincipals_H_
#define _BuiltInPrincipals_H_

BEGIN_NAMESPACE_NEX

/**
    \ingroup group_rdv_core_common
    \brief Namespace for enum BuiltInPrincipals.
*/
#ifdef SWIG
class BuiltInPrincipals
{
public:
#else
namespace BuiltInPrincipals
{
#endif

    /**
    \ingroup group_rdv_core_common
    \brief Enumerates the valid built-in PrincipalID s.
    \remarks PrincipalIDs ranging from 1 to 99 are reserved for Quazal processes and cannot be assigned by the
    developer. IDs above and including 100 can be assigned by the developer however, IDs from 100 to 999 are
    reserved for server processes.

    \note In order to access these types you must include the RendezVous.h file.
    \sa Principal, PrincipalID
    */
    enum BuiltInPrincipals
    {

        /**
        An invalid PrincipalID.
        */
        InvalidPID = 0,
        /** \internal */
        Authentication = 1,
        /**
        The Rendez-Vous daemon.
        */
        RendezVous = 2,
        SandboxManager = 3,
        /** \internal */
        Guest = 100,
        /** \internal */
        Administrator = 101,
        /** \internal */
        Eval = 102,
        /** \internal */
        SandboxProbe = 103,
        /** \internal */
        LobbyAdministrator = 104,
        /** \internal */
        Anonymous = 106,
        //{secret}
        BackgroundPlayerBegin = 110,
        //{secret}
        BackgroundPlayer0 = 110,
        //{secret}
        BackgroundPlayer1 = 111,
        //{secret}
        BackgroundPlayer2 = 112,
        //{secret}
        BackgroundPlayer3 = 113,
        //{secret}
        BackgroundPlayer4 = 114,
        //{secret}
        BackgroundPlayer5 = 115,
        //{secret}
        BackgroundPlayer6 = 116,
        //{secret}
        BackgroundPlayer7 = 117,
        //{secret}
        BackgroundPlayer8 = 118,
        //{secret}
        BackgroundPlayer9 = 119,
        //{secret}
        BackgroundPlayerEnd = 119,
        /**
        The first user-configurable account.
        */
        FirstUserAccount = 1000
    };
#ifdef SWIG
};
#else
}
#endif

END_NAMESPACE_NEX

#endif
