﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _ScriptErrors_H_
#define _ScriptErrors_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

////////////////////////////////////////////////////////////////////////////////
// IMPORTANT NOTE: Values of each element of the following enumeration must be
// specify so that translating this file for Python scripts works as expected.
// Also, the description of elements must use C-style /* */ comments where
// the opening and closing syntax must be on their own lines of code.
////////////////////////////////////////////////////////////////////////////////

BEGIN_NAMESPACE_NEX

/* Please see man pages for details */
#ifdef SWIG
class PythonCoreErrorCode
{
public:
#else
/* Please see man pages for details 
 
 */
namespace PythonCoreErrorCode
{
#endif
    /*
    \ingroup group_rdv_core_common
    \brief Enumerates the error codes that a call may return for the PythonCore facility.
    \remarks Details as to the cause of each ErrorCode are detailed in the documentation
    of each individual Rendez-Vous method that may return a result.
    */
    /* Please see man pages for details 
     
     */
    enum ErrorCode
    {
        /* Please see man pages for details 
        
        */
        Exception           = 1,    //
        /* Please see man pages for details 
        
        */
        TypeError           = 2,    //
        /* Please see man pages for details 
        
        */
        IndexError          = 3,    //
        /* Please see man pages for details 
        
        */
        InvalidReference    = 4,    //
        /* Please see man pages for details 
        
        */
        CallFailure         = 5,    //
        /* Please see man pages for details 
        
        */
        MemoryError         = 6,    //
        /* Please see man pages for details 
        
        */
        KeyError            = 7,    //
        /* Please see man pages for details 
        
        */
        OperationError      = 8,    //
        /* Please see man pages for details 
        
        */
        ConversionError     = 9,    //
        /* Please see man pages for details 
        
        */
        ValidationError     = 10     //

    };
    //Note: When adding new results, it is necessary to change NEX_QRESULT_TO_STR in OnlineCore/src/Platform/Core/Result.cpp.
#ifdef SWIG
};
#else
}
#endif

END_NAMESPACE_NEX

#endif // _ScriptErrors_H_
