﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _Data_H
#define _Data_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Core/src/Common/DataDDL.h>

BEGIN_NAMESPACE_NEX

class OSDK_API DDLCLASS(Data);
/*
\ingroup group_rdv_core_common
\brief This is the base class for custom data.
\remarks Any custom data classes or hierarchy of classes must be declared in the DDL file as inheriting from
this class. Before a custom Data class can be used it must first be registered via the AnyDataAdapter to ensure
that the derived class is correctly instantiated when required and that data is correctly streamed between a client
and the \productname back end. Refer to Custom Data for further details.
\sa Custom Data
*/

/* Please see man pages for details 
 
 */
class OSDK_API Data: public DDLCLASS(Data)
{
public:
    /* Please see man pages for details 
     
     */
    Data();
    /* Please see man pages for details 
     
     */
    virtual ~Data();
#ifdef OSDK_DLL_SUPPORT
    bool operator ==(const Data&other) const
    {
        return DDLCLASS(Data)::operator ==(other);
    }
    bool operator <(const Data&) const
    {
        // This is required for exporting STL containers of this type
        QLOG(EventLog::Error,_T("This operation is unimplemented. This is just to permit exporting Data-derived classes in the OSDK DLL."));
        SYSTEMCHECK(true);
        return true;
    }
#endif
#ifdef FOR_DOC_PURPOSE
    /* Please see man pages for details 
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     */
    static Data* DynamicCast(Data* pData)
    {
        // This method is provided by specific classes.
        SYSTEMCHECK(false);
        return NULL;
    }
    static const Data* DynamicCast(const Data* pData)
    {
        // This method is provided by specific classes.
        SYSTEMCHECK(false);
        return NULL;
    }
#endif
};

END_NAMESPACE_NEX

#endif
