#ifndef _Quazal_HealthProtocolDDL_H_
#define _Quazal_HealthProtocolDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(HealthProtocol, PingDaemon, 1 );
PROTO_DEFINE_RMCID(HealthProtocol, PingDatabase, 2 );
PROTO_DEFINE_RMCID(HealthProtocol, RunSanityCheck, 3 );
PROTO_DEFINE_RMCID(HealthProtocol, FixSanityErrors, 4 );
PROTO_DEFINE_NUM_RMC(HealthProtocol, 4);

class HealthProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(bool) TPingDaemon_result;
        PROTO_RMCIMPL_RETURN(HealthProtocol, PingDaemon)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPingDaemon_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TPingDatabase_result;
        PROTO_RMCIMPL_RETURN(HealthProtocol, PingDatabase)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPingDatabase_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TRunSanityCheck_result;
        PROTO_RMCIMPL_RETURN(HealthProtocol, RunSanityCheck)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRunSanityCheck_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TFixSanityErrors_result;
        PROTO_RMCIMPL_RETURN(HealthProtocol, FixSanityErrors)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFixSanityErrors_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        HealthProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew HealthProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallPingDaemon(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn);
        static qBool PingDaemon_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn);
        qBool CallPingDatabase(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn);
        static qBool PingDatabase_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn);
        qBool CallRunSanityCheck(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn);
        static qBool RunSanityCheck_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn);
        qBool CallFixSanityErrors(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn);
        static qBool FixSanityErrors_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(HealthProtocol) + 1];
};

class DDLPROTOCOL(HealthProtocolServer) : public ServerProtocol {
    public:
        typedef DDLTYPE(bool) TPingDaemon_result;
        PROTO_RMCIMPL_STUB(HealthProtocol, PingDaemon)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(bool)::CPPType __result=pProtocol->PingDaemon(  );
            PROTO_PREPARE_RETURN(HealthProtocol,PingDaemon);
            _MSG_ADD_VARIABLE(TPingDaemon_result,__result);
        }
        
        typedef DDLTYPE(bool) TPingDatabase_result;
        PROTO_RMCIMPL_STUB(HealthProtocol, PingDatabase)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(bool)::CPPType __result=pProtocol->PingDatabase(  );
            PROTO_PREPARE_RETURN(HealthProtocol,PingDatabase);
            _MSG_ADD_VARIABLE(TPingDatabase_result,__result);
        }
        
        typedef DDLTYPE(bool) TRunSanityCheck_result;
        PROTO_RMCIMPL_STUB(HealthProtocol, RunSanityCheck)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(bool)::CPPType __result=pProtocol->RunSanityCheck(  );
            PROTO_PREPARE_RETURN(HealthProtocol,RunSanityCheck);
            _MSG_ADD_VARIABLE(TRunSanityCheck_result,__result);
        }
        
        typedef DDLTYPE(bool) TFixSanityErrors_result;
        PROTO_RMCIMPL_STUB(HealthProtocol, FixSanityErrors)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(bool)::CPPType __result=pProtocol->FixSanityErrors(  );
            PROTO_PREPARE_RETURN(HealthProtocol,FixSanityErrors);
            _MSG_ADD_VARIABLE(TFixSanityErrors_result,__result);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual DDLTYPE(bool)::CPPType PingDaemon() = 0;
        virtual DDLTYPE(bool)::CPPType PingDatabase() = 0;
        virtual DDLTYPE(bool)::CPPType RunSanityCheck() = 0;
        virtual DDLTYPE(bool)::CPPType FixSanityErrors() = 0;
    };


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_HealthProtocolDDL.h_H_
