#ifndef _Quazal_LoginDataDDL_H_
#define _Quazal_LoginDataDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "RendezVous/Core/src/Common/ProtocolFoundationProperties.h"
#include "RendezVous/Core/src/Common/Data.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX
class LoginData;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(LoginData): public Data {
public:
    DDLCLASS(LoginData)():_mRevision_LoginData(0)
     {};
    DDLCLASS(LoginData)(const DDLCLASS(LoginData) &oOther):
        Data(oOther),
        _mRevision_LoginData(oOther._mRevision_LoginData),
        m_principalType(oOther.m_principalType),
        m_userName(oOther.m_userName),
        m_context(oOther.m_context),
        m_similarConnection(oOther.m_similarConnection)
    {
    }
    virtual ~DDLCLASS(LoginData)() {};
    const DDLCLASS(LoginData) &operator=(const DDLCLASS(LoginData) &oOther);
    qBool operator==(const DDLCLASS(LoginData) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(LoginData) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(LoginData) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(LoginData) *pValue);
    qByte _mRevision_LoginData;
    qByte GetClassRevision_LoginData() const {return _mRevision_LoginData;}
    void SetClassRevision_LoginData(qByte revision) {_mRevision_LoginData=revision;}
    static qByte GetKnownMaxClassRevision_LoginData() {return 0;}
    DDLTYPE(int8)::CPPType m_principalType;
    NEX_CLASS_VALID_REVISION_DEF(m_principalType, 0);
    qBool NEX_CLASS_ISVALID(m_principalType) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType m_userName;
    NEX_CLASS_VALID_REVISION_DEF(m_userName, 0);
    qBool NEX_CLASS_ISVALID(m_userName) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint64)::CPPType m_context;
    NEX_CLASS_VALID_REVISION_DEF(m_context, 0);
    qBool NEX_CLASS_ISVALID(m_context) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_similarConnection;
    NEX_CLASS_VALID_REVISION_DEF(m_similarConnection, 0);
    qBool NEX_CLASS_ISVALID(m_similarConnection) const { return true; /* The revision is 0. Always true */}
    public:
	_PR_dataclass_methods_pudecl(LoginData)
    protected:
	_PR_dataclass_methods_prdecl()
};


class DDLTYPE(LoginData): public DDLType {
public:
    typedef LoginData CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(LoginData)& oLoginData) {
        DDLCLASS(LoginData)::Add(pMessageToSend,oLoginData);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(LoginData)* pLoginDataToRefresh) {
        DDLCLASS(LoginData)::Extract(pReceivedMessage,pLoginDataToRefresh);
    }
};

class LoginData: public DDLCLASS(LoginData) {
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_LoginDataDDL.h_H_
