﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _ResultRangeDefs_H
#define _ResultRangeDefs_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

/*
@{
    \ingroup group_rdv_core_common
    \brief Defines the default ResultRange size, which by default is equal to 20.
*/
/* Please see man pages for details 
 
 */
#define RESULTRANGE_DEFAULT_SIZE        20

/*
    \brief Defines a pseudo random ResultRange offset.
    \remarks When this offset is set, \productname uses a pseudo random offset when returning
    the ResultRange.
*/
/* Please see man pages for details 
 

 
 
 */
#define RESULTRANGE_ANY_OFFSET          0xFFFFFFFFUL

END_NAMESPACE_NEX

#endif

