#ifndef _Quazal_TicketGrantingProtocolDDL_H_
#define _Quazal_TicketGrantingProtocolDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "RVConnectionDataDDL.h"
#include "RendezVous/Core/src/Common/ProtocolFoundationTypes.h"
#include "RendezVous/Core/src/Common/Data.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(TicketGrantingProtocol, Login, 1 );
PROTO_DEFINE_RMCID(TicketGrantingProtocol, LoginEx, 2 );
PROTO_DEFINE_RMCID(TicketGrantingProtocol, RequestTicket, 3 );
PROTO_DEFINE_RMCID(TicketGrantingProtocol, GetPID, 4 );
PROTO_DEFINE_RMCID(TicketGrantingProtocol, GetName, 5 );
PROTO_DEFINE_RMCID(TicketGrantingProtocol, LoginWithContext, 6 );
PROTO_DEFINE_NUM_RMC(TicketGrantingProtocol, 6);

class TicketGrantingProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(qresult) TLogin_result;
        typedef DDLTYPE(string) TLogin_strUserName;
        typedef DDLTYPE(uint32) TLogin_pidPrincipal;
        typedef DDLTYPE(buffer) TLogin_pbufResponse;
        typedef CLASSMETATYPE(RVConnectionData) TLogin_pConnectionData;
        typedef DDLTYPE(string) TLogin_strReturnMsg;
        PROTO_RMCIMPL_RETURN(TicketGrantingProtocol, Login)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TLogin_result,1);
            _DO_RMC_ExtractReturnValue(TLogin_pidPrincipal,1);
            _DO_RMC_ExtractReturnValue(TLogin_pbufResponse,1);
            _DO_RMC_ExtractReturnValue(TLogin_pConnectionData,1);
            _DO_RMC_ExtractReturnValue(TLogin_strReturnMsg,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qresult) TLoginEx_result;
        typedef DDLTYPE(string) TLoginEx_strUserName;
        typedef DDLTYPE(uint32) TLoginEx_pidPrincipal;
        typedef DDLTYPE(buffer) TLoginEx_pbufResponse;
        typedef CLASSMETATYPE(RVConnectionData) TLoginEx_pConnectionData;
        typedef DDLTYPE(string) TLoginEx_strReturnMsg;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TLoginEx_oExtraData;
        PROTO_RMCIMPL_RETURN(TicketGrantingProtocol, LoginEx)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TLoginEx_result,1);
            _DO_RMC_ExtractReturnValue(TLoginEx_pidPrincipal,1);
            _DO_RMC_ExtractReturnValue(TLoginEx_pbufResponse,1);
            _DO_RMC_ExtractReturnValue(TLoginEx_pConnectionData,1);
            _DO_RMC_ExtractReturnValue(TLoginEx_strReturnMsg,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qresult) TRequestTicket_result;
        typedef DDLTYPE(uint32) TRequestTicket_idSource;
        typedef DDLTYPE(uint32) TRequestTicket_idTarget;
        typedef DDLTYPE(buffer) TRequestTicket_bufResponse;
        PROTO_RMCIMPL_RETURN(TicketGrantingProtocol, RequestTicket)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRequestTicket_result,1);
            _DO_RMC_ExtractReturnValue(TRequestTicket_bufResponse,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetPID_result;
        typedef DDLTYPE(string) TGetPID_strUserName;
        PROTO_RMCIMPL_RETURN(TicketGrantingProtocol, GetPID)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPID_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TGetName_result;
        typedef DDLTYPE(uint32) TGetName_id;
        PROTO_RMCIMPL_RETURN(TicketGrantingProtocol, GetName)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetName_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qresult) TLoginWithContext_result;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TLoginWithContext_loginData;
        typedef DDLTYPE(uint32) TLoginWithContext_pidPrincipal;
        typedef DDLTYPE(buffer) TLoginWithContext_pbufResponse;
        typedef CLASSMETATYPE(RVConnectionData) TLoginWithContext_pConnectionData;
        PROTO_RMCIMPL_RETURN(TicketGrantingProtocol, LoginWithContext)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TLoginWithContext_result,1);
            _DO_RMC_ExtractReturnValue(TLoginWithContext_pidPrincipal,1);
            _DO_RMC_ExtractReturnValue(TLoginWithContext_pbufResponse,1);
            _DO_RMC_ExtractReturnValue(TLoginWithContext_pConnectionData,1);
            PROTO_RETURNSTUB_END();
        };
        
        TicketGrantingProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew TicketGrantingProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallLogin(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strUserName, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData, DDLTYPE(string)::CPPType* strReturnMsg);
        static qBool Login_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strUserName, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData, DDLTYPE(string)::CPPType* strReturnMsg);
        qBool CallLoginEx(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strUserName, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData, DDLTYPE(string)::CPPType* strReturnMsg, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oExtraData);
        static qBool LoginEx_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strUserName, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData, DDLTYPE(string)::CPPType* strReturnMsg, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oExtraData);
        qBool CallRequestTicket(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idSource, const DDLTYPE(uint32)::CPPType& idTarget, DDLTYPE(buffer)::CPPType* bufResponse);
        static qBool RequestTicket_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idSource, const DDLTYPE(uint32)::CPPType& idTarget, DDLTYPE(buffer)::CPPType* bufResponse);
        qBool CallGetPID(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strUserName);
        static qBool GetPID_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strUserName);
        qBool CallGetName(ProtocolCallContext *pContext, DDLTYPE(string)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& id);
        static qBool GetName_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(string)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& id);
        qBool CallLoginWithContext(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& loginData, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData);
        static qBool LoginWithContext_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& loginData, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(TicketGrantingProtocol) + 1];
};

class DDLPROTOCOL(TicketGrantingProtocolServer) : public ServerProtocol {
    public:
        typedef DDLTYPE(qresult) TLogin_result;
        typedef DDLTYPE(string) TLogin_strUserName;
        typedef DDLTYPE(uint32) TLogin_pidPrincipal;
        typedef DDLTYPE(buffer) TLogin_pbufResponse;
        typedef CLASSMETATYPE(RVConnectionData) TLogin_pConnectionData;
        typedef DDLTYPE(string) TLogin_strReturnMsg;
        PROTO_RMCIMPL_STUB(TicketGrantingProtocol, Login)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strUserName;
            _MSG_EXTRACT_VARIABLE(TLogin_strUserName, strUserName);
            DDLTYPE(uint32)::CPPType pidPrincipal;
            DDLTYPE(buffer)::CPPType pbufResponse;
            RVConnectionData pConnectionData;
            DDLTYPE(string)::CPPType strReturnMsg;
            DDLTYPE(qresult)::CPPType __result=pProtocol->Login( strUserName, &pidPrincipal, &pbufResponse, &pConnectionData, &strReturnMsg );
            PROTO_PREPARE_RETURN(TicketGrantingProtocol,Login);
            _MSG_ADD_VARIABLE(TLogin_result,__result);
            _MSG_ADD_VARIABLE(TLogin_pidPrincipal, pidPrincipal);
            _MSG_ADD_VARIABLE(TLogin_pbufResponse, pbufResponse);
            _MSG_ADD_VARIABLE(TLogin_pConnectionData, pConnectionData);
            _MSG_ADD_VARIABLE(TLogin_strReturnMsg, strReturnMsg);
        }
        
        typedef DDLTYPE(qresult) TLoginEx_result;
        typedef DDLTYPE(string) TLoginEx_strUserName;
        typedef DDLTYPE(uint32) TLoginEx_pidPrincipal;
        typedef DDLTYPE(buffer) TLoginEx_pbufResponse;
        typedef CLASSMETATYPE(RVConnectionData) TLoginEx_pConnectionData;
        typedef DDLTYPE(string) TLoginEx_strReturnMsg;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TLoginEx_oExtraData;
        PROTO_RMCIMPL_STUB(TicketGrantingProtocol, LoginEx)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strUserName;
            _MSG_EXTRACT_VARIABLE(TLoginEx_strUserName, strUserName);
            DDLTYPE(uint32)::CPPType pidPrincipal;
            DDLTYPE(buffer)::CPPType pbufResponse;
            RVConnectionData pConnectionData;
            DDLTYPE(string)::CPPType strReturnMsg;
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oExtraData;
            _MSG_EXTRACT_VARIABLE(TLoginEx_oExtraData, oExtraData);
            DDLTYPE(qresult)::CPPType __result=pProtocol->LoginEx( strUserName, &pidPrincipal, &pbufResponse, &pConnectionData, &strReturnMsg, oExtraData );
            PROTO_PREPARE_RETURN(TicketGrantingProtocol,LoginEx);
            _MSG_ADD_VARIABLE(TLoginEx_result,__result);
            _MSG_ADD_VARIABLE(TLoginEx_pidPrincipal, pidPrincipal);
            _MSG_ADD_VARIABLE(TLoginEx_pbufResponse, pbufResponse);
            _MSG_ADD_VARIABLE(TLoginEx_pConnectionData, pConnectionData);
            _MSG_ADD_VARIABLE(TLoginEx_strReturnMsg, strReturnMsg);
        }
        
        typedef DDLTYPE(qresult) TRequestTicket_result;
        typedef DDLTYPE(uint32) TRequestTicket_idSource;
        typedef DDLTYPE(uint32) TRequestTicket_idTarget;
        typedef DDLTYPE(buffer) TRequestTicket_bufResponse;
        PROTO_RMCIMPL_STUB(TicketGrantingProtocol, RequestTicket)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idSource;
            _MSG_EXTRACT_VARIABLE(TRequestTicket_idSource, idSource);
            DDLTYPE(uint32)::CPPType idTarget;
            _MSG_EXTRACT_VARIABLE(TRequestTicket_idTarget, idTarget);
            DDLTYPE(buffer)::CPPType bufResponse;
            DDLTYPE(qresult)::CPPType __result=pProtocol->RequestTicket( idSource, idTarget, &bufResponse );
            PROTO_PREPARE_RETURN(TicketGrantingProtocol,RequestTicket);
            _MSG_ADD_VARIABLE(TRequestTicket_result,__result);
            _MSG_ADD_VARIABLE(TRequestTicket_bufResponse, bufResponse);
        }
        
        typedef DDLTYPE(uint32) TGetPID_result;
        typedef DDLTYPE(string) TGetPID_strUserName;
        PROTO_RMCIMPL_STUB(TicketGrantingProtocol, GetPID)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strUserName;
            _MSG_EXTRACT_VARIABLE(TGetPID_strUserName, strUserName);
            DDLTYPE(uint32)::CPPType __result=pProtocol->GetPID( strUserName );
            PROTO_PREPARE_RETURN(TicketGrantingProtocol,GetPID);
            _MSG_ADD_VARIABLE(TGetPID_result,__result);
        }
        
        typedef DDLTYPE(string) TGetName_result;
        typedef DDLTYPE(uint32) TGetName_id;
        PROTO_RMCIMPL_STUB(TicketGrantingProtocol, GetName)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType id;
            _MSG_EXTRACT_VARIABLE(TGetName_id, id);
            DDLTYPE(string)::CPPType __result=pProtocol->GetName( id );
            PROTO_PREPARE_RETURN(TicketGrantingProtocol,GetName);
            _MSG_ADD_VARIABLE(TGetName_result,__result);
        }
        
        typedef DDLTYPE(qresult) TLoginWithContext_result;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TLoginWithContext_loginData;
        typedef DDLTYPE(uint32) TLoginWithContext_pidPrincipal;
        typedef DDLTYPE(buffer) TLoginWithContext_pbufResponse;
        typedef CLASSMETATYPE(RVConnectionData) TLoginWithContext_pConnectionData;
        PROTO_RMCIMPL_STUB(TicketGrantingProtocol, LoginWithContext)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType loginData;
            _MSG_EXTRACT_VARIABLE(TLoginWithContext_loginData, loginData);
            DDLTYPE(uint32)::CPPType pidPrincipal;
            DDLTYPE(buffer)::CPPType pbufResponse;
            RVConnectionData pConnectionData;
            DDLTYPE(qresult)::CPPType __result=pProtocol->LoginWithContext( loginData, &pidPrincipal, &pbufResponse, &pConnectionData );
            PROTO_PREPARE_RETURN(TicketGrantingProtocol,LoginWithContext);
            _MSG_ADD_VARIABLE(TLoginWithContext_result,__result);
            _MSG_ADD_VARIABLE(TLoginWithContext_pidPrincipal, pidPrincipal);
            _MSG_ADD_VARIABLE(TLoginWithContext_pbufResponse, pbufResponse);
            _MSG_ADD_VARIABLE(TLoginWithContext_pConnectionData, pConnectionData);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual DDLTYPE(qresult)::CPPType Login(const DDLTYPE(string)::CPPType& strUserName, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData, DDLTYPE(string)::CPPType* strReturnMsg) = 0;
        virtual DDLTYPE(qresult)::CPPType LoginEx(const DDLTYPE(string)::CPPType& strUserName, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData, DDLTYPE(string)::CPPType* strReturnMsg, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oExtraData) = 0;
        virtual DDLTYPE(qresult)::CPPType RequestTicket(const DDLTYPE(uint32)::CPPType& idSource, const DDLTYPE(uint32)::CPPType& idTarget, DDLTYPE(buffer)::CPPType* bufResponse) = 0;
        virtual DDLTYPE(uint32)::CPPType GetPID(const DDLTYPE(string)::CPPType& strUserName) = 0;
        virtual DDLTYPE(string)::CPPType GetName(const DDLTYPE(uint32)::CPPType& id) = 0;
        virtual DDLTYPE(qresult)::CPPType LoginWithContext(const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& loginData, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData) = 0;
    };


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_TicketGrantingProtocolDDL.h_H_
