#ifndef _Quazal_UserMessageDDL_H_
#define _Quazal_UserMessageDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "ProtocolFoundationProperties.h"
#include "Data.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX
class UserMessage;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class OSDK_API DDLCLASS(UserMessage): public Data {
public:
    DDLCLASS(UserMessage)():_mRevision_UserMessage(0)
     {};
    DDLCLASS(UserMessage)(const DDLCLASS(UserMessage) &oOther):
        Data(oOther),
        _mRevision_UserMessage(oOther._mRevision_UserMessage),
        m_uiID(oOther.m_uiID),
        m_idRecipient(oOther.m_idRecipient),
        m_uiRecipientType(oOther.m_uiRecipientType),
        m_uiParentID(oOther.m_uiParentID),
        m_pidSender(oOther.m_pidSender),
        m_receptiontime(oOther.m_receptiontime),
        m_uiLifeTime(oOther.m_uiLifeTime),
        m_uiFlags(oOther.m_uiFlags),
        m_strSubject(oOther.m_strSubject),
        m_strSender(oOther.m_strSender)
    {
    }
    virtual ~DDLCLASS(UserMessage)() {};
    const DDLCLASS(UserMessage) &operator=(const DDLCLASS(UserMessage) &oOther);
    qBool operator==(const DDLCLASS(UserMessage) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(UserMessage) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(UserMessage) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(UserMessage) *pValue);
    qByte _mRevision_UserMessage;
    qByte GetClassRevision_UserMessage() const {return _mRevision_UserMessage;}
    void SetClassRevision_UserMessage(qByte revision) {_mRevision_UserMessage=revision;}
    static qByte GetKnownMaxClassRevision_UserMessage() {return 0;}
    DDLTYPE(uint32)::CPPType m_uiID;
    NEX_CLASS_VALID_REVISION_DEF(m_uiID, 0);
    qBool NEX_CLASS_ISVALID(m_uiID) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_idRecipient;
    NEX_CLASS_VALID_REVISION_DEF(m_idRecipient, 0);
    qBool NEX_CLASS_ISVALID(m_idRecipient) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_uiRecipientType;
    NEX_CLASS_VALID_REVISION_DEF(m_uiRecipientType, 0);
    qBool NEX_CLASS_ISVALID(m_uiRecipientType) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_uiParentID;
    NEX_CLASS_VALID_REVISION_DEF(m_uiParentID, 0);
    qBool NEX_CLASS_ISVALID(m_uiParentID) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_pidSender;
    NEX_CLASS_VALID_REVISION_DEF(m_pidSender, 0);
    qBool NEX_CLASS_ISVALID(m_pidSender) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(datetime)::CPPType m_receptiontime;
    NEX_CLASS_VALID_REVISION_DEF(m_receptiontime, 0);
    qBool NEX_CLASS_ISVALID(m_receptiontime) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_uiLifeTime;
    NEX_CLASS_VALID_REVISION_DEF(m_uiLifeTime, 0);
    qBool NEX_CLASS_ISVALID(m_uiLifeTime) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_uiFlags;
    NEX_CLASS_VALID_REVISION_DEF(m_uiFlags, 0);
    qBool NEX_CLASS_ISVALID(m_uiFlags) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType m_strSubject;
    NEX_CLASS_VALID_REVISION_DEF(m_strSubject, 0);
    qBool NEX_CLASS_ISVALID(m_strSubject) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType m_strSender;
    NEX_CLASS_VALID_REVISION_DEF(m_strSender, 0);
    qBool NEX_CLASS_ISVALID(m_strSender) const { return true; /* The revision is 0. Always true */}
    public:
	_PR_dataclass_methods_pudecl(UserMessage)
    protected:
	_PR_dataclass_methods_prdecl()
};


class DDLTYPE(UserMessage): public DDLType {
public:
    typedef UserMessage CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(UserMessage)& oUserMessage) {
        DDLCLASS(UserMessage)::Add(pMessageToSend,oUserMessage);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(UserMessage)* pUserMessageToRefresh) {
        DDLCLASS(UserMessage)::Extract(pReceivedMessage,pUserMessageToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_UserMessageDDL.h_H_
