﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef DATASTORE_EVENT_LISTENER_H__
#define DATASTORE_EVENT_LISTENER_H__

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Services/Jugem/DataStore/src/Common/DataStoreConstants.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    

        
*/

#ifdef FOR_DOC_PURPOSE
class DataStoreGetObjectEventListener
#else
template<class TDataId>
class DataStoreGetObjectEventListenerTemplate
#endif  // FOR_DOC_PURPOSE
{
public:
#ifdef FOR_DOC_PURPOSE
    /* Please see man pages for details 
        
    */
    DataStoreGetObjectEventListener() {}
#else
    DataStoreGetObjectEventListenerTemplate() {}
#endif  // FOR_DOC_PURPOSE

#ifdef FOR_DOC_PURPOSE
    /* Please see man pages for details 
        
    */
    virtual ~DataStoreGetObjectEventListener() {}
#else
    virtual ~DataStoreGetObjectEventListenerTemplate() {}
#endif  // FOR_DOC_PURPOSE

    /* Please see man pages for details 
        
        

            
            

        
        
        
        
        
        
    */
    virtual void BeginInternal(TDataId dataId, qUnsignedInt32 size, qUnsignedInt32 ownerId, qUnsignedInt16 dataType, qUnsignedInt16 version, qBool isStorageServer)
    {
        (void)dataId;
        (void)size;
        (void)ownerId;
        (void)dataType;
        (void)version;
        (void)isStorageServer;
    }

#ifdef FOR_DOC_PURPOSE
    /* Please see man pages for details 
        

            

        
        
    */
    virtual void Begin(qUnsignedInt64 dataId, qUnsignedInt32 size)
#else
    virtual void Begin(TDataId dataId, qUnsignedInt32 size)
#endif  // FOR_DOC_PURPOSE
    {
        (void)dataId;
        (void)size;
    };

    /* Please see man pages for details 
        

            
            
            

        
        

        
                
                
    */
    virtual qBool ProcessResponse(const void* buffer, qUnsignedInt32 bufferSize) = 0;
};


typedef DataStoreGetObjectEventListenerTemplate<qUnsignedInt32> DataStoreGetObjectEventListenerV1;
typedef DataStoreGetObjectEventListenerTemplate<qUnsignedInt64> DataStoreGetObjectEventListener;

/* Please see man pages for details 
    

        
*/
class DataStorePostObjectEventListener
{
public:
    /* Please see man pages for details 
        
    */
    DataStorePostObjectEventListener() {}

    /* Please see man pages for details 
        
    */
    virtual ~DataStorePostObjectEventListener() {}

    /* Please see man pages for details 
        

            
            
            
            
            
            

        
        
        

        
    */
    virtual qUnsignedInt32 PostChunkedBuffer(void* buffer, qUnsignedInt32 bufferSize, qBool* completed) = 0;
};

/* Please see man pages for details 
    
    

        
*/
#ifdef FOR_DOC_PURPOSE
class DataStoreReceiveNewArrivedObjectsEventListener
#else
template<class TDataId>
class DataStoreReceiveNewArrivedObjectsEventListenerTemplate
#endif  // FOR_DOC_PURPOSE
{
public:
#ifdef FOR_DOC_PURPOSE
    /* Please see man pages for details 
        
    */
    DataStoreReceiveNewArrivedObjectsEventListener() {}
#else
    DataStoreReceiveNewArrivedObjectsEventListenerTemplate() {}
#endif  // FOR_DOC_PURPOSE

#ifdef FOR_DOC_PURPOSE
    /* Please see man pages for details 
        
    */
    virtual ~DataStoreReceiveNewArrivedObjectsEventListener() {}
#else
    virtual ~DataStoreReceiveNewArrivedObjectsEventListenerTemplate() {}
#endif  // FOR_DOC_PURPOSE

#ifdef FOR_DOC_PURPOSE
    /* Please see man pages for details 
        

            

        
        
        
        
        
                           
                           
        
                                  
                                  
    */
    virtual void PrepareNextDownload(qUnsignedInt64 dataId,
                                     qUnsignedInt32 size,
                                     qUnsignedInt32 ownerId,
                                     qUnsignedInt16 dataType,
                                     qUnsignedInt32 version,
                                     qUnsignedInt64 notificationId)
#else
    virtual void PrepareNextDownload(TDataId dataId,
                                     qUnsignedInt32 size,
                                     qUnsignedInt32 ownerId,
                                     qUnsignedInt16 dataType,
                                     qUnsignedInt32 version,
                                     qUnsignedInt64 notificationId)
#endif  // FOR_DOC_PURPOSE
    {
        (void)dataId;
        (void)size;
        (void)ownerId;
        (void)dataType;
        (void)version;
        (void)notificationId;
    }

#ifdef FOR_DOC_PURPOSE
    /* Please see man pages for details 
        

            
            
            
            
            
            
            

        
        
                                         
        
    */
    virtual void TokenUpdated(const qByte newArrivalCheckToken[DataStoreConstants::NEW_ARRIVAL_CHECK_TOKEN_SIZE],
                              DataStoreGetObjectEventListener* getObjectEventListener,
                              qUnsignedInt64 notificationId) = 0;
#else
    virtual void TokenUpdated(const qByte newArrivalCheckToken[DataStoreConstants::NEW_ARRIVAL_CHECK_TOKEN_SIZE],
                              DataStoreGetObjectEventListenerTemplate<TDataId>* getObjectEventListener,
                              qUnsignedInt64 notificationId) = 0;
#endif  // FOR_DOC_PURPOSE
};

typedef DataStoreReceiveNewArrivedObjectsEventListenerTemplate<qUnsignedInt32> DataStoreReceiveNewArrivedObjectsEventListenerV1;
typedef DataStoreReceiveNewArrivedObjectsEventListenerTemplate<qUnsignedInt64> DataStoreReceiveNewArrivedObjectsEventListener;

END_NAMESPACE_NEX

#endif // DATASTORE_EVENT_LISTENER_H__
