/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DATA_STORE_CONSTANTS_INTERNAL_H
#define _DATA_STORE_CONSTANTS_INTERNAL_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

namespace DataStoreConstants
{
// The token string for skipping authentication for debugging.
static const qChar SKIP_TOKEN_STRING[] = _T("skiptoken");

// The normal token string when authentication is not skipped.
static const qChar NORMAL_TOKEN_STRING[] = _T("normaltoken");

// The signature's minimal key length used by HPP. When the key is given by a string, twice this value is needed.
static const qUnsignedInt32 MINIMUM_KEY_SIZE = 8;

// An invalid notification URL. If this URL is specified for CheckNotification, the URL will forcibly be re-acquired.
static const qChar INVALID_NOTIFICATION_URL[] = _T("invalidurl");
}

END_NAMESPACE_NEX

#endif
