﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _NEX_DATASTOREDATACODE_H
#define _NEX_DATASTOREDATACODE_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX


/* Please see man pages for details 
    

    
    

*/
class DataStoreDataCode : public RootObject
{
private:
    DataStoreDataCode();

    qUnsignedInt64 m_dataCodeRaw;
    qBool m_isValid;

public:
    /* Please see man pages for details 
        

        

        
        

        

        
     */
    static DataStoreDataCode CreateFromDataId(const String& key, qUnsignedInt64 dataId);

    /* Please see man pages for details 
        

        
        

        

        
        

        

        
     */
    static DataStoreDataCode CreateFromDataCodeString(const String& key, const String& dataCodeString);


    /* Please see man pages for details 
        

        


        
        

        

        
     */
    static DataStoreDataCode CreateFromDataCodeRaw(const String& key, qUnsignedInt64 dataCodeRaw);

    /* Please see man pages for details 
        

        

        

    */
    qUnsignedInt64 GetDataId();

    /* Please see man pages for details 
        

            
            

            

        

        
     */
    String ToDataCodeString();

    /* Please see man pages for details 
        

            
            

            

        

        
     */
    String ToDataCodeStringZeroPad();

    /* Please see man pages for details 
        

        

        

        

        
     */
    qUnsignedInt64 GetDataCodeRaw()
    {
        return m_dataCodeRaw;
    }

    /* Please see man pages for details 
        
               

        
        

        
        
     */
    qBool IsValid()
    {
        return m_isValid;
    }

};


END_NAMESPACE_NEX

#endif
