﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef DATASTORE_ERRORS_H__
#define DATASTORE_ERRORS_H__

BEGIN_NAMESPACE_NEX

#ifdef SWIG
class DataStoreErrorCode
{
public:
#else
/* Please see man pages for details 
    
*/
namespace DataStoreErrorCode
{
#endif
    /* Please see man pages for details 
        
    */
    enum ErrorCode
    {
        Unknown                     =  1,  //
        InvalidArgument             =  2,  //
        PermissionDenied            =  3,  //
        NotFound                    =  4,  //
        AlreadyLocked               =  5,  //
        UnderReviewing              =  6,  //
        Expired                     =  7,  //
        InvalidCheckToken           =  8,  //
        SystemFileError             =  9,  //
        OverCapacity                = 10,  //
        OperationNotAllowed         = 11,  //
        InvalidPassword             = 12,  //
        ValueNotEqual               = 13   //
    };
    //70-99 is a reserved region for custom applications.
    
    //See operations done when adding error codes to the wiki.
    //If the errors the application should handle have increased, add them to the list of errors the application should handle in the`overall.rst` of the `common manual.`

#ifdef SWIG
};
#else
}
#endif

END_NAMESPACE_NEX

#endif // DATASTORE_ERRORS_H__
