/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DATA_STORE_GET_META_PARAM_H
#define _DATA_STORE_GET_META_PARAM_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStoreGetMetaParamDDL.h"
#include "DataStorePersistenceTarget.h"
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class DataStoreGetMetaParam: public DDLCLASS(DataStoreGetMetaParam)
{
public:
    /* Please see man pages for details 
        
    */
    DataStoreGetMetaParam()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~DataStoreGetMetaParam() {}

    /* Please see man pages for details 
        

            
            

        
    */
    void SetDataId(qUnsignedInt64 dataId)
    {
        SYSTEMCHECK(persistenceTarget == DataStorePersistenceTarget() && "PersistenceTarget is already set. Please specify either DataID or PersistenceTarget");
        this->dataId = dataId;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetDataId() const
    {
        return this->dataId;
    }

    /* Please see man pages for details 
        

            
            

        
    */
    void SetPersistenceTarget(DataStorePersistenceTarget persistenceTarget)
    {
        SYSTEMCHECK(dataId == DataStoreConstants::INVALID_DATAID && "DataID is already set. Please specify either DataID or PersistenceTarget");
        this->persistenceTarget = persistenceTarget;
    }

    /* Please see man pages for details 
        

        
    */
    const DataStorePersistenceTarget& GetPersistenceTarget() const
    {
        return this->persistenceTarget;
    }

    /* Please see man pages for details 
        

            
            

        
    */
    void SetResultOption(qUnsignedInt32 resultOption)
    {
        this->resultOption = static_cast<qByte>(resultOption);
    }

    /* Please see man pages for details 
        

        
    */
    qByte GetResultOption() const
    {
        return this->resultOption;
    }

    /* Please see man pages for details 
        

            
            
            
            
            

        
    */
    void SetAccessPassword(qUnsignedInt64 accessPassword)
    {
        this->accessPassword = accessPassword;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetAccessPassword() const
    {
        return this->accessPassword;
    }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        dataId = DataStoreConstants::INVALID_DATAID;
        persistenceTarget = DataStorePersistenceTarget();
        SetResultOption(0);
        SetAccessPassword(DataStoreConstants::INVALID_PASSWORD);
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, _T("DataStoreGetMetaParam: (")
               << _T("dataId=") << dataId
               << _T(", resultOption=") << resultOption
               << _T(", persistenceTarget") << persistenceTarget
               << _T(", accessPassword=") << accessPassword
               << _T(")")
              );
    }
};

END_NAMESPACE_NEX

#endif
