﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DATA_STORE_PASSWORD_INFO_H
#define _DATA_STORE_PASSWORD_INFO_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStorePasswordInfoDDL.h"
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class DataStorePasswordInfo: public DDLCLASS(DataStorePasswordInfo)
{
public:
    /* Please see man pages for details 
        
    */
    DataStorePasswordInfo()
    {
        // When the user generates this class, IsValid function will return false.
        dataId = DataStoreConstants::INVALID_DATAID;
    }

    /* Please see man pages for details 
        
    */
    virtual ~DataStorePasswordInfo() {}

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetDataId() const
    {
        return this->dataId;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetAccessPassword() const
    {
        return this->accessPassword;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetUpdatePassword() const
    {
        return this->updatePassword;
    }

    /* Please see man pages for details 
        

        

        
    */
    qBool IsValid() const
    {
        return dataId != DataStoreConstants::INVALID_DATAID;
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, _T("DataStorePasswordInfo: (")
               << _T("dataId=") << dataId
               << _T(", accessPassword=") << accessPassword
               << _T(", updatePassword=") << updatePassword
               << _T(")")
              );
    }
};

END_NAMESPACE_NEX

#endif
