/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DATA_STORE_PERSISTENCE_INIT_PARAM_H
#define _DATA_STORE_PERSISTENCE_INIT_PARAM_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStorePersistenceInitParamDDL.h"
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class DataStorePersistenceInitParam: public DDLCLASS(DataStorePersistenceInitParam)
{
public:
    /* Please see man pages for details 
        

            
            
            

        
        
    */
    explicit DataStorePersistenceInitParam(qUnsignedInt16 persistenceSlotId = DataStoreConstants::INVALID_PERSISTENCE_SLOT_ID, qBool deleteLastObject = true)
    {
        SetPersistenceSlotId(persistenceSlotId);
        SetDeleteLastObject(deleteLastObject);
    }

    /* Please see man pages for details 
        
    */
    virtual ~DataStorePersistenceInitParam() {}


    /* Please see man pages for details 
        

            
            

        
    */
    void SetPersistenceSlotId(qUnsignedInt16 persistenceSlotId)
    {
        this->persistenceSlotId = persistenceSlotId;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt16 GetPersistenceSlotId() const
    {
        return this->persistenceSlotId;
    }

    /* Please see man pages for details 
        

            

        
    */
    void SetDeleteLastObject(qBool deleteLastObject)
    {
        this->deleteLastObject = deleteLastObject;
    }

    /* Please see man pages for details 
        

        
    */
    qBool GetDeleteLastObject() const
    {
        return this->deleteLastObject;
    }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        SetPersistenceSlotId(DataStoreConstants::INVALID_PERSISTENCE_SLOT_ID);
        SetDeleteLastObject(true);
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, *this);
    }

    /* Please see man pages for details 
        
        
    */
    inline friend StringStream& operator<<(StringStream& oStr, const DataStorePersistenceInitParam& oPersistenceInitParam);
};

inline StringStream& operator<<(StringStream& oStr, const DataStorePersistenceInitParam& oPersistenceInitParam)
{
    oStr <<_T("DataStorePersistenceInitParam: (")
         << _T("persistenceSlotId=") << oPersistenceInitParam.persistenceSlotId
         << _T(", deleteLastObject=") << oPersistenceInitParam.deleteLastObject
         << _T(")");

    return oStr;
}

END_NAMESPACE_NEX

#endif
