/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DATA_STORE_PERSISTENCE_TARGET_H
#define _DATA_STORE_PERSISTENCE_TARGET_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStorePersistenceTargetDDL.h"
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class DataStorePersistenceTarget: public DDLCLASS(DataStorePersistenceTarget)
{
public:
    /* Please see man pages for details 
        

            

        
        
    */
    explicit DataStorePersistenceTarget(qUnsignedInt32 ownerId=INVALID_PRINCIPALID, qUnsignedInt16 persistenceSlotId=DataStoreConstants::INVALID_PERSISTENCE_SLOT_ID)
    {
        SetOwnerId(ownerId);
        SetPersistenceSlotId(persistenceSlotId);
    }

    /* Please see man pages for details 
        
    */
    virtual ~DataStorePersistenceTarget() {}

    /* Please see man pages for details 
        

        
    */
    void SetOwnerId(qUnsignedInt32 ownerId)
    {
        this->ownerId = ownerId;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetOwnerId() const
    {
        return this->ownerId;
    }

    /* Please see man pages for details 
        

        
    */
    void SetPersistenceSlotId(qUnsignedInt16 persistenceSlotId)
    {
        this->persistenceSlotId = persistenceSlotId;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt16 GetPersistenceSlotId() const
    {
        return this->persistenceSlotId;
    }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        SetOwnerId(INVALID_PRINCIPALID);
        SetPersistenceSlotId(DataStoreConstants::INVALID_PERSISTENCE_SLOT_ID);
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, *this);
    }

    /* Please see man pages for details 
        
        
    */
    inline friend StringStream& operator<<(StringStream& oStr, const DataStorePersistenceTarget& oPersistenceTarget);
};

inline StringStream& operator<<(StringStream& oStr, const DataStorePersistenceTarget& oPersistenceTarget)
{
    oStr <<_T("DataStorePersistenceTarget: (")
         << _T("ownerId=") << oPersistenceTarget.ownerId
         << _T(", persistenceSlotId=") << oPersistenceTarget.persistenceSlotId
         << _T(")");

    return oStr;
}

END_NAMESPACE_NEX

#endif
