﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DATA_STORE_TOUCH_OBJECT_PARAM_H
#define _DATA_STORE_TOUCH_OBJECT_PARAM_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStoreTouchObjectParamDDL.h"
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class DataStoreTouchObjectParam: public DDLCLASS(DataStoreTouchObjectParam)
{
public:
    /* Please see man pages for details 
        
    */
    DataStoreTouchObjectParam()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~DataStoreTouchObjectParam() {}

    /* Please see man pages for details 
        

            

        
    */
    void SetDataId(qUnsignedInt64 dataId)
    {
        this->dataId = dataId;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetDataId() const
    {
        return this->dataId;
    }

    /* Please see man pages for details 
        

            
            
            
            
            

        
    */
    void SetAccessPassword(qUnsignedInt64 accessPassword)
    {
        this->accessPassword = accessPassword;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetAccessPassword() const
    {
        return this->accessPassword;
    }

    /*
        
        

            
            
            
            
            

        
    */
    //    void SetLockId(qUnsignedInt32 lockId) { this->lockId = lockId; }

    /*
        
        

        
    */
    //    qUnsignedInt32 GetLockId() const { return this->lockId; }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        SetDataId(DataStoreConstants::INVALID_DATAID);
        SetAccessPassword(DataStoreConstants::INVALID_PASSWORD);
        // SetLockId(0);
        // Set to 0, because getting a strange value would cause problems.
        lockId = 0;
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, _T("DataStoreTouchObjectParam: (")
               << _T("dataId=") << dataId
               << _T(", accessPassword=") << accessPassword
               << _T(")")
              );
    }
};

END_NAMESPACE_NEX

#endif
