/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DebugClient_ApiCallSummary_H_
#define _DebugClient_ApiCallSummary_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Services/Jugem/Debug/src/Common/ApiCallSummaryDDL.h>
#include <RendezVous/Services/Jugem/Debug/src/Common/DebugConstants.h>
BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
#ifdef FOR_DOC_PURPOSE
class ApiCallSummary
#else
class ApiCallSummary: public DDLCLASS(ApiCallSummary)
#endif
{
public:
    /* Please see man pages for details 
        
    */
    ApiCallSummary()
    {
        methodName = _T("");
        result = DebugConstants::ApiCallSummaryResult_Normal;
        period = 0;
        limit = 0;
        callStartTime = DateTime::Never;
        count = 0;
        totalCount = 0;
    }

    /* Please see man pages for details 
        
    */
    virtual ~ApiCallSummary() {}

    /* Please see man pages for details 
        

        
    */
    const String& GetMethodName() const
    {
        return methodName;
    }

    /* Please see man pages for details 
        

        
    */
    DebugConstants::ApiCallSummaryResult GetResult() const
    {
        return static_cast<DebugConstants::ApiCallSummaryResult>(result);
    }

    /* Please see man pages for details 
        

        

        
    */
    qUnsignedInt32 GetPeriod() const
    {
        return period;
    }

    /* Please see man pages for details 
        

        

        
     */
    qUnsignedInt32 GetLimit() const
    {
        return limit;
    }

    /* Please see man pages for details 
        

        
        

        
     */
    const DateTime& GetCallStartTime() const
    {
        return callStartTime;
    }

    /* Please see man pages for details 
        

        
        

        
     */
    qUnsignedInt32 GetCount() const
    {
        return count;
    }

    /* Please see man pages for details 
        

        

        
     */
    qUnsignedInt32 GetTotalCount() const
    {
        return totalCount;
    }
};

END_NAMESPACE_NEX

#endif /* _DebugClient_ApiCallSummary_H_ */
