#ifndef _Quazal_DebugProtocolDDL_H_
#define _Quazal_DebugProtocolDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "ApiCallData.h"
#include "ApiCallSummary.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(DebugProtocol, EnableApiRecorder, 1 );
PROTO_DEFINE_RMCID(DebugProtocol, DisableApiRecorder, 2 );
PROTO_DEFINE_RMCID(DebugProtocol, IsApiRecorderEnabled, 3 );
PROTO_DEFINE_RMCID(DebugProtocol, GetApiCalls, 4 );
PROTO_DEFINE_RMCID(DebugProtocol, SetExcludeJoinedMatchmakeSession, 5 );
PROTO_DEFINE_RMCID(DebugProtocol, GetExcludeJoinedMatchmakeSession, 6 );
PROTO_DEFINE_RMCID(DebugProtocol, GetApiCallSummary, 7 );
PROTO_DEFINE_NUM_RMC(DebugProtocol, 7);

class DebugProtocolClient : public ClientProtocol {
    public:
        PROTO_RMCIMPL_RETURN(DebugProtocol, EnableApiRecorder)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        PROTO_RMCIMPL_RETURN(DebugProtocol, DisableApiRecorder)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TIsApiRecorderEnabled_IsEnabled;
        PROTO_RMCIMPL_RETURN(DebugProtocol, IsApiRecorderEnabled)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TIsApiRecorderEnabled_IsEnabled,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(ApiCallData) > TGetApiCalls_pApiCallDatas;
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TGetApiCalls_pPrincipalIds;
        typedef DDLTYPE(datetime) TGetApiCalls_sinceTime;
        typedef DDLTYPE(datetime) TGetApiCalls_untilTime;
        PROTO_RMCIMPL_RETURN(DebugProtocol, GetApiCalls)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetApiCalls_pApiCallDatas,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TSetExcludeJoinedMatchmakeSession_bAvoid;
        PROTO_RMCIMPL_RETURN(DebugProtocol, SetExcludeJoinedMatchmakeSession)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TGetExcludeJoinedMatchmakeSession_bAvoid;
        PROTO_RMCIMPL_RETURN(DebugProtocol, GetExcludeJoinedMatchmakeSession)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetExcludeJoinedMatchmakeSession_bAvoid,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(ApiCallSummary) > TGetApiCallSummary_pApiCallSummaryList;
        typedef DDLTYPE(uint32) TGetApiCallSummary_principalId;
        typedef DDLTYPE(datetime) TGetApiCallSummary_sinceTime;
        typedef DDLTYPE(datetime) TGetApiCallSummary_untilTime;
        typedef DDLTYPE(bool) TGetApiCallSummary_isViolationApiOnly;
        PROTO_RMCIMPL_RETURN(DebugProtocol, GetApiCallSummary)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetApiCallSummary_pApiCallSummaryList,1);
            PROTO_RETURNSTUB_END();
        };
        
        DebugProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew DebugProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallEnableApiRecorder(ProtocolCallContext *pContext);
        static qBool EnableApiRecorder_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg);
        qBool CallDisableApiRecorder(ProtocolCallContext *pContext);
        static qBool DisableApiRecorder_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg);
        qBool CallIsApiRecorderEnabled(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType* IsEnabled);
        static qBool IsApiRecorderEnabled_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType* IsEnabled);
        qBool CallGetApiCalls(ProtocolCallContext *pContext, DDLTYPE(qlist)< CLASSMETATYPE(ApiCallData) >::CPPType* pApiCallDatas, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& pPrincipalIds, const DDLTYPE(datetime)::CPPType& sinceTime, const DDLTYPE(datetime)::CPPType& untilTime);
        static qBool GetApiCalls_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qlist)< CLASSMETATYPE(ApiCallData) >::CPPType* pApiCallDatas, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& pPrincipalIds, const DDLTYPE(datetime)::CPPType& sinceTime, const DDLTYPE(datetime)::CPPType& untilTime);
        qBool CallSetExcludeJoinedMatchmakeSession(ProtocolCallContext *pContext, const DDLTYPE(bool)::CPPType& bAvoid);
        static qBool SetExcludeJoinedMatchmakeSession_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(bool)::CPPType& bAvoid);
        qBool CallGetExcludeJoinedMatchmakeSession(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType* bAvoid);
        static qBool GetExcludeJoinedMatchmakeSession_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType* bAvoid);
        qBool CallGetApiCallSummary(ProtocolCallContext *pContext, DDLTYPE(qlist)< CLASSMETATYPE(ApiCallSummary) >::CPPType* pApiCallSummaryList, const DDLTYPE(uint32)::CPPType& principalId, const DDLTYPE(datetime)::CPPType& sinceTime, const DDLTYPE(datetime)::CPPType& untilTime, const DDLTYPE(bool)::CPPType& isViolationApiOnly);
        static qBool GetApiCallSummary_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qlist)< CLASSMETATYPE(ApiCallSummary) >::CPPType* pApiCallSummaryList, const DDLTYPE(uint32)::CPPType& principalId, const DDLTYPE(datetime)::CPPType& sinceTime, const DDLTYPE(datetime)::CPPType& untilTime, const DDLTYPE(bool)::CPPType& isViolationApiOnly);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(DebugProtocol) + 1];
};

class DDLPROTOCOL(DebugProtocolServer) : public ServerProtocol {
    public:
        PROTO_RMCIMPL_STUB(DebugProtocol, EnableApiRecorder)
        {
            PROTO_PREPARE_EXTRACTION();
            pProtocol->EnableApiRecorder(  );
            PROTO_PREPARE_RETURN(DebugProtocol,EnableApiRecorder);
        }
        
        PROTO_RMCIMPL_STUB(DebugProtocol, DisableApiRecorder)
        {
            PROTO_PREPARE_EXTRACTION();
            pProtocol->DisableApiRecorder(  );
            PROTO_PREPARE_RETURN(DebugProtocol,DisableApiRecorder);
        }
        
        typedef DDLTYPE(bool) TIsApiRecorderEnabled_IsEnabled;
        PROTO_RMCIMPL_STUB(DebugProtocol, IsApiRecorderEnabled)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(bool)::CPPType IsEnabled;
            pProtocol->IsApiRecorderEnabled( &IsEnabled );
            PROTO_PREPARE_RETURN(DebugProtocol,IsApiRecorderEnabled);
            _MSG_ADD_VARIABLE(TIsApiRecorderEnabled_IsEnabled, IsEnabled);
        }
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(ApiCallData) > TGetApiCalls_pApiCallDatas;
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TGetApiCalls_pPrincipalIds;
        typedef DDLTYPE(datetime) TGetApiCalls_sinceTime;
        typedef DDLTYPE(datetime) TGetApiCalls_untilTime;
        PROTO_RMCIMPL_STUB(DebugProtocol, GetApiCalls)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< CLASSMETATYPE(ApiCallData) >::CPPType pApiCallDatas;
            DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType pPrincipalIds;
            _MSG_EXTRACT_VARIABLE(TGetApiCalls_pPrincipalIds, pPrincipalIds);
            DDLTYPE(datetime)::CPPType sinceTime;
            _MSG_EXTRACT_VARIABLE(TGetApiCalls_sinceTime, sinceTime);
            DDLTYPE(datetime)::CPPType untilTime;
            _MSG_EXTRACT_VARIABLE(TGetApiCalls_untilTime, untilTime);
            pProtocol->GetApiCalls( &pApiCallDatas, pPrincipalIds, sinceTime, untilTime );
            PROTO_PREPARE_RETURN(DebugProtocol,GetApiCalls);
            _MSG_ADD_VARIABLE(TGetApiCalls_pApiCallDatas, pApiCallDatas);
        }
        
        typedef DDLTYPE(bool) TSetExcludeJoinedMatchmakeSession_bAvoid;
        PROTO_RMCIMPL_STUB(DebugProtocol, SetExcludeJoinedMatchmakeSession)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(bool)::CPPType bAvoid;
            _MSG_EXTRACT_VARIABLE(TSetExcludeJoinedMatchmakeSession_bAvoid, bAvoid);
            pProtocol->SetExcludeJoinedMatchmakeSession( bAvoid );
            PROTO_PREPARE_RETURN(DebugProtocol,SetExcludeJoinedMatchmakeSession);
        }
        
        typedef DDLTYPE(bool) TGetExcludeJoinedMatchmakeSession_bAvoid;
        PROTO_RMCIMPL_STUB(DebugProtocol, GetExcludeJoinedMatchmakeSession)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(bool)::CPPType bAvoid;
            pProtocol->GetExcludeJoinedMatchmakeSession( &bAvoid );
            PROTO_PREPARE_RETURN(DebugProtocol,GetExcludeJoinedMatchmakeSession);
            _MSG_ADD_VARIABLE(TGetExcludeJoinedMatchmakeSession_bAvoid, bAvoid);
        }
        
        typedef DDLTYPE(qlist)< CLASSMETATYPE(ApiCallSummary) > TGetApiCallSummary_pApiCallSummaryList;
        typedef DDLTYPE(uint32) TGetApiCallSummary_principalId;
        typedef DDLTYPE(datetime) TGetApiCallSummary_sinceTime;
        typedef DDLTYPE(datetime) TGetApiCallSummary_untilTime;
        typedef DDLTYPE(bool) TGetApiCallSummary_isViolationApiOnly;
        PROTO_RMCIMPL_STUB(DebugProtocol, GetApiCallSummary)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< CLASSMETATYPE(ApiCallSummary) >::CPPType pApiCallSummaryList;
            DDLTYPE(uint32)::CPPType principalId;
            _MSG_EXTRACT_VARIABLE(TGetApiCallSummary_principalId, principalId);
            DDLTYPE(datetime)::CPPType sinceTime;
            _MSG_EXTRACT_VARIABLE(TGetApiCallSummary_sinceTime, sinceTime);
            DDLTYPE(datetime)::CPPType untilTime;
            _MSG_EXTRACT_VARIABLE(TGetApiCallSummary_untilTime, untilTime);
            DDLTYPE(bool)::CPPType isViolationApiOnly;
            _MSG_EXTRACT_VARIABLE(TGetApiCallSummary_isViolationApiOnly, isViolationApiOnly);
            pProtocol->GetApiCallSummary( &pApiCallSummaryList, principalId, sinceTime, untilTime, isViolationApiOnly );
            PROTO_PREPARE_RETURN(DebugProtocol,GetApiCallSummary);
            _MSG_ADD_VARIABLE(TGetApiCallSummary_pApiCallSummaryList, pApiCallSummaryList);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void EnableApiRecorder() = 0;
        virtual void DisableApiRecorder() = 0;
        virtual void IsApiRecorderEnabled(DDLTYPE(bool)::CPPType* IsEnabled) = 0;
        virtual void GetApiCalls(DDLTYPE(qlist)< CLASSMETATYPE(ApiCallData) >::CPPType* pApiCallDatas, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& pPrincipalIds, const DDLTYPE(datetime)::CPPType& sinceTime, const DDLTYPE(datetime)::CPPType& untilTime) = 0;
        virtual void SetExcludeJoinedMatchmakeSession(const DDLTYPE(bool)::CPPType& bAvoid) = 0;
        virtual void GetExcludeJoinedMatchmakeSession(DDLTYPE(bool)::CPPType* bAvoid) = 0;
        virtual void GetApiCallSummary(DDLTYPE(qlist)< CLASSMETATYPE(ApiCallSummary) >::CPPType* pApiCallSummaryList, const DDLTYPE(uint32)::CPPType& principalId, const DDLTYPE(datetime)::CPPType& sinceTime, const DDLTYPE(datetime)::CPPType& untilTime, const DDLTYPE(bool)::CPPType& isViolationApiOnly) = 0;
    };


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_DebugProtocolDDL.h_H_
