﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NN_NEX_NEX_JOB_NNID_LOGIN_H_
#define NN_NEX_NEX_JOB_NNID_LOGIN_H_

#include <RendezVous/Services/Jugem/Login/src/Client/JobLogin.h>

BEGIN_NAMESPACE_NEX

class JobNNIDLogin : public JobLogin
{
public:
    // Constructor.
    JobNNIDLogin();

    // Destructor.
    virtual ~JobNNIDLogin();

    void Initialize(qUnsignedInt32 contextId, qUnsignedInt32 gameId, NgsFacade* pClient, const qChar8* pSvlKeyHash, qChar8* pAuthToken, const void* pNexAuthResultArg, TimeInterval uiTimeout, PrincipalID principalID);

private:

    // EntryPoint
    virtual void StepFirst();

    // Log in to the game server.
    void StepGameLogin();

    // Wait to be logged in to the game server.
    void StepWaitingForGameLogin();

private:

    const void* m_pNexAuthResult;
    PrincipalID m_PrincipalID;
};

END_NAMESPACE_NEX

#endif // NN_NEX_NEX_JOB_NNID_LOGIN_H_
