﻿/*---------------------------------------------------------------------------*
  Copyright (C) 2011-2014 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef PIA_NGS_BRIDGE_INTERFACE_H_
#define PIA_NGS_BRIDGE_INTERFACE_H_


#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

class Credentials;
class ProtocolCallContext;
class StationURL;
class NotificationEventHandler;

/* Please see man pages for details 
    

    
*/
class NgsBridgeInterface : public RootObject
{
public:
    virtual ~NgsBridgeInterface() {};

    virtual Credentials* GetCredentials() = 0;
    virtual PrincipalID GetPrincipalID() = 0;

    virtual qBool RegisterNotificationEventHandler(NotificationEventHandler* pNotificationEventHandler) = 0;
    virtual qBool UnregisterNotificationEventHandler(NotificationEventHandler* pNotificationEventHandler) = 0;

    virtual qBool ReplaceURL(ProtocolCallContext *pContext, const StationURL& targetUrl, const StationURL& url) = 0;
    virtual void SendReport(qUnsignedInt32 reportId, const void* reportData, qUnsignedInt32 reportDataSize) = 0;

    virtual qResult IsConnected() const = 0;
};

END_NAMESPACE_NEX

#endif /* PIA_NGS_BRIDGE_INTERFACE_H_ */
