﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NGS_FACADE_H__
#define NGS_FACADE_H__

#include <RendezVous/Core/src/Client/RendezVous.h>


BEGIN_NAMESPACE_NEX

#ifndef CTR_TARGET
class WaitableLobbyApi;
#endif

class JobLogin;
class JobTerminate;
class AuthenticationInfo;
class NgsBridgeInterface;

/* Please see man pages for details 
    

    

    
    
*/
class NgsFacade : public RendezVous
{
public:
    /* Please see man pages for details 
        
    */
    NgsFacade();

    /* Please see man pages for details 
        

        
        
    */
    virtual ~NgsFacade();

#if defined(CTR_TARGET)
    /* Please see man pages for details 
        

        

        

        
        

        

        
        

        
        

        
        
        
        

        

        
                                   
        
        
        
        

        
        
        
        
        
        
        
        
    */
#elif defined(CAFE_TARGET)
    /* Please see man pages for details 
        

        

        

        
        

        

        

        
        

        
        
        
        

        
        

        
        
        
        

        

        
        
        

        
                                   
        
        
        
        

        
        
        
        
        
        
        
    */
#endif
    qResult Login(ProtocolCallContext* pContext,
                  qUnsignedInt32 gameServerId,
                  const qChar* pAccessKey,
                  TimeInterval uiTimeout = 30000,
                  PrincipalID principalId = INVALID_PRINCIPALID);

#ifndef CAFE_TARGET
    /* Please see man pages for details 
        

        
        

        
        

        
                                    
        
        
        
        
                                    
        
        

        
        
        
        
        
        
        
        
    */
#endif
    qResult LoginAndRequestAuthenticationToken(ProtocolCallContext* pContext,
            qUnsignedInt32 gameServerId,
            const qChar* pAccessKey,
            const qChar8* pKeyHash,
            qChar8* pAuthToken,
            TimeInterval uiTimeout = 30000,
            PrincipalID principalId = INVALID_PRINCIPALID);

#if defined(CTR_TARGET) && defined(NEX_ENABLED_CTR_NNID)
    /* Please see man pages for details 
        

        

        
        
        

        

        
                                   
        
        
        
        

        
        
        
        
        
        
        
        
        

    */
#endif
    qResult Login(ProtocolCallContext* pContext,
                  const void* pNexAuthData,
                  const qChar* pAccessKey,
                  TimeInterval uiTimeout = 30000,
                  PrincipalID principalId = INVALID_PRINCIPALID);

private:
    /*
        

                       
                       
                       
    */
    qResult LoginAndRequestAuthenticationTokenImpl(ProtocolCallContext* pContext, qUnsignedInt32 gameId, const qChar* pAccessKey, const qChar8* pKeyHash, qChar8* pAuthToken, const void* pNexAuthResult, TimeInterval uiTimeout, PrincipalID principalId);
public:

    /* Please see man pages for details 
        
        

                       
                       

        
                                  
        
        
        
        
        
        
                                  

        
    */
    qResult DebugCreateAccount(ProtocolCallContext* pContext, const qChar* pHostName, qUnsignedInt16 port, const qChar* pUserName,
                               const qChar8* pPassword, const qChar* pAccessKey, TimeInterval uiTimeout = 30000);

    /* Please see man pages for details 
        
        

                       
                       

        
                                  
        
        
        
        
        
        
                                  

        
    */
    qResult DebugLoginDirect(ProtocolCallContext* pContext, const qChar* pHostName, qUnsignedInt16 port, const qChar* pUserName,
                             const qChar8* pPassword, const qChar* pAccessKey, TimeInterval uiTimeout = 30000);

    /* Please see man pages for details 
        

        
        

        
                                

        
        
        
        
    */
    qResult Logout(ProtocolCallContext* pContext);

    /* Please see man pages for details 
        

        
        
        
        

        
        
        
        
         

        

        

        
        
     */
    qBool TestConnectivity(ProtocolCallContext* pContext);

    /* Please see man pages for details 
        
        

        
    */
    qBool LoginJobIsInProgress() const;

    /* Please see man pages for details 
        
        

        
    */
    qBool TerminateJobIsInProgress() const;

    /* Please see man pages for details 
        
                       

        
    */
    qInt32 GetLastLoginErrorCode() const;


    /* Please see man pages for details 
        

        

        
    */
    NgsBridgeInterface* GetNgsBridge() const
    {
        return m_pNgsBridgeInterface;
    }

    /* Please see man pages for details 
        
        

        
    */
    qInt32 GetNasErrorCode() const;

    /* Please see man pages for details 
        
        

        
    */
    qInt32 GetHttpStatusCode() const;

    /* Please see man pages for details 
        
        

        
                                          
    */
    void IgnoreServerVersion(qBool ignoreServerVersion)
    {
        m_ignoreServerVersion = ignoreServerVersion;
    }

    /* Please see man pages for details 
        
        

        
    */
    qBool IsIgnoreServerVersion() const
    {
        return m_ignoreServerVersion;
    }

#if !defined(CTR_TARGET) && !defined(CAFE_TARGET)
    void SetWaitableLobbyApi(WaitableLobbyApi* pApi)
    {
        m_pWaitableLobbyApi = pApi;
    }
    WaitableLobbyApi* GetWaitableLobbyApi()
    {
        return  m_pWaitableLobbyApi;
    }
#endif

    void SetNasErrorCode(qInt32 code)
    {
        m_nasReturnCode = code;
    }
    void SetHttpStatusCode(qInt32 code)
    {
        m_httpStatusCode = code;
    }
    void SetLastLoginErrorCode(qInt32 code)
    {
        m_LastLoginErrorCode = code;
    }
    void SetIgnoreNFSLoginCheck(qBool flag)
    {
        m_ignoreNFSLoginCheck = flag;
    }
    qBool GetIgnoreNFSLoginCheck()
    {
        return m_ignoreNFSLoginCheck;
    }

    void SetIgnorePidCheck(qBool flag)
    {
        m_ignorePidCheck = flag;
    }

protected:
    friend class JobLogin;
    friend class JobTerminate;

protected:
    // Credentials object
    Credentials* m_pCredentials;
    // Job object
    JobLogin* m_pJobNgsLogin;
    JobTerminate* m_pJobNgsTerminate;

    NgsBridgeInterface* m_pNgsBridgeInterface;

    // Terminate callback function
    static void OnTerminate(CallContext* pContext, const UserContext* pUserContext);
    // NgsFacade-specific Terminate function
    void TerminateImpl(CallContext* pContext);

    // NAS error code
    qInt32 m_nasReturnCode;
    // HTTP status code
    qInt32 m_httpStatusCode;
    // Results at JobLogin
    qResult m_lastLoginResult;
    // Error Code
    qInt32 m_LastLoginErrorCode;
    // Whether to ignore the server version check.
    qBool m_ignoreServerVersion;
    // Whether to make login to FPD unnecessary.
    qBool m_ignoreNFSLoginCheck;

    // For NNID test
    qBool m_ignorePidCheck;

    nn::nex::CustomDataHolder<nn::nex::AuthenticationInfo> m_pTokenHolder;

#if !defined(CTR_TARGET) && !defined(CAFE_TARGET)
    WaitableLobbyApi* m_pWaitableLobbyApi;
#endif
};

END_NAMESPACE_NEX

#endif // NGS_FACADE_H__
