﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _MatchmakeExtensionClient_H_
#define _MatchmakeExtensionClient_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Core/src/Client/ServiceClient.h>
#include <RendezVous/Core/src/Common/Constants/ServiceID.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/MatchmakeExtensionProtocolDDL.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/MatchmakeSession.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/MatchmakeSessionSearchCriteria.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/AutoMatchmakeParam.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/CreateMatchmakeSessionParam.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/JoinMatchmakeSessionParam.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/Community.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/MatchmakeConstants.h>
#include <RendezVous/Services/MatchMaking/src/Client/MatchMakingClient.h>

BEGIN_NAMESPACE_NEX

class KeyedChecksumAlgorithm;

/* Please see man pages for details 


*/
typedef CustomGatheringHolder<MatchmakeSession> MatchmakeSessionHolder;

/* Please see man pages for details 
    
*/
class MatchmakeExtensionClient : public MatchMakingClient
{
public:

    /* Please see man pages for details 
    

       
    */
    MatchmakeExtensionClient();

    /* Please see man pages for details 
    

       
    */
    virtual ~MatchmakeExtensionClient();

    /* Please see man pages for details 
    

       
       
       

    

    
    
    */
    virtual qBool Bind(Credentials* pCredentials);

    /* Please see man pages for details 
    

       

    
    
    */
    virtual qBool Unbind();

    /* Please see man pages for details 
    

    

       
       
       
       
       
       
       
       
       
       
       
       
       
       

       

       

       
                                              
                                              

       

       

    
    
                                         
    
    

    
    
    */
    qBool AutoMatchmake(ProtocolCallContext *pContext,
                        const GatheringHolder& matchmakingSession,
                        GatheringHolder* joinedMatchmakingSession,
                        const String strMessage = _T(""));

    /* Please see man pages for details 
    

    

       
       
       
       
       
       
       

       
       

       
       

       

       

       
       

       
       
                                              
                                              
       
       

    
    
    
    
    

    
    
    */
    qBool AutoMatchmake(ProtocolCallContext *pContext,
                        const qList<MatchmakeSessionSearchCriteria>& searchCriteriaList,
                        const GatheringHolder& matchmakingSession,
                        GatheringHolder* joinedMatchmakingSession,
                        const String strMessage = _T(""));

    /* Please see man pages for details 
    

    

       
       
       
       

       
       

       

       
       
       

       
       

       

       

       
                                              
                                              

       

       

    
    
    
    
    

    
    
    */
    qBool AutoMatchmake(ProtocolCallContext *pContext,
                        const qList<GatheringID> gidList,
                        const GatheringHolder& matchmakingSession,
                        GatheringHolder* joinedMatchmakingSession,
                        const String strMessage = _T(""));

    /* Please see man pages for details 
    

    

       
       
       

       
       

           

       

       
                                              
                                              
       

       

       

    
    
    

    
    
    */
    qBool AutoMatchmake(ProtocolCallContext *pContext,
                        const AutoMatchmakeParam& autoMatchmakeParam,
                        MatchmakeSession* joinedMatchmakingSession);

    /* Please see man pages for details 
    

    

       
       

       

       

       
                                              
                                              

       

       

    
    
    
    

    
    
    */
    qBool BrowseMatchmakeSession(ProtocolCallContext *pContext,
                                 const MatchmakeSessionSearchCriteria& searchCriteria,
                                 const ResultRange& resultRange,
                                 qList<GatheringHolder>* lstGathering);

    /* Please see man pages for details 
    

    

       
       
       

       

       

       
                                              
                                              

       

       

    
    
    
    
    

    
    
    */
    qBool BrowseMatchmakeSession(ProtocolCallContext *pContext,
                                 const MatchmakeSessionSearchCriteria& searchCriteria,
                                 const ResultRange& resultRange,
                                 qList<GatheringHolder>* lstGathering,
                                 qList<GatheringURLs>* lstGatheringURLs);

    /* Please see man pages for details 
    

    

       

       

       

       

       

       

    
    
    
    

    
    
    */
    qBool BrowseMatchmakeSession(ProtocolCallContext *pContext,
                                 const MatchmakeSessionSearchCriteria& searchCriteria,
                                 const ResultRange& resultRange,
                                 qList<MatchmakeSession>* lstMatchmakeSession);

    /* Please see man pages for details 
    

    

       
       

       

       

       

       

       

    
    
    
    
    

    
    
    */
    qBool BrowseMatchmakeSession(ProtocolCallContext *pContext,
                                 const MatchmakeSessionSearchCriteria& searchCriteria,
                                 const ResultRange& resultRange,
                                 qList<MatchmakeSession>* lstMatchmakeSession,
                                 qList<GatheringURLs>* lstGatheringURLs);

    /* Please see man pages for details 
    

    

       
       
       
       

       

       

           
                                           
                                           

       

           

    
    
                                         
    
    
    

    
    

    

    */
    qBool CreateMatchmakeSession(ProtocolCallContext *pContext,
                                 const GatheringHolder& matchmakingSession,
                                 GatheringID* gid,
                                 qVector<qByte>* pSessionKey,
                                 const String strMessage = _T(""));

    /* Please see man pages for details 
    

    

       
       
       
       

       

       

           
                                           
                                           
                                           

    
    
                                         
    
    
    
    

    
    

    

    */
    qBool CreateMatchmakeSession(ProtocolCallContext *pContext,
                                 const GatheringHolder& matchmakingSession,
                                 GatheringID* gid,
                                 qVector<qByte>* pSessionKey,
                                 qUnsignedInt16 participationCount,
                                 const String strMessage = _T(""));

    /* Please see man pages for details 
    

    

       
       
       

       
       

           
           

       

           
                                           
                                           

       

           

    
    
    

    
    

    

    */
    qBool CreateMatchmakeSession(ProtocolCallContext *pContext,
                                 const CreateMatchmakeSessionParam& createMatchmakeSessionParam,
                                 MatchmakeSession* joinedMatchmakingSession);

    /* Please see man pages for details 
    

    

       
       
       

       

           
           
           
           
           
           
           

       
           

       

           

    
    
    
    

    
    

    
    */
    qBool JoinMatchmakeSession(ProtocolCallContext *pContext,
                               GatheringID gid,
                               qVector<qByte>* pSessionKey,
                               const String strMessage=_T(""));

    /* Please see man pages for details 

    

       
       
       

       

           
           
           
           
           
           

       
           

       

           
           

    
    
    
    
    

    
    

    
    */
    qBool JoinMatchmakeSessionWithDontCareMyBlackList(ProtocolCallContext *pContext,
                               GatheringID gid,
                               qVector<qByte>* pSessionKey,
                               const String strMessage=_T(""),
                               qBool dontCareMyBlackList = false);

    /* Please see man pages for details 
    

    

       
       
       

       

           
           
           
           
           
           
           
       
           

    
    
    
    
    

    
    

    
    */
    qBool JoinMatchmakeSession(ProtocolCallContext *pContext,
                               GatheringID gid,
                               qVector<qByte>* pSessionKey,
                               qUnsignedInt16 participationCount,
                               const String strMessage=_T(""));

    /* Please see man pages for details 
    

    

       
       

       

           
           
           
           
           
           
           
                                                                     
           
                                                                       
           
                                                          
                                                          
           
                                                              
                                                              
           
           

       
           

       

           

    
    
    

    
    

    
    */
    qBool JoinMatchmakeSession(ProtocolCallContext *pContext,
                               const JoinMatchmakeSessionParam& joinMatchmakeSessionParam,
                               MatchmakeSession* joinedMatchmakingSession);

    /* Please see man pages for details 
    

       
       

       
       

       

           
           

    
    

    
    
    */
    qBool CloseParticipation(ProtocolCallContext *pContext, GatheringID gid);

    /* Please see man pages for details 
    

       

       
       

       

           
           

    
    

    
    
    */
    qBool OpenParticipation(ProtocolCallContext *pContext, GatheringID gid);

    /* Please see man pages for details 
    

       

       

           
           

    
    
    
    

    
    
    */
    qBool ModifyMatchmakeSessionAttribute(ProtocolCallContext *pContext, GatheringID gid, qUnsignedInt32 attribIndex, qUnsignedInt newValue);

    /* Please see man pages for details 
    

       

       

           
           

    
    
    

    
    
    */
    qBool UpdateMatchmakeSessionAttribute(ProtocolCallContext *pContext, GatheringID gid, qUnsignedInt32 attributes[nn::nex::NUM_MATCHMAKE_SESSION_ATTRIBUTES]);

    /* Please see man pages for details 
    

    

       

       
       
       
       

       

           
           
           
           

    
    
    

    
    
    */
    qBool UpdateProgressScore(ProtocolCallContext *pContext, GatheringID gid, qUnsignedInt8 progressScore);

    /* Please see man pages for details 
    

    

       

       
       
       
       

       

    
    

    
    
    */
    qBool UpdateProgressScore(GatheringID gid, qUnsignedInt8 progressScore);

    /* Please see man pages for details 
    

       

       

           
           

       
       

       

    
    
    

    
    
    */
    qBool UpdateApplicationBuffer(ProtocolCallContext *pContext, GatheringID gid, qVector<qUnsignedInt8> applicationBuffer);

    /* Please see man pages for details 
    

    

       
       
       
       
       

       

           
           

    
    

    
    
    */
    qBool UpdateMatchmakeSession(ProtocolCallContext *pContext, const GatheringHolder& matchmakingSession);

    /* Please see man pages for details 
    

    

       
       
       

       

           
           

       
       

           

    
    

    
    
    */
    qBool UpdateMatchmakeSession(ProtocolCallContext *pContext, const UpdateMatchmakeSessionParam& updateMatchmakeSessionParam);

    /* Please see man pages for details 
    

           
           

           

       

    
    
    
    
    

    
    
    */
    qBool UpdateNotificationData(ProtocolCallContext *pContext, qUnsignedInt32 uiType, qUnsignedInt32 uiParam1, qUnsignedInt32 uiParam2, String strParam);

    /* Please see man pages for details 
    

    

    
    
    

    
    
    */
    qBool GetFriendNotificationData(ProtocolCallContext *pContext, qList<NotificationEvent> *dataList, qUnsignedInt32 uiType);

    /* Please see man pages for details 
    

    

    
    
    

    
    
    */
    qBool GetFriendNotificationData(ProtocolCallContext *pContext, qList<NotificationEvent> *dataList, const qList<qUnsignedInt32>& lstTypes);

    /* Please see man pages for details 
     

     

         
         

     

           
     

     
     
     

     
     
     */
    qBool GetPlayingSession(ProtocolCallContext *pContext,
                            const qList<PrincipalID>& principalIdList,
                            qList<PlayingSession>* pPlayingSessionList);

    /* Please see man pages for details 
     

     

     
     

     

     
     
     

     
     
     */
    qBool UpdatePrivacySetting(ProtocolCallContext *pContext, qBool onlineStatus, qBool participation);

    /* Please see man pages for details 
    

       
       

       

           
           
           

    
    
    

    
    

    
    */
    qBool FindMatchmakeSessionByGatheringIdDetail(ProtocolCallContext *pContext,
                               GatheringID gid,
                               MatchmakeSession* matchmakingSession);

#ifndef CAFE_TARGET
    /* Please see man pages for details 
     

     
     

     

       

       

     
     

     
     
     */
    qBool AddToBlackList(ProtocolCallContext *pContext,
                         const qList<PrincipalID>& principalIdList);

    /* Please see man pages for details 
     

     
     

     
     
     */
    qBool RemoveFromBlackList(ProtocolCallContext *pContext,
                              const qList<PrincipalID>& principalIdList);

    /* Please see man pages for details 
     

     
     

     
     
     */
    qBool GetMyBlackList(ProtocolCallContext *pContext,
                         qList<PrincipalID>* pPrincipalIdList);

    /* Please see man pages for details 
     

     

     
     
     */
    qBool ClearBlackList(ProtocolCallContext *pContext);

#endif
    /* Please see man pages for details 
     
     

     
     
     

     
     
     

     
     
     

     
     
     
     

     
     
     */
    qBool ReportViolation(ProtocolCallContext *pContext,
                          PrincipalID principalId,
                          const String& userName,
                          qUnsignedInt8 violationCode = 0);

    /* Please see man pages for details 
     
     

     
     
     

     
     
     */
    qBool IsViolationUser(ProtocolCallContext *pContext,
                          qBool* pIsViolationUser,
                          qUnsignedInt32* pScore);

    /* Please see man pages for details 
     
     

     

     

         
         

     

     
     
     

     
     
     */
    qBool GetSimplePlayingSession(ProtocolCallContext *pContext,
                                  const qList<PrincipalID>& principalIdList,
                                  qList<SimplePlayingSession>* pSimplePlayingSessionList);

    /* Please see man pages for details 
     
     

     
     
     

     
     
     */
    qBool GetSimpleCommunity(ProtocolCallContext *pContext,
                             const qList<GatheringID>& gatheringIdList,
                             qList<SimpleCommunity>* pSimpleCommunityList);

    /* Please see man pages for details 
     

     
     
     
     
    
     
     

     
     

     
     
     
     

       

       
       

       
       

       

       

     
     
     */
    qBool CreatePersistentGathering(ProtocolCallContext *pContext,
                          const PersistentGathering& persistentGathering,
                          GatheringID* pGatheringId,
                          const String& strMessage = _T(""));

    /* Please see man pages for details 
     

       
       

       
       
       
       

       
       

       
       
     */
    qBool UpdatePersistentGathering(ProtocolCallContext *pContext, const PersistentGathering& persistentGathering);

    /* Please see man pages for details 
     

       
       
       

       

       
       
       
       
       
       

       
       

       

       

     
     
     
     

     
     
     */
    qBool JoinPersistentGathering(ProtocolCallContext *pContext,
                        GatheringID gatheringId,
                        const String& strMessage = _T(""),
                        const String& strPassword = _T(""));

    /* Please see man pages for details 
     

       


       

       

       

     
     
     

     
     
     */
    qBool FindPersistentGatheringByGatheringId(ProtocolCallContext *pContext,
                                     const qList<GatheringID>& gatheringIdList,
                                     qList<PersistentGathering>* pPersistentGatheringList);

    /* Please see man pages for details 
     

       


       

       

       

     
     
     
     

     
     
     */
    qBool FindOfficialPersistentGathering(ProtocolCallContext *pContext,
                                qBool isAvailableOnly,
                                const ResultRange& resultRange,
                                qList<PersistentGathering>* pPersistentGatheringList);

    /* Please see man pages for details 
     

     

       


       

       

       

     

         
         

     
     
     
     

     
     
     */
    qBool FindPersistentGatheringByParticipant(ProtocolCallContext *pContext,
                                     PrincipalID principalId,
                                     const ResultRange& resultRange,
                                     qList<PersistentGathering>* pPersistentGatheringList);

    /* Please see man pages for details 
     

     
     

     

          
          

     
     
     

     
     
     */
    qBool GenerateMatchmakeSessionSystemPassword(ProtocolCallContext *pContext, GatheringID gatheringId, String* pSystemPassword);

    /* Please see man pages for details 
     

     
     

     

          
          

     
     

     
     
     */
    qBool ClearMatchmakeSessionSystemPassword(ProtocolCallContext *pContext, GatheringID gatheringId);

    /* Please see man pages for details 
     

     
     

     

     

     

     
     */
    static qUnsignedInt64 GatheringIdToPersistentGatheringCode(GatheringID gatheringId);

    /* Please see man pages for details 
     

     
     

     

     

     
     */
    static GatheringID PersistentGatheringCodeToGatheringId(qUnsignedInt64 persistentGatheringCode);

    /* Please see man pages for details 
     

     

     

     
     */
    static qBool IsValidPersistentGatheringCode(qUnsignedInt64 persistentGatheringCode);

    /* Please see man pages for details 
     

     
     */
    static void SetPersistentGatheringCodeKey(const String& strKey);

    /* Please see man pages for details 
     

    
     */
    static void ClearPersistentGatheringCodeKey();

    /* Please see man pages for details 
     

     
     
     
     
     
     
     

     
     
     */
    qBool DebugNotifyEvent(ProtocolCallContext *pContext, PrincipalID pid, qUnsignedInt32 type, qUnsignedInt32 subType, qUnsignedInt32 param1, qUnsignedInt32 param2, const String& stringParam);

private:
    qBool m_bProtocolRegistered;
    MatchmakeExtensionProtocolClient m_oProtocol;
    static KeyedChecksumAlgorithm* s_pChecksumAlgorithm;
    static qBool s_isSetCommunityCodeKey;
    Time m_ProgressScoreLastUpdateTime;
};

#ifdef FOR_DOC_PURPOSE
/* Please see man pages for details 
 
 */
class ParticipantDetails: public RootObject
{
public:
    /* Please see man pages for details 
     
     */
    qUnsignedInt32 m_idParticipant;
    /* Please see man pages for details 
     
     */
    String m_strName;
    /* Please see man pages for details 
     
               
     */
    String m_strMessage;
    /* Please see man pages for details 
     
     */
    qUnsignedInt16 m_uiParticipants;
};
#endif

END_NAMESPACE_NEX

#endif // _MatchmakeExtensionClient_H_
