﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _AutoMatchmakeParam_H_
#define _AutoMatchmakeParam_H_

#include <RendezVous/Services/Jugem/Matchmake/src/Common/AutoMatchmakeParamDDL.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/MatchmakeConstants.h>


BEGIN_NAMESPACE_NEX

/* Please see man pages for details 

*/
class AutoMatchmakeParam: public DDLCLASS(AutoMatchmakeParam)
{
public:

    /* Please see man pages for details 
    

       
    */
    AutoMatchmakeParam()
    {
        Reset();
    };
    
    /* Please see man pages for details 
     
     */
    virtual ~AutoMatchmakeParam() {}

    /* Please see man pages for details 
    

       
       
       
       
       
       
       
       

    
    */
    void SetSourceMatchmakeSession(const MatchmakeSession& sourceMatchmakeSession) { this->sourceMatchmakeSession = sourceMatchmakeSession; }
    /* Please see man pages for details 
    

    
    */
    const MatchmakeSession& GetSourceMatchmakeSession() const { return sourceMatchmakeSession; }

    /* Please see man pages for details 
    

       
       
       
       
       
       

    

    
    */
    void SetAdditionalParticipant(const qList<PrincipalID>& additionalParticipants) { this->additionalParticipants = additionalParticipants; }
    /* Please see man pages for details 
    

    
    */
    const qList<PrincipalID>& GetAdditionalParticipants() const { return additionalParticipants; }

    /* Please see man pages for details 
    

        
        

    

    
    */
    void SetGatheringIdForParticipationCheck(GatheringID gidForParticipationCheck) { this->gidForParticipationCheck = gidForParticipationCheck; }
    /* Please see man pages for details 
    

    
    */
    GatheringID GetGatheringIdForParticipationCheck() const { return gidForParticipationCheck; }

    /* Please see man pages for details 
    
    

        

    
    */
    void SetAutoMatchmakeOption(qUnsignedInt32 autoMatchmakeOption) { this->autoMatchmakeOption = autoMatchmakeOption; }
    /* Please see man pages for details 
    
    

    
    */
    qUnsignedInt32 GetAutoMatchmakeOption() const { return autoMatchmakeOption; }

    /* Please see man pages for details 
    

        
        
        

    
    
    */
    void SetJoinMessage(const String& joinMessage) { this->joinMessage = joinMessage; }
    /* Please see man pages for details 
    

    
    */
    const String& GetJoinMessage() const { return joinMessage; }

    /* Please see man pages for details 
    

        
        
        
        
        
        
        
        
        

    
    
    */
    void SetSearchCriteria(const qList<MatchmakeSessionSearchCriteria>& searchCriteria) { this->lstSearchCriteria = searchCriteria; }
    /* Please see man pages for details 
    

    
    */
    const qList<MatchmakeSessionSearchCriteria>& GetSearchCriteria() const { return lstSearchCriteria; }

    /* Please see man pages for details 
    

        
        
        
        
        
        

        
        
        
        
        

    
    
    */
    void SetTargetGatheringId(const qList<GatheringID>& targetGids) { this->targetGids = targetGids; }
    /* Please see man pages for details 
    

    
    */
    const qList<GatheringID>& GetTargetGatheringId() const { return targetGids; }

    /* Please see man pages for details 
    
    

        
        
        
        

    
    */
    void SetParticipationCount(const qUnsignedInt16 participationCount) { this->participationCount = participationCount; }
    /* Please see man pages for details 
    
    

    
    */
    const qUnsignedInt16& GetParticipationCount() const { return participationCount; }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        SetSourceMatchmakeSession(MatchmakeSession());
        SetAdditionalParticipant(qList<PrincipalID>());
        SetGatheringIdForParticipationCheck(INVALID_GATHERINGID);
        SetAutoMatchmakeOption(AUTO_MATCHMAKE_OPTION_NONE);
        SetJoinMessage(String());
        SetSearchCriteria(qList<MatchmakeSessionSearchCriteria>());
        SetTargetGatheringId(qList<GatheringID>());
        SetParticipationCount(1);
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, *this);
    }

    /* Please see man pages for details 
        
        
    */
    inline friend StringStream& operator<<(StringStream& oStr, const AutoMatchmakeParam& rhs);
};

inline StringStream& operator<<(StringStream& oStr, const AutoMatchmakeParam& rhs)
{
    oStr << _T("AutoMatchmakeParam: (")
               << _T("sourceMatchmakeSession=(not implemented)")
               << _T(", joinMessage=") << rhs.joinMessage;

    {
        oStr << _T(", additionalParticipants=(");
        qList<PrincipalID>::const_iterator itr = rhs.additionalParticipants.begin();
        for (int i = 0; itr != rhs.additionalParticipants.end(); ++i, ++itr)
        {
            if (i != 0)
            {
                oStr << _T(", ");
            }
            oStr << *itr;
        }
        oStr << _T(")");
    }

    oStr << _T(", lstSearchCriteria=(not implemented)");

    {
        oStr << _T(", targetGids=(");
        qList<GatheringID>::const_iterator itr = rhs.targetGids.begin();
        for (int i = 0; itr != rhs.targetGids.end(); ++i, ++itr)
        {
            if (i != 0)
            {
                oStr << _T(", ");
            }
            oStr << *itr;
        }
        oStr << _T(")");
    }
    oStr << _T(", participationCount=") << rhs.participationCount;
    oStr << _T(")");
    return oStr;
}

END_NAMESPACE_NEX

#endif // _AutoMatchmakeParam_H_
