#ifndef _Quazal_AutoMatchmakeParamDDL_H_
#define _Quazal_AutoMatchmakeParamDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "MatchmakeSession.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "MatchmakeSessionSearchCriteria.h"

BEGIN_NAMESPACE_NEX
class AutoMatchmakeParam;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(AutoMatchmakeParam): public RootObject {
public:
    DDLCLASS(AutoMatchmakeParam)():_mRevision_AutoMatchmakeParam(0)
     {};
    DDLCLASS(AutoMatchmakeParam)(const DDLCLASS(AutoMatchmakeParam) &oOther):
        RootObject(oOther),
        _mRevision_AutoMatchmakeParam(oOther._mRevision_AutoMatchmakeParam),
        sourceMatchmakeSession(oOther.sourceMatchmakeSession),
        additionalParticipants(oOther.additionalParticipants),
        gidForParticipationCheck(oOther.gidForParticipationCheck),
        autoMatchmakeOption(oOther.autoMatchmakeOption),
        joinMessage(oOther.joinMessage),
        participationCount(oOther.participationCount),
        lstSearchCriteria(oOther.lstSearchCriteria),
        targetGids(oOther.targetGids)
    {
    }
    virtual ~DDLCLASS(AutoMatchmakeParam)() {};
    const DDLCLASS(AutoMatchmakeParam) &operator=(const DDLCLASS(AutoMatchmakeParam) &oOther);
    qBool operator==(const DDLCLASS(AutoMatchmakeParam) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(AutoMatchmakeParam) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(AutoMatchmakeParam) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(AutoMatchmakeParam) *pValue);
    qByte _mRevision_AutoMatchmakeParam;
    qByte GetClassRevision_AutoMatchmakeParam() const {return _mRevision_AutoMatchmakeParam;}
    void SetClassRevision_AutoMatchmakeParam(qByte revision) {_mRevision_AutoMatchmakeParam=revision;}
    static qByte GetKnownMaxClassRevision_AutoMatchmakeParam() {return 0;}
    MatchmakeSession sourceMatchmakeSession;
    NEX_CLASS_VALID_REVISION_DEF(sourceMatchmakeSession, 0);
    qBool NEX_CLASS_ISVALID(sourceMatchmakeSession) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType additionalParticipants;
    NEX_CLASS_VALID_REVISION_DEF(additionalParticipants, 0);
    qBool NEX_CLASS_ISVALID(additionalParticipants) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType gidForParticipationCheck;
    NEX_CLASS_VALID_REVISION_DEF(gidForParticipationCheck, 0);
    qBool NEX_CLASS_ISVALID(gidForParticipationCheck) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType autoMatchmakeOption;
    NEX_CLASS_VALID_REVISION_DEF(autoMatchmakeOption, 0);
    qBool NEX_CLASS_ISVALID(autoMatchmakeOption) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType joinMessage;
    NEX_CLASS_VALID_REVISION_DEF(joinMessage, 0);
    qBool NEX_CLASS_ISVALID(joinMessage) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint16)::CPPType participationCount;
    NEX_CLASS_VALID_REVISION_DEF(participationCount, 0);
    qBool NEX_CLASS_ISVALID(participationCount) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qlist)< CLASSMETATYPE(MatchmakeSessionSearchCriteria) >::CPPType lstSearchCriteria;
    NEX_CLASS_VALID_REVISION_DEF(lstSearchCriteria, 0);
    qBool NEX_CLASS_ISVALID(lstSearchCriteria) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType targetGids;
    NEX_CLASS_VALID_REVISION_DEF(targetGids, 0);
    qBool NEX_CLASS_ISVALID(targetGids) const { return true; /* The revision is 0. Always true */}
};


class DDLTYPE(AutoMatchmakeParam): public DDLType {
public:
    typedef AutoMatchmakeParam CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(AutoMatchmakeParam)& oAutoMatchmakeParam) {
        DDLCLASS(AutoMatchmakeParam)::Add(pMessageToSend,oAutoMatchmakeParam);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(AutoMatchmakeParam)* pAutoMatchmakeParamToRefresh) {
        DDLCLASS(AutoMatchmakeParam)::Extract(pReceivedMessage,pAutoMatchmakeParamToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_AutoMatchmakeParamDDL.h_H_
