﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _PersistentGathering_H_
#define _PersistentGathering_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/PersistentGatheringDDL.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/MatchmakeConstants.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
 
 */
namespace PersistentGatheringType
{
/* Please see man pages for details 
 
 */
typedef enum
{
    Open,              //
    PasswordLocked,    //
    Official           //
} PersistentGatheringType;
}

// Definition for the sake of compatibility.
class PersistentGathering;
typedef PersistentGathering Community;
namespace CommunityType
{
typedef enum
{
    Open           = PersistentGatheringType::Open,            // General community.
    PasswordLocked = PersistentGatheringType::PasswordLocked,  // Community with password.
    Official       = PersistentGatheringType::Official         // Official community.
} CommunityType;
}

/* Please see man pages for details 
 
 */
#ifdef FOR_DOC_PURPOSE
class PersistentGathering: public Gathering
#else
class PersistentGathering: public DDLCLASS(PersistentGathering)
#endif
{
public:

    /* Please see man pages for details 
    

       
    */
    PersistentGathering();

    /* Please see man pages for details 
    
    */
    virtual ~PersistentGathering() {};

    /* Please see man pages for details 
    

      
    */
    void Reset();

    /* Please see man pages for details 
    

    
    */
    void SetPersistentGatheringType(PersistentGatheringType::PersistentGatheringType type);
    void SetCommunityType(CommunityType::CommunityType type)
    {
        SetPersistentGatheringType(static_cast<PersistentGatheringType::PersistentGatheringType>(type));
    }

    /* Please see man pages for details 
     

     
     */
    PersistentGatheringType::PersistentGatheringType GetPersistentGatheringType() const;
    CommunityType::CommunityType GetCommunityType() const
    {
        return static_cast<CommunityType::CommunityType>(GetPersistentGatheringType());
    }

    /* Please see man pages for details 
     

     

     
     */
    void SetPassword(const String& password)
    {
        m_Password = password;
    }

    /* Please see man pages for details 
     

     

     
     */
    const String& GetPassword() const
    {
        return m_Password;
    }

    /* Please see man pages for details 
    

       

    
    
    */
    void SetAttribute(qUnsignedInt32 uiIndex, qUnsignedInt32 val);

    /* Please see man pages for details 
    

       

    

    
    */
    qUnsignedInt32 GetAttribute(qUnsignedInt32 uiIndex) const;

    /* Please see man pages for details 
    

       

    
    */
    void SetApplicationBuffer(qVector<qByte> buffer)
    {
        m_ApplicationBuffer = buffer;
    }

    /* Please see man pages for details 
    

       

    
    */
    const qVector<qByte>& GetApplicationBuffer() const
    {
        return m_ApplicationBuffer;
    }

    /* Please see man pages for details 
    

       
       
       

    
    */
    void SetParticipationStartDate(const DateTime& date)
    {
        m_ParticipationStartDate = date;
    }

    /* Please see man pages for details 
    

    
    */
    const DateTime& GetParticipationStartDate() const
    {
        return m_ParticipationStartDate;
    }

    /* Please see man pages for details 
    

       
       
       

    
    */
    void SetParticipationEndDate(const DateTime& date)
    {
        m_ParticipationEndDate = date;
    }

    /* Please see man pages for details 
    

    
    */
    const DateTime& GetParticipationEndDate() const
    {
        return m_ParticipationEndDate;
    }

    /* Please see man pages for details 
    

    
    
    */
    qUnsignedInt32 GetMatchmakeSessionCount() const
    {
        return m_MatchmakeSessionCount;
    }

    /* Please see man pages for details 
    

    
    */
    qUnsignedInt32 GetParticipationCount() const
    {
        return m_ParticipationCount;
    }
};

END_NAMESPACE_NEX

#endif /* _PersistentGathering_H_ */
