﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _UpdateMatchmakeSessionParam_H_
#define _UpdateMatchmakeSessionParam_H_

#include <RendezVous/Services/Jugem/Matchmake/src/Common/UpdateMatchmakeSessionParamDDL.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/MatchmakeConstants.h>


BEGIN_NAMESPACE_NEX

/* Please see man pages for details 

*/
class UpdateMatchmakeSessionParam: public DDLCLASS(UpdateMatchmakeSessionParam)
{
public:

    /* Please see man pages for details 
    

       
    */
    UpdateMatchmakeSessionParam()
    {
        Reset();
    };
    
    /* Please see man pages for details 
     
     */
    virtual ~UpdateMatchmakeSessionParam() {}

    /* Please see man pages for details 
    

        

    
    */
    void SetTargetGatheringId(GatheringID gid) { this->gid = gid; }
    /* Please see man pages for details 
    

    
    */
    GatheringID GetTargetGatheringId() const { return gid; }

    /* Please see man pages for details 
        

            
            

        
    */
    void SetModificationFlag(qUnsignedInt32 modificationFlag)
    {
        this->modificationFlag = modificationFlag;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetModificationFlag() const
    {
        return this->modificationFlag;
    }

    /* Please see man pages for details 
        

            

        
    */
    void SetAttribute(const qUnsignedInt32 attributes[NUM_MATCHMAKE_SESSION_ATTRIBUTES])
    {
        this->attributes.assign(attributes, attributes + NUM_MATCHMAKE_SESSION_ATTRIBUTES);
    }

    /* Please see man pages for details 
        

        
    */
    void GetAttribute(qUnsignedInt32 attributes[NUM_MATCHMAKE_SESSION_ATTRIBUTES]) const
    {
        std::copy(this->attributes.begin(), this->attributes.begin() + NUM_MATCHMAKE_SESSION_ATTRIBUTES, attributes);
    }

    /* Please see man pages for details 
        

           

        
    */
    void SetOpenParticipation(qBool openParticipation)
    {
        this->openParticipation = openParticipation;
    }

    /* Please see man pages for details 
        

        
    */
    qBool GetOpenParticipation() const
    {
        return openParticipation;
    }

    /* Please see man pages for details 
        

           

        
    */
    void SetApplicationBuffer(const qVector<qUnsignedInt8>& applicationBuffer)
    {
        this->applicationBuffer = applicationBuffer;
    }

    /* Please see man pages for details 
        

        
    */
    void GetApplicationBuffer(qVector<qUnsignedInt8>* pApplicationBuffer) const
    {
        SYSTEMCHECK(pApplicationBuffer != NULL);
        *pApplicationBuffer = this->applicationBuffer;
    };

    /* Please see man pages for details 
        

           

        
        
    */
    qBool SetProgressScore(qUnsignedInt8 progressScore)
    {
        if (progressScore > MAX_PROGRESS_SCORE)
        {
            return false;
        }
        this->progressScore = progressScore;
        return true;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt8 GetProgressScore() const
    {
        return progressScore;
    }

    /* Please see man pages for details 
        

           

        
    */
    void SetMatchmakeParam(const MatchmakeParam& matchmakeParam)
    {
        this->matchmakeParam = matchmakeParam;
    }

    /* Please see man pages for details 
        

        
    */
    const MatchmakeParam& GetMatchmakeParam() const
    {
        return matchmakeParam;
    }

    /* Please see man pages for details 
        

           
           

        
    */
    void SetUserPassword(const String& userPassword)
    {
        this->userPassword = userPassword;
    }

    /* Please see man pages for details 
        

        
    */
    const String& GetUserPassword() const
    {
        return userPassword;
    }

    /* Please see man pages for details 
        

           
           

        
    */
    void SetStartedTime(const DateTime& startedTime = DateTime::Future)
    {
        this->startedTime = startedTime;
    };

    /* Please see man pages for details 
        

        
    */
    const DateTime& GetStartedTime() const
    {
        return startedTime;
    }

    /*
        

           

        
    */
    void SetGameMode(qUnsignedInt32 gameMode)
    {
        this->gameMode = gameMode;
    };

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetGameMode() const
    {
        return gameMode;
    }

    /* Please see man pages for details 
        

            

        
    */
    void SetDescription(const String& description)
    {
        this->description = description;
    }

    /* Please see man pages for details 
        

            

        
    */
    const String& GetDescription() const
    {
        return description;
    }

    /* Please see man pages for details 
        

            

        
    */
    void SetMinParticipants(qUnsignedInt16 minParticipants)
    {
        this->minParticipants = minParticipants;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt16 GetMinParticipants() const
    {
        return minParticipants;
    }

    /* Please see man pages for details 
        

            
            
            
            

        
     */
    void SetMaxParticipants(qUnsignedInt16 maxParticipants)
    {
        this->maxParticipants = maxParticipants;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt16 GetMaxParticipants() const
    {
        return maxParticipants;
    }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        SetTargetGatheringId(INVALID_GATHERINGID);
        SetModificationFlag(MATCHMAKE_SESSION_MODIFICATION_FLAG_NONE);
        qUnsignedInt32 attributes[NUM_MATCHMAKE_SESSION_ATTRIBUTES];
        memset(attributes, 0, sizeof(attributes));
        SetAttribute(attributes);
        SetOpenParticipation(true);
        SetApplicationBuffer(qVector<qUnsignedInt8>());
        SetProgressScore(MAX_PROGRESS_SCORE);
        SetMatchmakeParam(MatchmakeParam());
        SetUserPassword(String());
        SetStartedTime(DateTime::Never);
        SetGameMode(0);
        SetDescription(String());
        SetMaxParticipants(0);
        SetMinParticipants(0);
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, *this);
    }

    /* Please see man pages for details 
        
        
    */
    inline friend StringStream& operator<<(StringStream& oStr, const UpdateMatchmakeSessionParam& rhs);
};

inline StringStream& operator<<(StringStream& oStr, const UpdateMatchmakeSessionParam& rhs)
{
    oStr << _T("UpdateMatchmakeSessionParam: (")
               << _T("gid=") << rhs.gid
               << _T(", modificationFlag=") << rhs.modificationFlag;

    {
        oStr << _T(", attributes=(");
        qVector<qUnsignedInt32>::const_iterator itr = rhs.attributes.begin();
        for (int i = 0; itr != rhs.attributes.end(); ++i, ++itr)
        {
            if (i != 0)
            {
                oStr << _T(", ");
            }
            oStr << *itr;
        }
        oStr << _T(")");
    }

    oStr << _T(", openParticipation=") << rhs.openParticipation
         << _T(", applicationBuffer=(not implemented)")
         << _T(", progressScore=") << rhs.progressScore
         << _T(", matchmakeParam=") << rhs.matchmakeParam
         << _T(", startedTime=") << rhs.startedTime
         << _T(", userPassword=") << rhs.userPassword
         << _T(")");
    return oStr;
}

END_NAMESPACE_NEX

#endif // _UpdateMatchmakeSessionParam_H_
