﻿/*---------------------------------------------------------------------------*
  Copyright (C) 2011-2014 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef _MATCHMAKE_REFEREE_CLIENT_H_
#define _MATCHMAKE_REFEREE_CLIENT_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Core/src/Client/ServiceClient.h>
#include <RendezVous/Services/Jugem/MatchmakeReferee/src/Common/MatchmakeRefereeConstants.h>
#include <RendezVous/Services/Jugem/MatchmakeReferee/src/Common/MatchmakeRefereeDDF.h>
#include <RendezVous/Services/Jugem/MatchmakeReferee/src/Common/MatchmakeRefereeProtocolDDL.h>
#include <RendezVous/Services/Jugem/MatchmakeReferee/src/Common/MatchmakeRefereeErrors.h>
#include <RendezVous/Services/Jugem/MatchmakeReferee/src/Common/MatchmakeRefereeSuccesses.h>
#include <RendezVous/Services/Jugem/MatchmakeReferee/src/Common/MatchmakeRefereeStatsTarget.h>
#include <RendezVous/Services/Jugem/MatchmakeReferee/src/Common/MatchmakeRefereePersonalRoundResult.h>
#include <RendezVous/Services/Jugem/MatchmakeReferee/src/Common/MatchmakeRefereeStats.h>
#include <RendezVous/Services/Jugem/MatchmakeReferee/src/Common/MatchmakeRefereeStatsInitParam.h>
#include <RendezVous/Services/Jugem/MatchmakeReferee/src/Common/MatchmakeRefereeRound.h>
#include <RendezVous/Services/Jugem/MatchmakeReferee/src/Common/MatchmakeRefereeEndRoundParam.h>
#include <RendezVous/Services/Jugem/MatchmakeReferee/src/Common/MatchmakeRefereeStartRoundParam.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class MatchmakeRefereeClient : public ServiceClient
{
public:

    /* Please see man pages for details 
    

       
    */
    MatchmakeRefereeClient();

    /* Please see man pages for details 
    

       
    */
    virtual ~MatchmakeRefereeClient();

    /* Please see man pages for details 
        

        

        
    */
    qBool Bind(Credentials* pCredentials);

    /* Please see man pages for details 
        

        
    */
    qBool Unbind();

    void UpdateProtocolsDefaultCredentials(Credentials* pCredentials);

    /* Please see man pages for details 
        

        
        
        
        

        
        
        

        
        
        

        
    */
    qBool StartRound(ProtocolCallContext* pCC, const MatchmakeRefereeStartRoundParam& param, qUnsignedInt64* roundId);

    /* Please see man pages for details 
        

        

        
        
        

        
    */
    qBool GetStartRoundParam(ProtocolCallContext* pCC, qUnsignedInt64 roundId, MatchmakeRefereeStartRoundParam* param);

    /* Please see man pages for details 
        

        
        
        
        
        
        

        

        
        
        
        
        
        
        

        
        

        
    */
    qBool EndRound(ProtocolCallContext* pCC, const MatchmakeRefereeEndRoundParam& endRoundParam);

    /* Please see man pages for details 
        

        
        
        
        
        
        

        
        
        
        

        
        

        
    */
    qBool EndRoundWithoutReport(ProtocolCallContext* pCC, qUnsignedInt64 roundId);

    /* Please see man pages for details 
        

        
        
        

        
    */
    qBool GetRoundParticipants(ProtocolCallContext* pCC, qUnsignedInt64 roundId, qVector<PrincipalID>* pids);

    /* Please see man pages for details 
        

        

        
        

        
    */
    qBool GetNotSummarizedRound(ProtocolCallContext* pCC, qVector<MatchmakeRefereeRound>* rounds);

    /* Please see man pages for details 
        

        

        

        
        
        

        
    */
    qBool GetRound(ProtocolCallContext* pCC, qUnsignedInt64 roundId, MatchmakeRefereeRound* round);

    /* Please see man pages for details 
    

       

        

        
        
        

        
    */
    qBool GetStats(ProtocolCallContext* pCC, const MatchmakeRefereeStatsTarget& target, MatchmakeRefereeStats* stats);

    /* Please see man pages for details 
    

       

        
        
        
        
                                      

        
    */
    qBool GetStats(ProtocolCallContext* pCC, const qVector<MatchmakeRefereeStatsTarget>& targets, qVector<MatchmakeRefereeStats>* stats, qVector<qResult>* results);

    /* Please see man pages for details 
    

        

        

        
        
        

        
    */
    qBool GetStats(ProtocolCallContext* pCC, const MatchmakeRefereeStatsTarget& target, qVector<MatchmakeRefereeStats>* stats);

    /* Please see man pages for details 
        

       

        
        

        
    */
    qBool CreateStats(ProtocolCallContext* pCC, const MatchmakeRefereeStatsInitParam& param);

    /* Please see man pages for details 
        

        
        
        

        
    */
    qBool GetOrCreateStats(ProtocolCallContext* pCC, const MatchmakeRefereeStatsInitParam& param, MatchmakeRefereeStats* stats);


private:
    qBool m_bProtocolRegistered;
    MatchmakeRefereeProtocolClient m_oProtocol;
};

END_NAMESPACE_NEX

#endif // _MATCHMAKE_REFEREE_CLIENT_H_
