﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2014 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef _MATCHMAKEREFEREE_CONSTANTS_H
#define _MATCHMAKEREFEREE_CONSTANTS_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
namespace MatchmakeRefereeConstants
{

/// The maximum length of the buffer than can be set for MatchmakeRefereePersonalRoundResult.
static const qUnsignedInt32 STATS_BUFFER_MAX_SIZE = 128;

/* Please see man pages for details 
    
*/
enum RoundState
{
    ROUND_STATE_FIGHT             = 0, //
    ROUND_STATE_ARBITRATION       = 1, //
    ROUND_STATE_RESULT_AVAILABLE  = 2, //
    ROUND_STATE_NO_CONTEST        = 3  //
};

/* Please see man pages for details 
    
*/
enum PersonalRoundResultFlag
{
    PERSONAL_ROUND_RESULT_FLAG_NONE       = 0x0000, //
    PERSONAL_ROUND_RESULT_FLAG_DISCONNECT = 0x0001, //
    PERSONAL_ROUND_RESULT_FLAG_VIOLATION  = 0x0002  //
};

/* Please see man pages for details 
    
*/
enum RoundResult
{
    ROUND_RESULT_LOSS  = 0, //
    ROUND_RESULT_WIN   = 1, //
    ROUND_RESULT_DRAW  = 2  //
};

}

END_NAMESPACE_NEX

#endif
