#ifndef _Quazal_MatchmakeRefereeProtocolDDL_H_
#define _Quazal_MatchmakeRefereeProtocolDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "MatchmakeRefereeStartRoundParam.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "MatchmakeRefereeEndRoundParam.h"
#include "MatchmakeRefereeRound.h"
#include "MatchmakeRefereeStatsTarget.h"
#include "MatchmakeRefereeStats.h"
#include "MatchmakeRefereeStatsInitParam.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(MatchmakeRefereeProtocol, StartRound, 1 );
PROTO_DEFINE_RMCID(MatchmakeRefereeProtocol, GetStartRoundParam, 2 );
PROTO_DEFINE_RMCID(MatchmakeRefereeProtocol, EndRound, 3 );
PROTO_DEFINE_RMCID(MatchmakeRefereeProtocol, EndRoundWithoutReport, 4 );
PROTO_DEFINE_RMCID(MatchmakeRefereeProtocol, GetRoundParticipants, 5 );
PROTO_DEFINE_RMCID(MatchmakeRefereeProtocol, GetNotSummarizedRound, 6 );
PROTO_DEFINE_RMCID(MatchmakeRefereeProtocol, GetRound, 7 );
PROTO_DEFINE_RMCID(MatchmakeRefereeProtocol, GetStatsPrimary, 8 );
PROTO_DEFINE_RMCID(MatchmakeRefereeProtocol, GetStatsPrimaries, 9 );
PROTO_DEFINE_RMCID(MatchmakeRefereeProtocol, GetStatsAll, 10 );
PROTO_DEFINE_RMCID(MatchmakeRefereeProtocol, CreateStats, 11 );
PROTO_DEFINE_RMCID(MatchmakeRefereeProtocol, GetOrCreateStats, 12 );
PROTO_DEFINE_NUM_RMC(MatchmakeRefereeProtocol, 12);

class MatchmakeRefereeProtocolClient : public ClientProtocol {
    public:
        typedef CLASSMETATYPE(MatchmakeRefereeStartRoundParam) TStartRound_param;
        typedef DDLTYPE(uint64) TStartRound_roundId;
        PROTO_RMCIMPL_RETURN(MatchmakeRefereeProtocol, StartRound)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TStartRound_roundId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint64) TGetStartRoundParam_roundId;
        typedef CLASSMETATYPE(MatchmakeRefereeStartRoundParam) TGetStartRoundParam_param;
        PROTO_RMCIMPL_RETURN(MatchmakeRefereeProtocol, GetStartRoundParam)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetStartRoundParam_param,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MatchmakeRefereeEndRoundParam) TEndRound_endRoundParam;
        PROTO_RMCIMPL_RETURN(MatchmakeRefereeProtocol, EndRound)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint64) TEndRoundWithoutReport_roundId;
        PROTO_RMCIMPL_RETURN(MatchmakeRefereeProtocol, EndRoundWithoutReport)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint64) TGetRoundParticipants_roundId;
        typedef DDLTYPE(qvector)< DDLTYPE(uint32) > TGetRoundParticipants_pids;
        PROTO_RMCIMPL_RETURN(MatchmakeRefereeProtocol, GetRoundParticipants)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetRoundParticipants_pids,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeRound) > TGetNotSummarizedRound_rounds;
        PROTO_RMCIMPL_RETURN(MatchmakeRefereeProtocol, GetNotSummarizedRound)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetNotSummarizedRound_rounds,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint64) TGetRound_roundId;
        typedef CLASSMETATYPE(MatchmakeRefereeRound) TGetRound_round;
        PROTO_RMCIMPL_RETURN(MatchmakeRefereeProtocol, GetRound)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetRound_round,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MatchmakeRefereeStatsTarget) TGetStatsPrimary_target;
        typedef CLASSMETATYPE(MatchmakeRefereeStats) TGetStatsPrimary_stats;
        PROTO_RMCIMPL_RETURN(MatchmakeRefereeProtocol, GetStatsPrimary)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetStatsPrimary_stats,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStatsTarget) > TGetStatsPrimaries_targets;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStats) > TGetStatsPrimaries_stats;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetStatsPrimaries_results;
        PROTO_RMCIMPL_RETURN(MatchmakeRefereeProtocol, GetStatsPrimaries)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetStatsPrimaries_stats,1);
            _DO_RMC_ExtractReturnValue(TGetStatsPrimaries_results,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MatchmakeRefereeStatsTarget) TGetStatsAll_target;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStats) > TGetStatsAll_stats;
        PROTO_RMCIMPL_RETURN(MatchmakeRefereeProtocol, GetStatsAll)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetStatsAll_stats,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MatchmakeRefereeStatsInitParam) TCreateStats_param;
        PROTO_RMCIMPL_RETURN(MatchmakeRefereeProtocol, CreateStats)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MatchmakeRefereeStatsInitParam) TGetOrCreateStats_param;
        typedef CLASSMETATYPE(MatchmakeRefereeStats) TGetOrCreateStats_stats;
        PROTO_RMCIMPL_RETURN(MatchmakeRefereeProtocol, GetOrCreateStats)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetOrCreateStats_stats,1);
            PROTO_RETURNSTUB_END();
        };
        
        MatchmakeRefereeProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew MatchmakeRefereeProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallStartRound(ProtocolCallContext *pContext, const MatchmakeRefereeStartRoundParam& param, DDLTYPE(uint64)::CPPType* roundId);
        static qBool StartRound_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MatchmakeRefereeStartRoundParam& param, DDLTYPE(uint64)::CPPType* roundId);
        qBool CallGetStartRoundParam(ProtocolCallContext *pContext, const DDLTYPE(uint64)::CPPType& roundId, MatchmakeRefereeStartRoundParam* param);
        static qBool GetStartRoundParam_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint64)::CPPType& roundId, MatchmakeRefereeStartRoundParam* param);
        qBool CallEndRound(ProtocolCallContext *pContext, const MatchmakeRefereeEndRoundParam& endRoundParam);
        static qBool EndRound_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MatchmakeRefereeEndRoundParam& endRoundParam);
        qBool CallEndRoundWithoutReport(ProtocolCallContext *pContext, const DDLTYPE(uint64)::CPPType& roundId);
        static qBool EndRoundWithoutReport_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint64)::CPPType& roundId);
        qBool CallGetRoundParticipants(ProtocolCallContext *pContext, const DDLTYPE(uint64)::CPPType& roundId, DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType* pids);
        static qBool GetRoundParticipants_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint64)::CPPType& roundId, DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType* pids);
        qBool CallGetNotSummarizedRound(ProtocolCallContext *pContext, DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeRound) >::CPPType* rounds);
        static qBool GetNotSummarizedRound_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeRound) >::CPPType* rounds);
        qBool CallGetRound(ProtocolCallContext *pContext, const DDLTYPE(uint64)::CPPType& roundId, MatchmakeRefereeRound* round);
        static qBool GetRound_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint64)::CPPType& roundId, MatchmakeRefereeRound* round);
        qBool CallGetStatsPrimary(ProtocolCallContext *pContext, const MatchmakeRefereeStatsTarget& target, MatchmakeRefereeStats* stats);
        static qBool GetStatsPrimary_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MatchmakeRefereeStatsTarget& target, MatchmakeRefereeStats* stats);
        qBool CallGetStatsPrimaries(ProtocolCallContext *pContext, const DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStatsTarget) >::CPPType& targets, DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStats) >::CPPType* stats, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* results);
        static qBool GetStatsPrimaries_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStatsTarget) >::CPPType& targets, DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStats) >::CPPType* stats, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* results);
        qBool CallGetStatsAll(ProtocolCallContext *pContext, const MatchmakeRefereeStatsTarget& target, DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStats) >::CPPType* stats);
        static qBool GetStatsAll_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MatchmakeRefereeStatsTarget& target, DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStats) >::CPPType* stats);
        qBool CallCreateStats(ProtocolCallContext *pContext, const MatchmakeRefereeStatsInitParam& param);
        static qBool CreateStats_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MatchmakeRefereeStatsInitParam& param);
        qBool CallGetOrCreateStats(ProtocolCallContext *pContext, const MatchmakeRefereeStatsInitParam& param, MatchmakeRefereeStats* stats);
        static qBool GetOrCreateStats_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MatchmakeRefereeStatsInitParam& param, MatchmakeRefereeStats* stats);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(MatchmakeRefereeProtocol) + 1];
};

class DDLPROTOCOL(MatchmakeRefereeProtocolServer) : public ServerProtocol {
    public:
        typedef CLASSMETATYPE(MatchmakeRefereeStartRoundParam) TStartRound_param;
        typedef DDLTYPE(uint64) TStartRound_roundId;
        PROTO_RMCIMPL_STUB(MatchmakeRefereeProtocol, StartRound)
        {
            PROTO_PREPARE_EXTRACTION();
            MatchmakeRefereeStartRoundParam param;
            _MSG_EXTRACT_VARIABLE(TStartRound_param, param);
            DDLTYPE(uint64)::CPPType roundId;
            pProtocol->StartRound( param, &roundId );
            PROTO_PREPARE_RETURN(MatchmakeRefereeProtocol,StartRound);
            _MSG_ADD_VARIABLE(TStartRound_roundId, roundId);
        }
        
        typedef DDLTYPE(uint64) TGetStartRoundParam_roundId;
        typedef CLASSMETATYPE(MatchmakeRefereeStartRoundParam) TGetStartRoundParam_param;
        PROTO_RMCIMPL_STUB(MatchmakeRefereeProtocol, GetStartRoundParam)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint64)::CPPType roundId;
            _MSG_EXTRACT_VARIABLE(TGetStartRoundParam_roundId, roundId);
            MatchmakeRefereeStartRoundParam param;
            pProtocol->GetStartRoundParam( roundId, &param );
            PROTO_PREPARE_RETURN(MatchmakeRefereeProtocol,GetStartRoundParam);
            _MSG_ADD_VARIABLE(TGetStartRoundParam_param, param);
        }
        
        typedef CLASSMETATYPE(MatchmakeRefereeEndRoundParam) TEndRound_endRoundParam;
        PROTO_RMCIMPL_STUB(MatchmakeRefereeProtocol, EndRound)
        {
            PROTO_PREPARE_EXTRACTION();
            MatchmakeRefereeEndRoundParam endRoundParam;
            _MSG_EXTRACT_VARIABLE(TEndRound_endRoundParam, endRoundParam);
            pProtocol->EndRound( endRoundParam );
            PROTO_PREPARE_RETURN(MatchmakeRefereeProtocol,EndRound);
        }
        
        typedef DDLTYPE(uint64) TEndRoundWithoutReport_roundId;
        PROTO_RMCIMPL_STUB(MatchmakeRefereeProtocol, EndRoundWithoutReport)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint64)::CPPType roundId;
            _MSG_EXTRACT_VARIABLE(TEndRoundWithoutReport_roundId, roundId);
            pProtocol->EndRoundWithoutReport( roundId );
            PROTO_PREPARE_RETURN(MatchmakeRefereeProtocol,EndRoundWithoutReport);
        }
        
        typedef DDLTYPE(uint64) TGetRoundParticipants_roundId;
        typedef DDLTYPE(qvector)< DDLTYPE(uint32) > TGetRoundParticipants_pids;
        PROTO_RMCIMPL_STUB(MatchmakeRefereeProtocol, GetRoundParticipants)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint64)::CPPType roundId;
            _MSG_EXTRACT_VARIABLE(TGetRoundParticipants_roundId, roundId);
            DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType pids;
            pProtocol->GetRoundParticipants( roundId, &pids );
            PROTO_PREPARE_RETURN(MatchmakeRefereeProtocol,GetRoundParticipants);
            _MSG_ADD_VARIABLE(TGetRoundParticipants_pids, pids);
        }
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeRound) > TGetNotSummarizedRound_rounds;
        PROTO_RMCIMPL_STUB(MatchmakeRefereeProtocol, GetNotSummarizedRound)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeRound) >::CPPType rounds;
            pProtocol->GetNotSummarizedRound( &rounds );
            PROTO_PREPARE_RETURN(MatchmakeRefereeProtocol,GetNotSummarizedRound);
            _MSG_ADD_VARIABLE(TGetNotSummarizedRound_rounds, rounds);
        }
        
        typedef DDLTYPE(uint64) TGetRound_roundId;
        typedef CLASSMETATYPE(MatchmakeRefereeRound) TGetRound_round;
        PROTO_RMCIMPL_STUB(MatchmakeRefereeProtocol, GetRound)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint64)::CPPType roundId;
            _MSG_EXTRACT_VARIABLE(TGetRound_roundId, roundId);
            MatchmakeRefereeRound round;
            pProtocol->GetRound( roundId, &round );
            PROTO_PREPARE_RETURN(MatchmakeRefereeProtocol,GetRound);
            _MSG_ADD_VARIABLE(TGetRound_round, round);
        }
        
        typedef CLASSMETATYPE(MatchmakeRefereeStatsTarget) TGetStatsPrimary_target;
        typedef CLASSMETATYPE(MatchmakeRefereeStats) TGetStatsPrimary_stats;
        PROTO_RMCIMPL_STUB(MatchmakeRefereeProtocol, GetStatsPrimary)
        {
            PROTO_PREPARE_EXTRACTION();
            MatchmakeRefereeStatsTarget target;
            _MSG_EXTRACT_VARIABLE(TGetStatsPrimary_target, target);
            MatchmakeRefereeStats stats;
            pProtocol->GetStatsPrimary( target, &stats );
            PROTO_PREPARE_RETURN(MatchmakeRefereeProtocol,GetStatsPrimary);
            _MSG_ADD_VARIABLE(TGetStatsPrimary_stats, stats);
        }
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStatsTarget) > TGetStatsPrimaries_targets;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStats) > TGetStatsPrimaries_stats;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetStatsPrimaries_results;
        PROTO_RMCIMPL_STUB(MatchmakeRefereeProtocol, GetStatsPrimaries)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStatsTarget) >::CPPType targets;
            _MSG_EXTRACT_VARIABLE(TGetStatsPrimaries_targets, targets);
            DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStats) >::CPPType stats;
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType results;
            pProtocol->GetStatsPrimaries( targets, &stats, &results );
            PROTO_PREPARE_RETURN(MatchmakeRefereeProtocol,GetStatsPrimaries);
            _MSG_ADD_VARIABLE(TGetStatsPrimaries_stats, stats);
            _MSG_ADD_VARIABLE(TGetStatsPrimaries_results, results);
        }
        
        typedef CLASSMETATYPE(MatchmakeRefereeStatsTarget) TGetStatsAll_target;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStats) > TGetStatsAll_stats;
        PROTO_RMCIMPL_STUB(MatchmakeRefereeProtocol, GetStatsAll)
        {
            PROTO_PREPARE_EXTRACTION();
            MatchmakeRefereeStatsTarget target;
            _MSG_EXTRACT_VARIABLE(TGetStatsAll_target, target);
            DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStats) >::CPPType stats;
            pProtocol->GetStatsAll( target, &stats );
            PROTO_PREPARE_RETURN(MatchmakeRefereeProtocol,GetStatsAll);
            _MSG_ADD_VARIABLE(TGetStatsAll_stats, stats);
        }
        
        typedef CLASSMETATYPE(MatchmakeRefereeStatsInitParam) TCreateStats_param;
        PROTO_RMCIMPL_STUB(MatchmakeRefereeProtocol, CreateStats)
        {
            PROTO_PREPARE_EXTRACTION();
            MatchmakeRefereeStatsInitParam param;
            _MSG_EXTRACT_VARIABLE(TCreateStats_param, param);
            pProtocol->CreateStats( param );
            PROTO_PREPARE_RETURN(MatchmakeRefereeProtocol,CreateStats);
        }
        
        typedef CLASSMETATYPE(MatchmakeRefereeStatsInitParam) TGetOrCreateStats_param;
        typedef CLASSMETATYPE(MatchmakeRefereeStats) TGetOrCreateStats_stats;
        PROTO_RMCIMPL_STUB(MatchmakeRefereeProtocol, GetOrCreateStats)
        {
            PROTO_PREPARE_EXTRACTION();
            MatchmakeRefereeStatsInitParam param;
            _MSG_EXTRACT_VARIABLE(TGetOrCreateStats_param, param);
            MatchmakeRefereeStats stats;
            pProtocol->GetOrCreateStats( param, &stats );
            PROTO_PREPARE_RETURN(MatchmakeRefereeProtocol,GetOrCreateStats);
            _MSG_ADD_VARIABLE(TGetOrCreateStats_stats, stats);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void StartRound(const MatchmakeRefereeStartRoundParam& param, DDLTYPE(uint64)::CPPType* roundId) = 0;
        virtual void GetStartRoundParam(const DDLTYPE(uint64)::CPPType& roundId, MatchmakeRefereeStartRoundParam* param) = 0;
        virtual void EndRound(const MatchmakeRefereeEndRoundParam& endRoundParam) = 0;
        virtual void EndRoundWithoutReport(const DDLTYPE(uint64)::CPPType& roundId) = 0;
        virtual void GetRoundParticipants(const DDLTYPE(uint64)::CPPType& roundId, DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType* pids) = 0;
        virtual void GetNotSummarizedRound(DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeRound) >::CPPType* rounds) = 0;
        virtual void GetRound(const DDLTYPE(uint64)::CPPType& roundId, MatchmakeRefereeRound* round) = 0;
        virtual void GetStatsPrimary(const MatchmakeRefereeStatsTarget& target, MatchmakeRefereeStats* stats) = 0;
        virtual void GetStatsPrimaries(const DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStatsTarget) >::CPPType& targets, DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStats) >::CPPType* stats, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* results) = 0;
        virtual void GetStatsAll(const MatchmakeRefereeStatsTarget& target, DDLTYPE(qvector)< CLASSMETATYPE(MatchmakeRefereeStats) >::CPPType* stats) = 0;
        virtual void CreateStats(const MatchmakeRefereeStatsInitParam& param) = 0;
        virtual void GetOrCreateStats(const MatchmakeRefereeStatsInitParam& param, MatchmakeRefereeStats* stats) = 0;
    };


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_MatchmakeRefereeProtocolDDL.h_H_
