﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2014 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef _MATCHMAKE_REFEREE_ROUND_H
#define _MATCHMAKE_REFEREE_ROUND_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Services/MatchMaking/src/Common/GatheringID.h>
#include "MatchmakeRefereeRoundDDL.h"
#include "MatchmakeRefereePersonalRoundResult.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class MatchmakeRefereeRound: public DDLCLASS(MatchmakeRefereeRound)
{
public:
    /* Please see man pages for details 
        
    */
    MatchmakeRefereeRound()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~MatchmakeRefereeRound() {}

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        this->roundId = 0;
        this->gid = INVALID_GATHERINGID;
        this->state = 0;
        this->personalDataCategory = 0;
        this->normalizedPersonalRoundResults.clear();
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetRoundId() const
    {
        return this->roundId;
    }

    /* Please see man pages for details 
        

        
    */
    GatheringID GetGatheringId() const
    {
        return this->gid;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetState() const
    {
        return this->state;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetPersonalDataCategory() const
    {
        return this->personalDataCategory;
    }

    /* Please see man pages for details 
        

        
    */
    const qVector<MatchmakeRefereePersonalRoundResult>& GetNormalizedRoundResult() const
    {
        return this->normalizedPersonalRoundResults;
    }


    /* Please see man pages for details 
        

        
        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS, qBool bShowBufferContents=false) const
    {
        QTRACE(uiTraceFlags, _T("MatchmakeRefereeRound: (")
                            << _T("roundId=") << this->roundId
                            << _T(", gid=") << this->gid
                            << _T(", state=") << state
                            << _T(", personalDataCategory=") << this->personalDataCategory
                            << _T(", normalizedPersonalRoundResults size=") << this->normalizedPersonalRoundResults.size()
                            << _T(", normalizedPersonalRoundResults contents="));
        for (qVector<MatchmakeRefereePersonalRoundResult>::const_iterator it = this->normalizedPersonalRoundResults.begin(); 
             it != this->normalizedPersonalRoundResults.end(); ++it)
        {
            it->Trace(uiTraceFlags, bShowBufferContents);
        }
    }
};

END_NAMESPACE_NEX

#endif
