﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2014 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef _MATCHMAKE_REFEREE_START_ROUND_PARAM_H
#define _MATCHMAKE_REFEREE_START_ROUND_PARAM_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Services/MatchMaking/src/Common/GatheringID.h>
#include "MatchmakeRefereeStartRoundParamDDL.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class MatchmakeRefereeStartRoundParam: public DDLCLASS(MatchmakeRefereeStartRoundParam)
{
public:
    /* Please see man pages for details 
        
    */
    MatchmakeRefereeStartRoundParam()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~MatchmakeRefereeStartRoundParam() {}

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        SetPersonalDataCategory(0);
        SetGatheringId(INVALID_GATHERINGID);
        SetPrincipalIds(qVector<PrincipalID>());
    }

    /* Please see man pages for details 
        

        

        
    */
    void SetPersonalDataCategory(qUnsignedInt32 personalDataCategory)
    {
        this->personalDataCategory = personalDataCategory;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetPersonalDataCategory() const
    {
        return this->personalDataCategory;
    }

    /* Please see man pages for details 
        

        
    */
    void SetGatheringId(GatheringID gid)
    {
        this->gid = gid;
    }

    /* Please see man pages for details 
        

        
    */
    GatheringID GetGatheringId() const
    {
        return this->gid;
    }

    /* Please see man pages for details 
        

        
    */
    void SetPrincipalIds(const qVector<PrincipalID>& pids)
    {
        this->pids = pids;
    }

    /* Please see man pages for details 
        

        
    */
    const qVector<PrincipalID>& GetPrincipalIds() const
    {
        return this->pids;
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        StringStream ss;
        ss << _T("MatchmakeRefereeStartRoundParam: (")
           << _T("personalDataCategory=") << this->personalDataCategory
           << _T(", gid=") << this->gid;
        ss << _T(", pids=(");
        for (qVector<PrincipalID>::const_iterator it = this->pids.begin(); it != this->pids.end(); ++it)
        {
            ss << *it << _T(", ");
        }
        ss << _T("))");
        QTRACE(uiTraceFlags, ss.CStr());
    }
};

END_NAMESPACE_NEX

#endif
