﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2014 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef _MATCHMAKE_REFEREE_STATS_H
#define _MATCHMAKE_REFEREE_STATS_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Services/Jugem/Utility/src/Common/UniqueId.h>
#include "MatchmakeRefereeStatsDDL.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class MatchmakeRefereeStats: public DDLCLASS(MatchmakeRefereeStats)
{
public:
    /* Please see man pages for details 
        
    */
    MatchmakeRefereeStats()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~MatchmakeRefereeStats() {}

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        this->uniqueId = INVALID_UNIQUEID;
        this->category = 0;
        this->pid = 0;
        this->recentDisconnection = 0;
        this->recentViolation = 0;
        this->recentMismatch = 0;
        this->recentWin = 0;
        this->recentLoss = 0;
        this->recentDraw = 0;
        this->totalDisconnect = 0;
        this->totalViolation = 0;
        this->totalMismatch = 0;
        this->totalWin = 0;
        this->totalLoss = 0;
        this->totalDraw = 0;
        this->ratingValue = 0;
    }

    /* Please see man pages for details 
        

        

        
    */
    qBool IsValid() const
    {
        return this->uniqueId != INVALID_UNIQUEID;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetUniqueId() const
    {
        return this->uniqueId;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetCategory() const
    {
        return this->category;
    }

    /* Please see man pages for details 
        

        
    */
    PrincipalID GetPrincipalId() const
    {
        return this->pid;
    }

    /* Please see man pages for details 
        

        

        
    */
    qUnsignedInt32 GetRecentDisconnectCount() const
    {
        return this->recentDisconnection;
    }

    /* Please see man pages for details 
        

        

        
    */
    qUnsignedInt32 GetRecentViolationCount() const
    {
        return this->recentViolation;
    }

    /* Please see man pages for details 
        

        
        

        
    */
    qUnsignedInt32 GetRecentMismatchCount() const
    {
        return this->recentMismatch;
    }

    /* Please see man pages for details 
        

        

        
    */
    qUnsignedInt32 GetRecentWinCount() const
    {
        return this->recentWin;
    }

    /* Please see man pages for details 
        

        

        
    */
    qUnsignedInt32 GetRecentLossCount() const
    {
        return this->recentLoss;
    }

    /* Please see man pages for details 
        

        

        
    */
    qUnsignedInt32 GetRecentDrawCount() const
    {
        return this->recentDraw;
    }

    /* Please see man pages for details 
        

        

        
    */
    qUnsignedInt32 GetTotalDisconnectCount() const
    {
        return this->totalDisconnect;
    }

    /* Please see man pages for details 
        

        

        
    */
    qUnsignedInt32 GetTotalViolationCount() const
    {
        return this->totalViolation;
    }

    /* Please see man pages for details 
        

        
        

        
    */
    qUnsignedInt32 GetTotalMismatchCount() const
    {
        return this->totalMismatch;
    }

    /* Please see man pages for details 
        

        

        
    */
    qUnsignedInt32 GetTotalWinCount() const
    {
        return this->totalWin;
    }

    /* Please see man pages for details 
        

        

        
    */
    qUnsignedInt32 GetTotalLossCount() const
    {
        return this->totalLoss;
    }

    /* Please see man pages for details 
        

        

        
    */
    qUnsignedInt32 GetTotalDrawCount() const
    {
        return this->totalDraw;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetRatingValue() const
    {
        return this->ratingValue;
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, _T("MatchmakeRefereeStats: (")
               << _T("uniqueId=") << hex << this->uniqueId
               << _T(", category=") << dec << this->category
               << _T(", pid=") << pid
               << _T(", recentDisconnection=") << this->recentDisconnection
               << _T(", recentViolation=") << this->recentViolation
               << _T(", recentMismatch=") << this->recentMismatch
               << _T(", recentWin=") << this->recentWin
               << _T(", recentLoss=") << this->recentLoss
               << _T(", recentDraw=") << this->recentDraw
               << _T(", totalDisconnect=") << this->totalDisconnect
               << _T(", totalViolation=") << this->totalViolation
               << _T(", totalMismatch=") << this->totalMismatch
               << _T(", totalWin=") << this->totalWin
               << _T(", totalLoss=") << this->totalLoss
               << _T(", totalDraw=") << this->totalDraw
               << _T(", ratingValue=") << this->ratingValue
               << _T(")"));
    }
};

END_NAMESPACE_NEX

#endif
