﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef RANKING_CLIENT_H__
#define RANKING_CLIENT_H__

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Core/src/Client/ServiceClient.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingDDF.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingProtocolDDL.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingRankData.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingScoreData.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingOrderParam.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingChangeAttributesParam.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingConstants.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingResult.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingErrors.h>
#include <RendezVous/Services/Jugem/Utility/src/Common/UniqueId.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    

           

           
           
           
           
           
*/
class RankingClient : public ServiceClient
{
public:
    /* Please see man pages for details 
        
    */
    RankingClient();

    /* Please see man pages for details 
        

                       
    */
    virtual ~RankingClient();

    /* Please see man pages for details 
        

        

        
        
    */
    virtual qBool Bind(Credentials* pCredentials);

    /* Please see man pages for details 
        

        
        
    */
    virtual qBool Unbind();

    void UpdateProtocolsDefaultCredentials(Credentials* pCredentials);

    /* Please see man pages for details 
        

            

        
        
        

        
        
    */
    qBool UploadScore(ProtocolCallContext* pContext, const RankingScoreData& scoreData, UniqueId nexUniqueId = INVALID_UNIQUEID);


    /* Please see man pages for details 
        

        

            
            

        
        
        

        
        
    */
    qBool DeleteScore(ProtocolCallContext* pContext, qUnsignedInt32 category, UniqueId nexUniqueId = INVALID_UNIQUEID);

    /* Please see man pages for details 
        

        

            

        
        

        
        
    */
    qBool DeleteScore(ProtocolCallContext* pContext, UniqueId nexUniqueId = INVALID_UNIQUEID);

    /* Please see man pages for details 
        

        

            

        
        
        

        
        
    */
    qBool UploadCommonData(ProtocolCallContext* pContext, const qVector<qByte>& commonData, UniqueId nexUniqueId = INVALID_UNIQUEID);

    /* Please see man pages for details 
        

        

            

        
        
        
        

        
        
    */
    qBool UploadCommonData(ProtocolCallContext* pContext, const void* pCommonData, qByte commonDataSize, UniqueId nexUniqueId = INVALID_UNIQUEID);

    /* Please see man pages for details 
        

            

        
        

        
        
    */
    qBool DeleteCommonData(ProtocolCallContext* pContext, UniqueId nexUniqueId = INVALID_UNIQUEID);

    /* Please see man pages for details 
        

        

            
            

        
        
        
        

        
        
    */
    qBool ChangeAttributes(ProtocolCallContext* pContext, qUnsignedInt32 category, const RankingChangeAttributesParam& changeParam, UniqueId nexUniqueId = INVALID_UNIQUEID);

    /* Please see man pages for details 
        

        

            

        
        
        

        
        
    */
    qBool ChangeAttributes(ProtocolCallContext* pContext, const RankingChangeAttributesParam& changeParam, UniqueId nexUniqueId = INVALID_UNIQUEID);


    /* Please see man pages for details 
        

            

        
        
        

        
        
    */
    qBool GetCommonData(ProtocolCallContext* pContext, qVector<qByte>* pCommonData, UniqueId nexUniqueId = INVALID_UNIQUEID);

    /* Please see man pages for details 
        

            

            
            
            
            
            

            
            
            
            
            
            
            
            
            

            
            
            
            
            
            

            
            
            
            
            

            
            
            

        
        
        
        
        
        
        

        
        
    */
    qBool GetRanking(ProtocolCallContext* pContext, RankingConstants::RankingMode rankingMode, qUnsignedInt32 category, const RankingOrderParam& orderParam, RankingResult* pResult, UniqueId nexUniqueId = INVALID_UNIQUEID, qUnsignedInt32 principalId = INVALID_PRINCIPALID);

    /* Please see man pages for details 
        
        

            

        
        
        
        
        

        
        

        

        
        
        
        

        
        

        
    */
    qBool GetCachedTopXRankings(ProtocolCallContext* pContext, const qVector<qUnsignedInt32>& categories, const qVector<RankingOrderParam>& orderParams, qVector<RankingCachedResult>* pResults);

    /* Please see man pages for details 
        
        

            

        
        
        
        
        

        
        

        
        
        
        

        
        

        
    */
    qBool GetCachedTopXRankings(ProtocolCallContext* pContext, const qVector<qUnsignedInt32>& categories, const RankingOrderParam& orderParam, qVector<RankingCachedResult>* pResults);

    /* Please see man pages for details 
        

        

        
        
        
        

        
        

        
        
        
        

        
        

        
    */
    qBool GetCachedTopXRanking(ProtocolCallContext* pContext, qUnsignedInt32 category, const RankingOrderParam& orderParam, RankingCachedResult* pResult);


    /* Please see man pages for details 
        

            
            

            
            

            

            
            

        
        
        
        
        
        
        

        
        
    */
    qBool GetApproxOrder(ProtocolCallContext* pContext, qUnsignedInt32 category, const RankingOrderParam& orderParam, qUnsignedInt32 score, qUnsignedInt32* pOrder, UniqueId nexUniqueId = INVALID_UNIQUEID, qUnsignedInt32 principalId = INVALID_PRINCIPALID);

    /* Please see man pages for details 
        

            
            
            
            

        
        
        
        
        

        
        
    */
    qBool GetStats(ProtocolCallContext* pContext, qUnsignedInt32 category, const RankingOrderParam& orderParam, qUnsignedInt32 flags, RankingStats* pStats);

    /* Please see man pages for details 
        

            

            
            
            
            
            

            
            
            
            
            

        
        
        
        
        
        
        

        
        
    */
    qBool GetRankingByPIDList(ProtocolCallContext* pContext, qVector<PrincipalID>& principalIdList, RankingConstants::RankingMode rankingMode, qUnsignedInt32 category, const RankingOrderParam& orderParam, RankingResult* pResult, UniqueId nexUniqueId = INVALID_UNIQUEID);

    /* Please see man pages for details 
        

            

            
            

            
            
            

        
        
        
        
        
        
        

        
        
    */
    qBool GetRankingByUniqueIdList(ProtocolCallContext* pContext, qVector<UniqueId>& nexUniqueIdList, RankingConstants::RankingMode rankingMode, qUnsignedInt32 category, const RankingOrderParam& orderParam, RankingResult* pResult, UniqueId nexUniqueId = INVALID_UNIQUEID);

private:
    // Registered flag
    qBool m_bProtocolRegistered;
    // Protocol object
    RankingProtocolClient m_oProtocol;
};

END_NAMESPACE_NEX

#endif // RANKING_CLIENT_H__
