﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _RankingCachedResult_H_
#define _RankingCachedResult_H_

#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingCachedResultDDL.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingResult.h>

BEGIN_NAMESPACE_NEX

#ifdef FOR_DOC_PURPOSE
/* Please see man pages for details 
    
 */
class RankingCachedResult: public RankingResult
#else
class RankingCachedResult: public DDLCLASS(RankingCachedResult)
#endif
{
public:
    /* Please see man pages for details 
        
    */
    RankingCachedResult()
    {
        this->maxLength = 0;
    };

    /* Please see man pages for details 
        
    */
    virtual ~RankingCachedResult() {};

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetMaxLength() const
    {
        return this->maxLength;
    };

    /* Please see man pages for details 
        

        
    */
    DateTime GetCreatedTime() const
    {
        return this->createdTime;
    };


    /* Please see man pages for details 
        

        
    */
    DateTime GetExpiredTime() const
    {
        return this->expiredTime;
    };

    /* Please see man pages for details 
     
     
     */
    enum LocalUpdateState
    {
        UPDATE_SUCCESS = 0, //
        UPDATE_FAILED = 1, //
        UPDATE_ERROR = 2 //
    };

    /* Please see man pages for details 
        

        
        
        
        
        

        

        
        
        
        
        
        

        
        
        
        
        
        
        

        
        
        

        
     */
    LocalUpdateState LocalUpdate(const RankingOrderParam& orderParam,
                const RankingScoreData& scoreData, PrincipalID pid,
                UniqueId nexUniqueId = INVALID_UNIQUEID, DateTime utcCurrentTime = DateTime::Never,
                const void * pCommonData = NULL, qByte commonDataSize = 0
                );


};

END_NAMESPACE_NEX

#endif /* _RankingCachedResult_H_ */
