﻿/*---------------------------------------------------------------------------*
  Copyright (C) 2011-2014 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef _SUBSCRIBE_CLIENT_H_
#define _SUBSCRIBE_CLIENT_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Core/src/Client/ServiceClient.h>
#include <RendezVous/Services/Jugem/Subscriber/src/Common/SubscriberConstants.h>
#include <RendezVous/Services/Jugem/Subscriber/src/Common/SubscriberDDF.h>
#include <RendezVous/Services/Jugem/Subscriber/src/Common/SubscriberProtocolDDL.h>
#include <RendezVous/Services/Jugem/Subscriber/src/Common/SubscriberErrors.h>
#include <RendezVous/Services/Jugem/Subscriber/src/Common/SubscriberSuccesses.h>
#include <RendezVous/Services/Jugem/Subscriber/src/Client/SubscriberUtil.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class SubscriberClient : public ServiceClient
{
public:

    /* Please see man pages for details 
    

       
    */
    SubscriberClient();

    /* Please see man pages for details 
    

       
    */
    virtual ~SubscriberClient();

    /* Please see man pages for details 
        

        

        
    */
    qBool Bind(Credentials* pCredentials);

    /* Please see man pages for details 
        

        
    */
    qBool Unbind();

    virtual void UpdateProtocolsDefaultCredentials(Credentials* pCredentials);

    /* Please see man pages for details 
        

        

        
        
        

            
            
                                            
                                            
                                            

        
        
        

        
        
    */
    qBool PostContent(ProtocolCallContext* pContext, const SubscriberPostContentParam& param, qUnsignedInt64* contentId);

    /* Please see man pages for details 
        

        
        
        
        

        
        
        
        

        
        
        

            
            

        
        
        

        
        
    */
    qBool GetContent(ProtocolCallContext* pContext, const SubscriberGetContentParam& param, qVector<SubscriberContent>* contents);

    /* Please see man pages for details 
        

        

        
        

        
        
        

            
            
                                            

        
        

        
        
    */
    qBool Follow(ProtocolCallContext* pContext, const qVector<String>& topics);

    /* Please see man pages for details 
        

        

        
        

        
        
        

            
            
                                            

        
        

        
        
    */
    qBool Follow(ProtocolCallContext* pContext, const String& topic);

    /* Please see man pages for details 
        

        

        
        
        

            
            

        
        

        
        
    */
    qBool Unfollow(ProtocolCallContext* pContext, const qVector<String>& topics);

    /* Please see man pages for details 
        

        

        
        
        

            
            

        
        

        
        
    */
    qBool Unfollow(ProtocolCallContext* pContext, const String& topic);

    /* Please see man pages for details 
        

        

        
        
    */
    qBool UnfollowAll(ProtocolCallContext* pContext);

    /* Please see man pages for details 
        

        

        
        
        

            
            
                                            

        
        

        
        
    */
    qBool UnfollowAllAndFollow(ProtocolCallContext* pContext, const qVector<String>& topics);

    /* Please see man pages for details 
        

        
        
        

        
        
    */
    qBool GetFollowing(ProtocolCallContext* pContext, qVector<String>* topics, PrincipalID pid=INVALID_PRINCIPALID);

    /* Please see man pages for details 
        

        

        
        
        

            
            
                                            

        
        
        

        
        
    */
    qBool GetFollower(ProtocolCallContext* pContext, const SubscriberGetFollowerParam& param, SubscriberGetFollowerResult* result);

    /* Please see man pages for details 
        

        
        
        

            
            

        
        
        

        
        
    */
    qBool GetNumFollowers(ProtocolCallContext* pContext, const String& topic, qUnsignedInt32* numFollowers);

    /* Please see man pages for details 
        

        
        
        
        
        
        
        

        
        
        

        
        
        

            

        
        
        

        
        
    */
    qBool GetTimeline(ProtocolCallContext* pContext, const SubscriberGetTimelineParam& param, qVector<SubscriberContent>* contents);

    /* Please see man pages for details 
        

        
        
        
        
        

        
        
        

            
            
            

        
        
        

        
        
    */
    qBool DeleteContent(ProtocolCallContext* pContext, const qVector<String>& topics, qUnsignedInt64 contentId);

private:
    qBool m_bProtocolRegistered;
    SubscriberProtocolClient m_oProtocol;
};

END_NAMESPACE_NEX

#endif // _SUBSCRIBE_CLIENT_H_
