﻿/*---------------------------------------------------------------------------*
  Copyright (C) 2011-2014 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef _SUBSCRIBER_CONSTANTS_H
#define _SUBSCRIBER_CONSTANTS_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
namespace SubscriberConstants
{
/// Number of content stored in topic. 
static const qUnsignedInt32 MAX_TOPIC_CONTENT_SIZE = 100;

/// Number of content stored in timeline. 
static const qUnsignedInt32 MAX_TIMELINE_CONTENT_SIZE = 100;

/// Maximum number that can be followed.
static const qUnsignedInt32 MAX_FOLLOWING_SIZE = 20;

/// Number of topics that have already been reserved. 
static const qUnsignedInt32 NUM_RESERVED_TOPICS = 128;

/// Invalid reserved topic number. 
static const qUnsignedInt32 INVALID_RESERVED_TOPIC_NUM = 0xffffffff;

/// Maximum number of followers that can be acquired at once. 
static const qUnsignedInt32 MAX_GET_FOLLOWER_SIZE = 1000;

/// Length of message contained in content. 
static const qUnsignedInt32 MAX_CONTENT_MESSAGE_LEN = 140;

/// Size of binary contained in content. 
static const qUnsignedInt32 MAX_CONTENT_BINARY_SIZE = 100;

/// Maxiumum number of topics that may be specified as a target for posting a single content. 
static const qUnsignedInt32 MAX_POST_CONTENT_TOPIC_SIZE = 10;
}

END_NAMESPACE_NEX

#endif
