﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _SUBSCRIBER_CONTENT_H
#define _SUBSCRIBER_CONTENT_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "SubscriberContentDDL.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class SubscriberContent: public DDLCLASS(SubscriberContent)
{
public:
    /* Please see man pages for details 
        
    */
    SubscriberContent()
    {
    }

    /* Please see man pages for details 
        
    */
    virtual ~SubscriberContent() {}

    /* Please see man pages for details 
    

    
    */
    qUnsignedInt64 GetContentId() const { return contentId; }

    /* Please see man pages for details 
    

    
    */
    const String& GetMessage() const { return message; }

    /* Please see man pages for details 
    

    

    
    */
    qVector<qByte> GetBinary() const
    {
        // Conversion from qBuffer to qVector<qByte>
        qVector<qByte> vb;
        vb.assign(this->binary.begin(), this->binary.end());
        return vb;
    }

    /* Please see man pages for details 
    

    

    

    
    */
    void GetBinary(qVector<qByte>& binary) const
    {
        // Conversion from qBuffer to qVector<qByte>
        binary.assign(this->binary.begin(), this->binary.end());
    }

    /* Please see man pages for details 
    

    
    */
    PrincipalID GetPosterPrincipalId() const { return pid; }

    /* Please see man pages for details 
    

        
        
        

    
    */
    const qVector<String>& GetTopic() const { return topics; }

    /* Please see man pages for details 
    

        
        
        
        
        
        

    
    */
    String GetTopicSingle() const { if (topics.empty()) { return _T(""); } return topics.at(0); }

    /* Please see man pages for details 
    

    
    */
    const DateTime& GetPostDateTime() const { return postTime; }


    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, *this);
    }

    /* Please see man pages for details 
        
        
    */
    inline friend StringStream& operator<<(StringStream& oStr, const SubscriberContent& rhs);
};

inline StringStream& operator<<(StringStream& oStr, const SubscriberContent& rhs)
{
    oStr << _T("SubscriberContent: (")
               << _T("contentId=") << rhs.contentId
               << _T(", message=") << rhs.message
               << _T(", pid=") << rhs.pid
               << _T(", postTime=") << rhs.postTime;

    oStr << _T(", binary=");
    for (qBuffer::const_iterator it = rhs.binary.begin(); it != rhs.binary.end(); ++it)
    {
        oStr << hex << *it;
    }

    oStr << _T(", topics=(");
    for (qVector<String>::const_iterator it = rhs.topics.begin(); it != rhs.topics.end(); ++it)
    {
        oStr << *it << _T(", ");
    }
    oStr << _T(")");

    oStr << _T(")");
    return oStr;
}

END_NAMESPACE_NEX

#endif
