#ifndef _Quazal_SubscriberContentDDL_H_
#define _Quazal_SubscriberContentDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX
class SubscriberContent;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(SubscriberContent): public RootObject {
public:
    DDLCLASS(SubscriberContent)():_mRevision_SubscriberContent(0)
    , topics(0)     {};
    DDLCLASS(SubscriberContent)(const DDLCLASS(SubscriberContent) &oOther):
        RootObject(oOther),
        _mRevision_SubscriberContent(oOther._mRevision_SubscriberContent),
        contentId(oOther.contentId),
        message(oOther.message),
        binary(oOther.binary),
        pid(oOther.pid),
        topics(oOther.topics),
        postTime(oOther.postTime)
    {
    }
    virtual ~DDLCLASS(SubscriberContent)() {};
    const DDLCLASS(SubscriberContent) &operator=(const DDLCLASS(SubscriberContent) &oOther);
    qBool operator==(const DDLCLASS(SubscriberContent) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(SubscriberContent) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(SubscriberContent) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(SubscriberContent) *pValue);
    qByte _mRevision_SubscriberContent;
    qByte GetClassRevision_SubscriberContent() const {return _mRevision_SubscriberContent;}
    void SetClassRevision_SubscriberContent(qByte revision) {_mRevision_SubscriberContent=revision;}
    static qByte GetKnownMaxClassRevision_SubscriberContent() {return 0;}
    DDLTYPE(uint64)::CPPType contentId;
    NEX_CLASS_VALID_REVISION_DEF(contentId, 0);
    qBool NEX_CLASS_ISVALID(contentId) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType message;
    NEX_CLASS_VALID_REVISION_DEF(message, 0);
    qBool NEX_CLASS_ISVALID(message) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qBuffer)::CPPType binary;
    NEX_CLASS_VALID_REVISION_DEF(binary, 0);
    qBool NEX_CLASS_ISVALID(binary) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType pid;
    NEX_CLASS_VALID_REVISION_DEF(pid, 0);
    qBool NEX_CLASS_ISVALID(pid) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< DDLTYPE(string) >::CPPType topics;
    NEX_CLASS_VALID_REVISION_DEF(topics, 0);
    qBool NEX_CLASS_ISVALID(topics) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(datetime)::CPPType postTime;
    NEX_CLASS_VALID_REVISION_DEF(postTime, 0);
    qBool NEX_CLASS_ISVALID(postTime) const { return true; /* The revision is 0. Always true */}
};


class DDLTYPE(SubscriberContent): public DDLType {
public:
    typedef SubscriberContent CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(SubscriberContent)& oSubscriberContent) {
        DDLCLASS(SubscriberContent)::Add(pMessageToSend,oSubscriberContent);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(SubscriberContent)* pSubscriberContentToRefresh) {
        DDLCLASS(SubscriberContent)::Extract(pReceivedMessage,pSubscriberContentToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_SubscriberContentDDL.h_H_
