﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _UtilityClient_H__
#define _UtilityClient_H__

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Core/src/Client/ServiceClient.h>
#include <RendezVous/Services/Jugem/Utility/src/Common/UtilityDDF.h>
#include <RendezVous/Services/Jugem/Utility/src/Common/UtilityProtocolDDL.h>
#include <RendezVous/Services/Jugem/Utility/src/Common/UniqueId.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class UtilityClient : public ServiceClient
{
public:
    /* Please see man pages for details 
        
    */
    UtilityClient();

    /* Please see man pages for details 
        
    */
    virtual ~UtilityClient();

    /* Please see man pages for details 
        

        

        
    */
    virtual qBool Bind(Credentials* pCredentials);

    /* Please see man pages for details 
        

        
    */
    virtual qBool Unbind();

    void UpdateProtocolsDefaultCredentials(Credentials* pCredentials);

    /* Please see man pages for details 
        

                       
                       

        
        

        
    */
    qBool AcquireNexUniqueId(ProtocolCallContext* pContext, UniqueId* pNexUniqueId);

    /* Please see man pages for details 
        

                       
                       

        
        

        
    */
    qBool AcquireNexUniqueIdWithPassword(ProtocolCallContext* pContext, UniqueIdInfo* pUniqueIdInfo);

    /* Please see man pages for details 
        

        

        
    */
    static qBool IsValidNexUniqueId(UniqueId nexUniqueId);

    /* Please see man pages for details 
        

                       
                       

                       
                       

        
        

        
    */
    qBool AssociateNexUniqueIdWithMyPrincipalId(ProtocolCallContext* pContext, const UniqueIdInfo& uniqueIdInfo);

    /* Please see man pages for details 
        

                       
                       

                       
                       

        
        

        
    */
    qBool AssociateNexUniqueIdWithMyPrincipalId(ProtocolCallContext* pContext, const qVector<UniqueIdInfo>& uniqueIdInfo);

    /* Please see man pages for details 
        

        
        

        
    */
    qBool GetAssociatedNexUniqueIdWithMyPrincipalId(ProtocolCallContext* pContext, UniqueIdInfo* pUniqueIdInfo);

    /* Please see man pages for details 
        

        
        

        
    */
    qBool GetAssociatedNexUniqueIdWithMyPrincipalId(ProtocolCallContext* pContext, qVector<UniqueIdInfo>* pUniqueIdInfo);


private:
    // Registered flag
    qBool m_bProtocolRegistered;
    // Protocol object
    UtilityProtocolClient m_oProtocol;
};

END_NAMESPACE_NEX

#endif // _UtilityClient_H__
