﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _UNIQUEID_INFO_H_
#define _UNIQUEID_INFO_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "UniqueIdInfoDDL.h"
#include "UniqueId.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class UniqueIdInfo: public DDLCLASS(UniqueIdInfo)
{
public:
    /* Please see man pages for details 
        
    */
    UniqueIdInfo()
    {
        nexUniqueId = INVALID_UNIQUEID;
    }

    /* Please see man pages for details 
        
    */
    virtual ~UniqueIdInfo() {}

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetUniqueId() const
    {
        return nexUniqueId;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetPassword() const
    {
        return nexUniqueIdPassword;
    }

    /* Please see man pages for details 
        

        

        
    */
    qBool IsValid() const
    {
        return nexUniqueId != INVALID_UNIQUEID;
    }

    qBool operator==(const UniqueIdInfo& rhs) const
    {
        return nexUniqueId == rhs.nexUniqueId
               && nexUniqueIdPassword == rhs.nexUniqueIdPassword;
    }
    qBool operator!=(const UniqueIdInfo& rhs) const
    {
        return !(*this == rhs);
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, _T("UniqueIdInfo: (")
               << _T("nexUniqueId=") << hex << nexUniqueId
               << _T(", nexUniqueIdPassword=") << nexUniqueIdPassword
               << _T(")")
              );
    }
};

END_NAMESPACE_NEX

#endif
