#ifndef _Quazal_UtilityProtocolDDL_H_
#define _Quazal_UtilityProtocolDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "UniqueIdInfo.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(UtilityProtocol, AcquireNexUniqueId, 1 );
PROTO_DEFINE_RMCID(UtilityProtocol, AcquireNexUniqueIdWithPassword, 2 );
PROTO_DEFINE_RMCID(UtilityProtocol, AssociateNexUniqueIdWithMyPrincipalId, 3 );
PROTO_DEFINE_RMCID(UtilityProtocol, AssociateNexUniqueIdsWithMyPrincipalId, 4 );
PROTO_DEFINE_RMCID(UtilityProtocol, GetAssociatedNexUniqueIdWithMyPrincipalId, 5 );
PROTO_DEFINE_RMCID(UtilityProtocol, GetAssociatedNexUniqueIdsWithMyPrincipalId, 6 );
PROTO_DEFINE_NUM_RMC(UtilityProtocol, 6);

class UtilityProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(uint64) TAcquireNexUniqueId_pNexUniqueId;
        PROTO_RMCIMPL_RETURN(UtilityProtocol, AcquireNexUniqueId)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TAcquireNexUniqueId_pNexUniqueId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(UniqueIdInfo) TAcquireNexUniqueIdWithPassword_pNexUniqueIdInfo;
        PROTO_RMCIMPL_RETURN(UtilityProtocol, AcquireNexUniqueIdWithPassword)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TAcquireNexUniqueIdWithPassword_pNexUniqueIdInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(UniqueIdInfo) TAssociateNexUniqueIdWithMyPrincipalId_uniqueIdInfo;
        PROTO_RMCIMPL_RETURN(UtilityProtocol, AssociateNexUniqueIdWithMyPrincipalId)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(UniqueIdInfo) > TAssociateNexUniqueIdsWithMyPrincipalId_uniqueIdInfo;
        PROTO_RMCIMPL_RETURN(UtilityProtocol, AssociateNexUniqueIdsWithMyPrincipalId)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(UniqueIdInfo) TGetAssociatedNexUniqueIdWithMyPrincipalId_pUniqueIdInfo;
        PROTO_RMCIMPL_RETURN(UtilityProtocol, GetAssociatedNexUniqueIdWithMyPrincipalId)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetAssociatedNexUniqueIdWithMyPrincipalId_pUniqueIdInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(UniqueIdInfo) > TGetAssociatedNexUniqueIdsWithMyPrincipalId_pUniqueIdInfo;
        PROTO_RMCIMPL_RETURN(UtilityProtocol, GetAssociatedNexUniqueIdsWithMyPrincipalId)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetAssociatedNexUniqueIdsWithMyPrincipalId_pUniqueIdInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        UtilityProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew UtilityProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallAcquireNexUniqueId(ProtocolCallContext *pContext, DDLTYPE(uint64)::CPPType* pNexUniqueId);
        static qBool AcquireNexUniqueId_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint64)::CPPType* pNexUniqueId);
        qBool CallAcquireNexUniqueIdWithPassword(ProtocolCallContext *pContext, UniqueIdInfo* pNexUniqueIdInfo);
        static qBool AcquireNexUniqueIdWithPassword_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, UniqueIdInfo* pNexUniqueIdInfo);
        qBool CallAssociateNexUniqueIdWithMyPrincipalId(ProtocolCallContext *pContext, const UniqueIdInfo& uniqueIdInfo);
        static qBool AssociateNexUniqueIdWithMyPrincipalId_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const UniqueIdInfo& uniqueIdInfo);
        qBool CallAssociateNexUniqueIdsWithMyPrincipalId(ProtocolCallContext *pContext, const DDLTYPE(qvector)< CLASSMETATYPE(UniqueIdInfo) >::CPPType& uniqueIdInfo);
        static qBool AssociateNexUniqueIdsWithMyPrincipalId_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< CLASSMETATYPE(UniqueIdInfo) >::CPPType& uniqueIdInfo);
        qBool CallGetAssociatedNexUniqueIdWithMyPrincipalId(ProtocolCallContext *pContext, UniqueIdInfo* pUniqueIdInfo);
        static qBool GetAssociatedNexUniqueIdWithMyPrincipalId_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, UniqueIdInfo* pUniqueIdInfo);
        qBool CallGetAssociatedNexUniqueIdsWithMyPrincipalId(ProtocolCallContext *pContext, DDLTYPE(qvector)< CLASSMETATYPE(UniqueIdInfo) >::CPPType* pUniqueIdInfo);
        static qBool GetAssociatedNexUniqueIdsWithMyPrincipalId_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qvector)< CLASSMETATYPE(UniqueIdInfo) >::CPPType* pUniqueIdInfo);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(UtilityProtocol) + 1];
};

class DDLPROTOCOL(UtilityProtocolServer) : public ServerProtocol {
    public:
        typedef DDLTYPE(uint64) TAcquireNexUniqueId_pNexUniqueId;
        PROTO_RMCIMPL_STUB(UtilityProtocol, AcquireNexUniqueId)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint64)::CPPType pNexUniqueId;
            pProtocol->AcquireNexUniqueId( &pNexUniqueId );
            PROTO_PREPARE_RETURN(UtilityProtocol,AcquireNexUniqueId);
            _MSG_ADD_VARIABLE(TAcquireNexUniqueId_pNexUniqueId, pNexUniqueId);
        }
        
        typedef CLASSMETATYPE(UniqueIdInfo) TAcquireNexUniqueIdWithPassword_pNexUniqueIdInfo;
        PROTO_RMCIMPL_STUB(UtilityProtocol, AcquireNexUniqueIdWithPassword)
        {
            PROTO_PREPARE_EXTRACTION();
            UniqueIdInfo pNexUniqueIdInfo;
            pProtocol->AcquireNexUniqueIdWithPassword( &pNexUniqueIdInfo );
            PROTO_PREPARE_RETURN(UtilityProtocol,AcquireNexUniqueIdWithPassword);
            _MSG_ADD_VARIABLE(TAcquireNexUniqueIdWithPassword_pNexUniqueIdInfo, pNexUniqueIdInfo);
        }
        
        typedef CLASSMETATYPE(UniqueIdInfo) TAssociateNexUniqueIdWithMyPrincipalId_uniqueIdInfo;
        PROTO_RMCIMPL_STUB(UtilityProtocol, AssociateNexUniqueIdWithMyPrincipalId)
        {
            PROTO_PREPARE_EXTRACTION();
            UniqueIdInfo uniqueIdInfo;
            _MSG_EXTRACT_VARIABLE(TAssociateNexUniqueIdWithMyPrincipalId_uniqueIdInfo, uniqueIdInfo);
            pProtocol->AssociateNexUniqueIdWithMyPrincipalId( uniqueIdInfo );
            PROTO_PREPARE_RETURN(UtilityProtocol,AssociateNexUniqueIdWithMyPrincipalId);
        }
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(UniqueIdInfo) > TAssociateNexUniqueIdsWithMyPrincipalId_uniqueIdInfo;
        PROTO_RMCIMPL_STUB(UtilityProtocol, AssociateNexUniqueIdsWithMyPrincipalId)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< CLASSMETATYPE(UniqueIdInfo) >::CPPType uniqueIdInfo;
            _MSG_EXTRACT_VARIABLE(TAssociateNexUniqueIdsWithMyPrincipalId_uniqueIdInfo, uniqueIdInfo);
            pProtocol->AssociateNexUniqueIdsWithMyPrincipalId( uniqueIdInfo );
            PROTO_PREPARE_RETURN(UtilityProtocol,AssociateNexUniqueIdsWithMyPrincipalId);
        }
        
        typedef CLASSMETATYPE(UniqueIdInfo) TGetAssociatedNexUniqueIdWithMyPrincipalId_pUniqueIdInfo;
        PROTO_RMCIMPL_STUB(UtilityProtocol, GetAssociatedNexUniqueIdWithMyPrincipalId)
        {
            PROTO_PREPARE_EXTRACTION();
            UniqueIdInfo pUniqueIdInfo;
            pProtocol->GetAssociatedNexUniqueIdWithMyPrincipalId( &pUniqueIdInfo );
            PROTO_PREPARE_RETURN(UtilityProtocol,GetAssociatedNexUniqueIdWithMyPrincipalId);
            _MSG_ADD_VARIABLE(TGetAssociatedNexUniqueIdWithMyPrincipalId_pUniqueIdInfo, pUniqueIdInfo);
        }
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(UniqueIdInfo) > TGetAssociatedNexUniqueIdsWithMyPrincipalId_pUniqueIdInfo;
        PROTO_RMCIMPL_STUB(UtilityProtocol, GetAssociatedNexUniqueIdsWithMyPrincipalId)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< CLASSMETATYPE(UniqueIdInfo) >::CPPType pUniqueIdInfo;
            pProtocol->GetAssociatedNexUniqueIdsWithMyPrincipalId( &pUniqueIdInfo );
            PROTO_PREPARE_RETURN(UtilityProtocol,GetAssociatedNexUniqueIdsWithMyPrincipalId);
            _MSG_ADD_VARIABLE(TGetAssociatedNexUniqueIdsWithMyPrincipalId_pUniqueIdInfo, pUniqueIdInfo);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void AcquireNexUniqueId(DDLTYPE(uint64)::CPPType* pNexUniqueId) = 0;
        virtual void AcquireNexUniqueIdWithPassword(UniqueIdInfo* pNexUniqueIdInfo) = 0;
        virtual void AssociateNexUniqueIdWithMyPrincipalId(const UniqueIdInfo& uniqueIdInfo) = 0;
        virtual void AssociateNexUniqueIdsWithMyPrincipalId(const DDLTYPE(qvector)< CLASSMETATYPE(UniqueIdInfo) >::CPPType& uniqueIdInfo) = 0;
        virtual void GetAssociatedNexUniqueIdWithMyPrincipalId(UniqueIdInfo* pUniqueIdInfo) = 0;
        virtual void GetAssociatedNexUniqueIdsWithMyPrincipalId(DDLTYPE(qvector)< CLASSMETATYPE(UniqueIdInfo) >::CPPType* pUniqueIdInfo) = 0;
    };


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_UtilityProtocolDDL.h_H_
