#ifndef _Quazal_DynamicGatheringDDL_H_
#define _Quazal_DynamicGatheringDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "MatchMakingServiceProperties.h"
#include "Gathering.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX
class DynamicGathering;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(DynamicGathering): public Gathering {
public:
    DDLCLASS(DynamicGathering)():_mRevision_DynamicGathering(0)
     {};
    DDLCLASS(DynamicGathering)(const DDLCLASS(DynamicGathering) &oOther):
        Gathering(oOther),
        _mRevision_DynamicGathering(oOther._mRevision_DynamicGathering),
        m_bufTail(oOther.m_bufTail)
    {
    }
    virtual ~DDLCLASS(DynamicGathering)() {};
    const DDLCLASS(DynamicGathering) &operator=(const DDLCLASS(DynamicGathering) &oOther);
    qBool operator==(const DDLCLASS(DynamicGathering) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(DynamicGathering) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(DynamicGathering) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(DynamicGathering) *pValue);
    qByte _mRevision_DynamicGathering;
    qByte GetClassRevision_DynamicGathering() const {return _mRevision_DynamicGathering;}
    void SetClassRevision_DynamicGathering(qByte revision) {_mRevision_DynamicGathering=revision;}
    static qByte GetKnownMaxClassRevision_DynamicGathering() {return 0;}
    DDLTYPE(buffertail)::CPPType m_bufTail;
    NEX_CLASS_VALID_REVISION_DEF(m_bufTail, 0);
    qBool NEX_CLASS_ISVALID(m_bufTail) const { return true; /* The revision is 0. Always true */}
    public:
	_PR_gathering_methods_pudecl()
    protected:
	_PR_gathering_methods_prdecl()
};


class DDLTYPE(DynamicGathering): public DDLType {
public:
    typedef DynamicGathering CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(DynamicGathering)& oDynamicGathering) {
        DDLCLASS(DynamicGathering)::Add(pMessageToSend,oDynamicGathering);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(DynamicGathering)* pDynamicGatheringToRefresh) {
        DDLCLASS(DynamicGathering)::Extract(pReceivedMessage,pDynamicGatheringToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_DynamicGatheringDDL.h_H_
