#ifndef _Quazal_InvitationDDL_H_
#define _Quazal_InvitationDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX
class Invitation;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(Invitation): public RootObject {
public:
    DDLCLASS(Invitation)():_mRevision_Invitation(0)
     {};
    DDLCLASS(Invitation)(const DDLCLASS(Invitation) &oOther):
        RootObject(oOther),
        _mRevision_Invitation(oOther._mRevision_Invitation),
        m_idGathering(oOther.m_idGathering),
        m_idGuest(oOther.m_idGuest),
        m_strMessage(oOther.m_strMessage)
    {
    }
    virtual ~DDLCLASS(Invitation)() {};
    const DDLCLASS(Invitation) &operator=(const DDLCLASS(Invitation) &oOther);
    qBool operator==(const DDLCLASS(Invitation) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(Invitation) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(Invitation) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(Invitation) *pValue);
    qByte _mRevision_Invitation;
    qByte GetClassRevision_Invitation() const {return _mRevision_Invitation;}
    void SetClassRevision_Invitation(qByte revision) {_mRevision_Invitation=revision;}
    static qByte GetKnownMaxClassRevision_Invitation() {return 0;}
    DDLTYPE(uint32)::CPPType m_idGathering;
    NEX_CLASS_VALID_REVISION_DEF(m_idGathering, 0);
    qBool NEX_CLASS_ISVALID(m_idGathering) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_idGuest;
    NEX_CLASS_VALID_REVISION_DEF(m_idGuest, 0);
    qBool NEX_CLASS_ISVALID(m_idGuest) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType m_strMessage;
    NEX_CLASS_VALID_REVISION_DEF(m_strMessage, 0);
    qBool NEX_CLASS_ISVALID(m_strMessage) const { return true; /* The revision is 0. Always true */}
    public:
    protected:
};


class DDLTYPE(Invitation): public DDLType {
public:
    typedef Invitation CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(Invitation)& oInvitation) {
        DDLCLASS(Invitation)::Add(pMessageToSend,oInvitation);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(Invitation)* pInvitationToRefresh) {
        DDLCLASS(Invitation)::Extract(pReceivedMessage,pInvitationToRefresh);
    }
};

class Invitation: public DDLCLASS(Invitation) {
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_InvitationDDL.h_H_
