#ifndef _Quazal_MessagingProtocolDDL_H_
#define _Quazal_MessagingProtocolDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "RendezVous/Core/src/Common/ProtocolFoundationTypes.h"
#include "RendezVous/Core/src/Common/Data.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "OnlineCore/src/DDLTypes/STLExtTypes.h"
#include "RendezVous/Core/src/Common/MessageRecipient.h"
#include "RendezVous/Core/src/Common/ResultRange.h"
#include "RendezVous/Core/src/Common/UserMessage.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(MessagingProtocol, DeliverMessage, 1 );
PROTO_DEFINE_RMCID(MessagingProtocol, GetNumberOfMessages, 2 );
PROTO_DEFINE_RMCID(MessagingProtocol, GetMessagesHeaders, 3 );
PROTO_DEFINE_RMCID(MessagingProtocol, RetrieveAllMessagesWithinRange, 4 );
PROTO_DEFINE_RMCID(MessagingProtocol, RetrieveMessages, 5 );
PROTO_DEFINE_RMCID(MessagingProtocol, DeleteMessages, 6 );
PROTO_DEFINE_RMCID(MessagingProtocol, DeleteAllMessages, 7 );
PROTO_DEFINE_NUM_RMC(MessagingProtocol, 7);

class MessagingProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TDeliverMessage_oUserMessage;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TDeliverMessage_oModifiedMessage;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TDeliverMessage_lstSandboxNodeId;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TDeliverMessage_lstParticipants;
        PROTO_RMCIMPL_RETURN(MessagingProtocol, DeliverMessage)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TDeliverMessage_oModifiedMessage,1);
            _DO_RMC_ExtractReturnValue(TDeliverMessage_lstSandboxNodeId,1);
            _DO_RMC_ExtractReturnValue(TDeliverMessage_lstParticipants,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MessageRecipient) TGetNumberOfMessages_recipient;
        typedef DDLTYPE(uint32) TGetNumberOfMessages_uiNbMessages;
        PROTO_RMCIMPL_RETURN(MessagingProtocol, GetNumberOfMessages)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetNumberOfMessages_uiNbMessages,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MessageRecipient) TGetMessagesHeaders_recipient;
        typedef CLASSMETATYPE(ResultRange) TGetMessagesHeaders_range;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(UserMessage) > TGetMessagesHeaders_lstMsgHeaders;
        PROTO_RMCIMPL_RETURN(MessagingProtocol, GetMessagesHeaders)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetMessagesHeaders_lstMsgHeaders,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MessageRecipient) TRetrieveAllMessagesWithinRange_recipient;
        typedef CLASSMETATYPE(ResultRange) TRetrieveAllMessagesWithinRange_range;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > > TRetrieveAllMessagesWithinRange_lstMessages;
        PROTO_RMCIMPL_RETURN(MessagingProtocol, RetrieveAllMessagesWithinRange)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRetrieveAllMessagesWithinRange_lstMessages,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MessageRecipient) TRetrieveMessages_recipient;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TRetrieveMessages_lstMsgIDs;
        typedef DDLTYPE(bool) TRetrieveMessages_bLeaveOnServer;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > > TRetrieveMessages_lstMessages;
        PROTO_RMCIMPL_RETURN(MessagingProtocol, RetrieveMessages)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRetrieveMessages_lstMessages,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MessageRecipient) TDeleteMessages_recipient;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TDeleteMessages_lstMessagesToDelete;
        PROTO_RMCIMPL_RETURN(MessagingProtocol, DeleteMessages)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(MessageRecipient) TDeleteAllMessages_recipient;
        typedef DDLTYPE(uint32) TDeleteAllMessages_uiNbDeletedMessages;
        PROTO_RMCIMPL_RETURN(MessagingProtocol, DeleteAllMessages)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TDeleteAllMessages_uiNbDeletedMessages,1);
            PROTO_RETURNSTUB_END();
        };
        
        MessagingProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew MessagingProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallDeliverMessage(ProtocolCallContext *pContext, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oUserMessage, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oModifiedMessage, DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType* lstSandboxNodeId, DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType* lstParticipants);
        static qBool DeliverMessage_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oUserMessage, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oModifiedMessage, DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType* lstSandboxNodeId, DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType* lstParticipants);
        qBool CallGetNumberOfMessages(ProtocolCallContext *pContext, const MessageRecipient& recipient, DDLTYPE(uint32)::CPPType* uiNbMessages);
        static qBool GetNumberOfMessages_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MessageRecipient& recipient, DDLTYPE(uint32)::CPPType* uiNbMessages);
        qBool CallGetMessagesHeaders(ProtocolCallContext *pContext, const MessageRecipient& recipient, const ResultRange& range, DDLTYPE(std_list)< CLASSMETATYPE(UserMessage) >::CPPType* lstMsgHeaders);
        static qBool GetMessagesHeaders_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MessageRecipient& recipient, const ResultRange& range, DDLTYPE(std_list)< CLASSMETATYPE(UserMessage) >::CPPType* lstMsgHeaders);
        qBool CallRetrieveAllMessagesWithinRange(ProtocolCallContext *pContext, const MessageRecipient& recipient, const ResultRange& range, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > >::CPPType* lstMessages);
        static qBool RetrieveAllMessagesWithinRange_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MessageRecipient& recipient, const ResultRange& range, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > >::CPPType* lstMessages);
        qBool CallRetrieveMessages(ProtocolCallContext *pContext, const MessageRecipient& recipient, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstMsgIDs, const DDLTYPE(bool)::CPPType& bLeaveOnServer, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > >::CPPType* lstMessages);
        static qBool RetrieveMessages_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MessageRecipient& recipient, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstMsgIDs, const DDLTYPE(bool)::CPPType& bLeaveOnServer, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > >::CPPType* lstMessages);
        qBool CallDeleteMessages(ProtocolCallContext *pContext, const MessageRecipient& recipient, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstMessagesToDelete);
        static qBool DeleteMessages_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MessageRecipient& recipient, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstMessagesToDelete);
        qBool CallDeleteAllMessages(ProtocolCallContext *pContext, const MessageRecipient& recipient, DDLTYPE(uint32)::CPPType* uiNbDeletedMessages);
        static qBool DeleteAllMessages_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const MessageRecipient& recipient, DDLTYPE(uint32)::CPPType* uiNbDeletedMessages);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(MessagingProtocol) + 1];
};

class DDLPROTOCOL(MessagingProtocolServer) : public ServerProtocol {
    public:
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TDeliverMessage_oUserMessage;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TDeliverMessage_oModifiedMessage;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TDeliverMessage_lstSandboxNodeId;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TDeliverMessage_lstParticipants;
        PROTO_RMCIMPL_STUB(MessagingProtocol, DeliverMessage)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oUserMessage;
            _MSG_EXTRACT_VARIABLE(TDeliverMessage_oUserMessage, oUserMessage);
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oModifiedMessage;
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstSandboxNodeId;
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstParticipants;
            pProtocol->DeliverMessage( oUserMessage, &oModifiedMessage, &lstSandboxNodeId, &lstParticipants );
            PROTO_PREPARE_RETURN(MessagingProtocol,DeliverMessage);
            _MSG_ADD_VARIABLE(TDeliverMessage_oModifiedMessage, oModifiedMessage);
            _MSG_ADD_VARIABLE(TDeliverMessage_lstSandboxNodeId, lstSandboxNodeId);
            _MSG_ADD_VARIABLE(TDeliverMessage_lstParticipants, lstParticipants);
        }
        
        typedef CLASSMETATYPE(MessageRecipient) TGetNumberOfMessages_recipient;
        typedef DDLTYPE(uint32) TGetNumberOfMessages_uiNbMessages;
        PROTO_RMCIMPL_STUB(MessagingProtocol, GetNumberOfMessages)
        {
            PROTO_PREPARE_EXTRACTION();
            MessageRecipient recipient;
            _MSG_EXTRACT_VARIABLE(TGetNumberOfMessages_recipient, recipient);
            DDLTYPE(uint32)::CPPType uiNbMessages;
            pProtocol->GetNumberOfMessages( recipient, &uiNbMessages );
            PROTO_PREPARE_RETURN(MessagingProtocol,GetNumberOfMessages);
            _MSG_ADD_VARIABLE(TGetNumberOfMessages_uiNbMessages, uiNbMessages);
        }
        
        typedef CLASSMETATYPE(MessageRecipient) TGetMessagesHeaders_recipient;
        typedef CLASSMETATYPE(ResultRange) TGetMessagesHeaders_range;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(UserMessage) > TGetMessagesHeaders_lstMsgHeaders;
        PROTO_RMCIMPL_STUB(MessagingProtocol, GetMessagesHeaders)
        {
            PROTO_PREPARE_EXTRACTION();
            MessageRecipient recipient;
            _MSG_EXTRACT_VARIABLE(TGetMessagesHeaders_recipient, recipient);
            ResultRange range;
            _MSG_EXTRACT_VARIABLE(TGetMessagesHeaders_range, range);
            DDLTYPE(std_list)< CLASSMETATYPE(UserMessage) >::CPPType lstMsgHeaders;
            pProtocol->GetMessagesHeaders( recipient, range, &lstMsgHeaders );
            PROTO_PREPARE_RETURN(MessagingProtocol,GetMessagesHeaders);
            _MSG_ADD_VARIABLE(TGetMessagesHeaders_lstMsgHeaders, lstMsgHeaders);
        }
        
        typedef CLASSMETATYPE(MessageRecipient) TRetrieveAllMessagesWithinRange_recipient;
        typedef CLASSMETATYPE(ResultRange) TRetrieveAllMessagesWithinRange_range;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > > TRetrieveAllMessagesWithinRange_lstMessages;
        PROTO_RMCIMPL_STUB(MessagingProtocol, RetrieveAllMessagesWithinRange)
        {
            PROTO_PREPARE_EXTRACTION();
            MessageRecipient recipient;
            _MSG_EXTRACT_VARIABLE(TRetrieveAllMessagesWithinRange_recipient, recipient);
            ResultRange range;
            _MSG_EXTRACT_VARIABLE(TRetrieveAllMessagesWithinRange_range, range);
            DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > >::CPPType lstMessages;
            pProtocol->RetrieveAllMessagesWithinRange( recipient, range, &lstMessages );
            PROTO_PREPARE_RETURN(MessagingProtocol,RetrieveAllMessagesWithinRange);
            _MSG_ADD_VARIABLE(TRetrieveAllMessagesWithinRange_lstMessages, lstMessages);
        }
        
        typedef CLASSMETATYPE(MessageRecipient) TRetrieveMessages_recipient;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TRetrieveMessages_lstMsgIDs;
        typedef DDLTYPE(bool) TRetrieveMessages_bLeaveOnServer;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > > TRetrieveMessages_lstMessages;
        PROTO_RMCIMPL_STUB(MessagingProtocol, RetrieveMessages)
        {
            PROTO_PREPARE_EXTRACTION();
            MessageRecipient recipient;
            _MSG_EXTRACT_VARIABLE(TRetrieveMessages_recipient, recipient);
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstMsgIDs;
            _MSG_EXTRACT_VARIABLE(TRetrieveMessages_lstMsgIDs, lstMsgIDs);
            DDLTYPE(bool)::CPPType bLeaveOnServer;
            _MSG_EXTRACT_VARIABLE(TRetrieveMessages_bLeaveOnServer, bLeaveOnServer);
            DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > >::CPPType lstMessages;
            pProtocol->RetrieveMessages( recipient, lstMsgIDs, bLeaveOnServer, &lstMessages );
            PROTO_PREPARE_RETURN(MessagingProtocol,RetrieveMessages);
            _MSG_ADD_VARIABLE(TRetrieveMessages_lstMessages, lstMessages);
        }
        
        typedef CLASSMETATYPE(MessageRecipient) TDeleteMessages_recipient;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TDeleteMessages_lstMessagesToDelete;
        PROTO_RMCIMPL_STUB(MessagingProtocol, DeleteMessages)
        {
            PROTO_PREPARE_EXTRACTION();
            MessageRecipient recipient;
            _MSG_EXTRACT_VARIABLE(TDeleteMessages_recipient, recipient);
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstMessagesToDelete;
            _MSG_EXTRACT_VARIABLE(TDeleteMessages_lstMessagesToDelete, lstMessagesToDelete);
            pProtocol->DeleteMessages( recipient, lstMessagesToDelete );
            PROTO_PREPARE_RETURN(MessagingProtocol,DeleteMessages);
        }
        
        typedef CLASSMETATYPE(MessageRecipient) TDeleteAllMessages_recipient;
        typedef DDLTYPE(uint32) TDeleteAllMessages_uiNbDeletedMessages;
        PROTO_RMCIMPL_STUB(MessagingProtocol, DeleteAllMessages)
        {
            PROTO_PREPARE_EXTRACTION();
            MessageRecipient recipient;
            _MSG_EXTRACT_VARIABLE(TDeleteAllMessages_recipient, recipient);
            DDLTYPE(uint32)::CPPType uiNbDeletedMessages;
            pProtocol->DeleteAllMessages( recipient, &uiNbDeletedMessages );
            PROTO_PREPARE_RETURN(MessagingProtocol,DeleteAllMessages);
            _MSG_ADD_VARIABLE(TDeleteAllMessages_uiNbDeletedMessages, uiNbDeletedMessages);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void DeliverMessage(const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oUserMessage, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oModifiedMessage, DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType* lstSandboxNodeId, DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType* lstParticipants) = 0;
        virtual void GetNumberOfMessages(const MessageRecipient& recipient, DDLTYPE(uint32)::CPPType* uiNbMessages) = 0;
        virtual void GetMessagesHeaders(const MessageRecipient& recipient, const ResultRange& range, DDLTYPE(std_list)< CLASSMETATYPE(UserMessage) >::CPPType* lstMsgHeaders) = 0;
        virtual void RetrieveAllMessagesWithinRange(const MessageRecipient& recipient, const ResultRange& range, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > >::CPPType* lstMessages) = 0;
        virtual void RetrieveMessages(const MessageRecipient& recipient, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstMsgIDs, const DDLTYPE(bool)::CPPType& bLeaveOnServer, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > >::CPPType* lstMessages) = 0;
        virtual void DeleteMessages(const MessageRecipient& recipient, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstMessagesToDelete) = 0;
        virtual void DeleteAllMessages(const MessageRecipient& recipient, DDLTYPE(uint32)::CPPType* uiNbDeletedMessages) = 0;
    };


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_MessagingProtocolDDL.h_H_
