﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _TextMessage_H
#define _TextMessage_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/String.h>
#include <RendezVous/Services/Messaging/src/Common/TextMessageDDL.h>

BEGIN_NAMESPACE_NEX

// Group=Messaging Service

#ifdef FOR_DOC_PURPOSE
/*
Description: Construct a message containing essentially a text body.
See Also: Messaging Service
*/
/* Please see man pages for details 
 

 
 */
class TextMessage: public UserMessage
{

#else
class TextMessage: public DDLCLASS(TextMessage)
{

#endif

public:

    /*
     Description: Default constructor.
     */
    /* Please see man pages for details 
     

     
     */
    TextMessage()
    {
    }

    /*
     Description: Assignment constructor.
     Parameters:
     strTextBody: Text body to attach to message.
     */
    /* Please see man pages for details 
     

     

     
     */
    TextMessage(const String& strTextBody)
    {
        m_strTextBody = strTextBody;
    }

    /*
     Description: Accessor to set text body.
     Parameters:
     strTextBody: Text body to attach to message.
     */
    /* Please see man pages for details 
     
            
            

     
     */
    void SetTextBody(const String& strTextBody)
    {
        m_strTextBody = strTextBody;
    }

    /*
     Description: Accessor to get text body.
     Returns: Message text body
     */
    /* Please see man pages for details 
     

     
     */
    const String& GetTextBody() const
    {
        return m_strTextBody;
    }

    /*
     For debug
     */
    virtual void Trace(qUnsignedInt64 traceFlag)
    {
        UserMessage::Trace(traceFlag);
        QTRACE(traceFlag, _T("TextMessage:") << this)
        QTRACE(traceFlag, _T("  TextBody:") << GetTextBody());
    }
};


END_NAMESPACE_NEX

#endif
